package com.kuxuan.autoclick.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.kuxuan.autoclick.R;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * @author lkj
 * @date 2024/1/24 14:24
 * @desc 文字
 */
public class TextAdapter extends RecyclerView.Adapter<TextAdapter.MYViewHolder> {

    private Context context;
    private List<String> strings;

    public TextAdapter(Context context, List<String> strings) {
        this.context = context;
        this.strings = strings;
    }

    public void addList(List<String> strings) {
        this.strings = strings;
        notifyDataSetChanged();
    }

    @NonNull
    @Override
    public MYViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(context).inflate(R.layout.adapter_text, parent, false);
        MYViewHolder holder = new MYViewHolder(view);
        return holder;
    }

    @Override
    public void onBindViewHolder(@NonNull MYViewHolder holder, int position) {
        holder.textString.setText(strings.get(position));
    }

    @Override
    public int getItemCount() {
        return strings.size();
    }

    class MYViewHolder extends RecyclerView.ViewHolder {
        @BindView(R.id.text_string)
        TextView textString;

        public MYViewHolder(@NonNull View itemView) {
            super(itemView);
            ButterKnife.bind(this, itemView);
        }
    }
}
