package com.kuxuan.autoclick.app;

import android.app.Application;
import android.content.Context;
import android.content.pm.ApplicationInfo;
import android.util.AndroidRuntimeException;

import com.kuxuan.autoclick.app_status.AppStatusConstant;
import com.kuxuan.autoclick.app_status.AppStatusManager;
import com.kuxuan.autoclick.utils.get_expection.MyCrashHandler;
import com.kuxuan.autoclick.utils.LogUtil;

/**
 * @Auth lkj
 * @Date 2023/5/26 14:00
 * @Describe
 */
public class Mapp extends Application {
    public static Context context;

    @Override
    public void onCreate() {
        super.onCreate();
        /**
         * @auth lkj
         * @Date 2023/6/9 10:41
         * @Describe 异常捕获
         */
        context = getApplicationContext();
        MyCrashHandler.getInstance().init(this);
        LogUtil.getInstance().init(this);
        AppStatusManager.init(this);
        LogUtil.e("APP启动");
//        LogUtil.setDebuggable(isApkInDebug(this));
    }

    /**
     * @auth lkj
     * @Date 2023/6/16 11:30
     * @Describe 判断当前应用是否是debug状态
     */
    private boolean isApkInDebug(Context context) {
        try {
            ApplicationInfo info = context.getApplicationInfo();
            return (info.flags & ApplicationInfo.FLAG_DEBUGGABLE) != 0;
        } catch (Exception e) {
            return false;
        }
    }

    /**
     * @Author: lkj
     * @Date: 2023/7/12 15:45
     * @Desc: 程序终止时会调用
     */
    @Override
    public void onTerminate() {
        super.onTerminate();
    }
}
