package com.kuxuan.autoclick.net;

import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.MainBean;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.groupsend.RequestMessageBean;
import com.kuxuan.autoclick.net.callback.ResultCallBack;
import com.kuxuan.autoclick.net.request.AccessPresenter;
import com.kuxuan.autoclick.service.SelectMethod;
import com.kuxuan.autoclick.service.WeworkController;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.StringSort;
import com.kuxuan.autoclick.utils.StringUtils;
import com.kuxuan.autoclick.utils.SystemUtils;
import com.kuxuan.autoclick.utils.get_expection.MyCrashHandler;

import org.greenrobot.eventbus.EventBus;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * @author lkj
 * @date 2024/4/28 10:20
 * @desc 朋友圈群发 执行请求网络
 */
public class FriendCircleNet {
    private static FriendCircleNet friendCircleNet;

    public static FriendCircleNet getInstance() {
        if (friendCircleNet == null) {
            synchronized (FriendCircleNet.class) {
                if (friendCircleNet == null) {
                    friendCircleNet = new FriendCircleNet();
                }
            }
        }
        return friendCircleNet;
    }

    /**
     * @param taskBean
     * @auth lkj
     * @Date 2023/6/19 10:15
     * @Describe 执行群发朋友圈的流程
     */
    public void friendSendMethod(TaskBean taskBean) {
        try {
            LogUtil.e("朋友圈定时器执行任务 " + Constant.sendGroupIsRuning + "  " + Constant.addGroupIsRuning + "  " + Constant.friendSendIsRuning + "  " + Constant.isShareToColleague + "  " + Constant.isAddShareClient + "  " + Constant.isLeaderCreateGroup + "  " + Constant.isOutGroupCustomReturn + "  " + Constant.isRealTimeAddGroup);
            if (!Constant.sendGroupIsRuning && !Constant.addGroupIsRuning && !Constant.friendSendIsRuning && !Constant.isShareToColleague && !Constant.isAddShareClient && !Constant.isLeaderCreateGroup && !Constant.isOutGroupCustomReturn && !Constant.isRealTimeAddGroup) {
                Constant.listIndex = 0;
                LogUtil.e("发起请求任务呀  系统信息：" + android.os.Build.FINGERPRINT);
                String deviceid = SystemUtils.getDeviceId(WeworkController.mainActivity);
                Map<String, Object> map = new HashMap<>();
                map.put("device_id", deviceid);
                String sortKey = StringSort.sortKey(map);
                Set<String> set = new HashSet<String>(Arrays.asList(Constant.testDevicesIds));
                AccessPresenter.getInstance().friendSender(deviceid, sortKey, new ResultCallBack<RequestMessageBean>() {
                    @Override
                    public void success(RequestMessageBean messageBean) {
                        if (set.contains(deviceid)) {
                            LogUtil.e("这是测试手机的设备id");
                        } else {
                            LogUtil.e("这是正式手机的设备id");
                        }
                        /**
                         * @auth lkj
                         * @Date 2023/6/5 10:45
                         * @Describe 朋友圈请求返回数据
                         */
                        Constant.friendSendIsRuning = true;
                        StringUtils.setMessageData("正在执行朋友圈群发……", 10, 0);
                        EventBus.getDefault().post(new MainBean(true));
//                        RequestMessageBean messageBean = new Gson().fromJson(result, RequestMessageBean.class);
                        if (messageBean.getErr().equals("成功")) {
                            RequestMessageBean.RstBean rst = messageBean.getRst();
                            if (rst.getList() != null && rst.getList().size() > 0) {
                                WeworkController.weworkService.companyBeans = rst.getList();
                                WeworkController.weworkService.canUserCompanyNameList.clear();
                                /**
                                 * @auth lkj
                                 * @Date 2023/6/1 14:11
                                 * @Describe 这里暂时注释 正式使用需打开
                                 * 2023/6/6 17:44 lkj 已打开
                                 */
                                LogUtil.e("得到朋友圈数据 开始执行任务");
                                WeworkController.weworkService.startOtherTask(true, taskBean);
                            } else {
                                Constant.friendSendIsRuning = false;
                                WeworkController.weworkService.runStop();
                                LogUtil.e("朋友圈执行 设置为false");
                                SelectMethod.getInstance().selectMethod4(taskBean);
                            }
                        } else {
                            Constant.friendSendIsRuning = false;
                            WeworkController.weworkService.runStop();
                            LogUtil.e("朋友圈执行 设置为false");
                            SelectMethod.getInstance().selectMethod4(taskBean);
                        }
                    }

                    @Override
                    public void fail(String error) {
                        Constant.friendSendIsRuning = false;
                        WeworkController.weworkService.runStop();
                    }

                    @Override
                    public void requestComplete() {

                    }
                });
            }
        } catch (Exception e) {
            Constant.friendSendIsRuning = false;
            WeworkController.weworkService.runStop();
            e.printStackTrace();
            MyCrashHandler.getInstance().dealException(e);
        }
    }
}
