package com.kuxuan.autoclick.net;

import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.LeaderCreateBroupBean;
import com.kuxuan.autoclick.model.MainBean;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.groupsend.CompanyBean;
import com.kuxuan.autoclick.net.callback.ResultCallBack;
import com.kuxuan.autoclick.net.request.AccessPresenter;
import com.kuxuan.autoclick.service.WeworkController;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.StringSort;
import com.kuxuan.autoclick.utils.SystemUtils;

import org.greenrobot.eventbus.EventBus;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * @author lkj
 * @date 2024/4/28 10:20
 * @desc 群主创建群 执行请求网络
 */
public class GroupLeaderCreateGroupNet {
    private static GroupLeaderCreateGroupNet groupLeaderCreateGroupNet;

    public static GroupLeaderCreateGroupNet getInstance() {
        if (groupLeaderCreateGroupNet == null) {
            synchronized (GroupLeaderCreateGroupNet.class) {
                if (groupLeaderCreateGroupNet == null) {
                    groupLeaderCreateGroupNet = new GroupLeaderCreateGroupNet();
                }
            }
        }
        return groupLeaderCreateGroupNet;
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:06
     * @desc 群主创建群聊
     */
    private long groupLeaderTimeStemp = 0;

    public void groupLeader(TaskBean taskBean) {
        LogUtil.e("群主创建群执行任务 " + Constant.sendGroupIsRuning + "  " + Constant.addGroupIsRuning + "  " + Constant.friendSendIsRuning + "  " + Constant.isShareToColleague + "  " + Constant.isAddShareClient + "  " + Constant.isLeaderCreateGroup + " " + Constant.isOutGroupCustomReturn + "  " + Constant.isRealTimeAddGroup);
        if (!Constant.sendGroupIsRuning && !Constant.addGroupIsRuning && !Constant.friendSendIsRuning && !Constant.isShareToColleague && !Constant.isAddShareClient && !Constant.isLeaderCreateGroup && !Constant.isOutGroupCustomReturn && !Constant.isRealTimeAddGroup) {
            long currTimeStemp = System.currentTimeMillis();
            if (currTimeStemp - groupLeaderTimeStemp < 10 * 1000) {
                LogUtil.e("请求时间小于10秒，过滤掉本次请求！！");
                return;
            }
            groupLeaderTimeStemp = currTimeStemp;
            Constant.isLeaderCreateGroup = true;
            Constant.listIndex = 0;
            EventBus.getDefault().post(new MainBean(true));
//            StringUtils.setMessageData("正在执行群主创建群聊……", 10, 0);
            String deviceid = SystemUtils.getDeviceId(WeworkController.mainActivity);
            Map<String, Object> map = new HashMap<>();
            map.put("device_id", deviceid);
            String sortKey = StringSort.sortKey(map);
            Set<String> set = new HashSet<String>(Arrays.asList(Constant.testDevicesIds));
            AccessPresenter.getInstance().getCreateGroupTask(deviceid, sortKey, new ResultCallBack<LeaderCreateBroupBean>() {
                @Override
                public void success(LeaderCreateBroupBean createBroupBean) {
                    if (set.contains(deviceid)) {
                        LogUtil.e("这是测试手机的设备id");
//                        String result = "{\"rst\":{\"companyName\":\"酷炫公司\",\"groupBeans\":[{\"corpid\":\"wpezvKNwAAqhf2EANC2YbxJKsQNl33kA\",\"owner\":\"woezvKNwAAiwDjVwv1Jo0PHybME6NdsQ\",\"groupName\":\"\uD83C\uDF4E\uD83C\uDF4E测试群\",\"manager\":\"沈松\"}],\"request_time\":1709489655},\"errno\":\"0\",\"err\":\"成功\",\"timestamp\":\"1709489669\",\"v\":\"1.0.1\",\"auno\":\"0\"}";
//                        createBroupBean = new Gson().fromJson(result, LeaderCreateBroupBean.class);
                    } else {
                        LogUtil.e("这是正式手机的设备id");
                    }
                    if (createBroupBean.getErr().equals("成功")) {
                        LeaderCreateBroupBean.RstBean rst = createBroupBean.getRst();
                        if (rst != null && rst.getGroupBeans().size() > 0) {
                            WeworkController.weworkService.canUserCompanyNameList.clear();
                            CompanyBean companyBean = new CompanyBean();
                            companyBean.setCompanyName(rst.getCompanyName());
                            WeworkController.weworkService.canUserCompanyNameList.add(companyBean);
                            WeworkController.weworkService.needCreateCompanyName = rst.getCompanyName();
                            WeworkController.weworkService.groupBeans = rst.getGroupBeans();
                            LogUtil.e("得到群主创建群聊数据 开始执行任务");
                            taskBean.setCreateGroup(true);
                            taskBean.setLive(true);
                            WeworkController.weworkService.startOtherTask(true, taskBean);
                        } else {
                            Constant.isLeaderCreateGroup = false;
                            WeworkController.weworkService.runStop();
//                            LogUtil.e("群主创建群聊 设置为false");
                        }
                    } else {
                        Constant.isLeaderCreateGroup = false;
                        WeworkController.weworkService.runStop();
                        LogUtil.e("群主创建群聊 设置为false");
                    }
                }

                @Override
                public void fail(String error) {
                    Constant.isLeaderCreateGroup = false;
                    WeworkController.weworkService.runStop();
                    LogUtil.e("群主创建群聊 设置为false");
                }

                @Override
                public void requestComplete() {

                }
            });
        }
    }
}
