package com.kuxuan.autoclick.net;

import android.os.Build;

import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.MainBean;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.groupsend.RequestMessageBean;
import com.kuxuan.autoclick.net.callback.ResultCallBack;
import com.kuxuan.autoclick.net.request.AccessPresenter;
import com.kuxuan.autoclick.service.SelectMethod;
import com.kuxuan.autoclick.service.WeworkController;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.StringSort;
import com.kuxuan.autoclick.utils.StringUtils;
import com.kuxuan.autoclick.utils.SystemUtils;
import com.kuxuan.autoclick.utils.get_expection.MyCrashHandler;

import org.greenrobot.eventbus.EventBus;

import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * @author lkj
 * @date 2024/4/28 10:20
 * @desc 群发消息执行请求网络
 */
public class GroupSendNet {
    private static GroupSendNet groupSendNet;

    public static GroupSendNet getInstance() {
        if (groupSendNet == null) {
            synchronized (GroupSendNet.class) {
                if (groupSendNet == null) {
                    groupSendNet = new GroupSendNet();
                }
            }
        }
        return groupSendNet;
    }

    /**
     * @param taskBean
     * @auth lkj
     * @Date 2023/6/12 10:12
     * @Describe 执行群发任务的方法
     */
    public void groupSendMethod(TaskBean taskBean) {
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    LogUtil.e("群发工具定时器执行任务 " + Constant.sendGroupIsRuning + "  " + Constant.addGroupIsRuning + "  " + Constant.friendSendIsRuning + "  " + Constant.isShareToColleague + "  " + Constant.isAddShareClient + "  " + Constant.isLeaderCreateGroup + "  " + Constant.isOutGroupCustomReturn + "  " + Constant.isRealTimeAddGroup);
                    if (!Constant.sendGroupIsRuning && !Constant.addGroupIsRuning && !Constant.friendSendIsRuning && !Constant.isShareToColleague && !Constant.isAddShareClient && !Constant.isLeaderCreateGroup && !Constant.isOutGroupCustomReturn && !Constant.isRealTimeAddGroup) {
                        Constant.listIndex = 0;
                        LogUtil.e("发起请求任务呀  系统信息：" + Build.FINGERPRINT);
                        String deviceid = SystemUtils.getDeviceId(WeworkController.mainActivity);
                        Map<String, Object> map = new HashMap<>();
                        map.put("device_id", deviceid);
                        String sortKey = StringSort.sortKey(map);
                        Set<String> set = new HashSet<String>(Arrays.asList(Constant.testDevicesIds));
                        AccessPresenter.getInstance().senderConfirm(deviceid, sortKey, new ResultCallBack<RequestMessageBean>() {
                            @Override
                            public void success(RequestMessageBean messageBean) {
                                if (set.contains(deviceid)) {
                                    LogUtil.e("这是测试手机的设备id");
                                } else {
                                    LogUtil.e("这是正式手机的设备id");
                                }
                                Constant.sendGroupIsRuning = true;
                                StringUtils.setMessageData("正在执行群发消息……", 10, 0);
                                EventBus.getDefault().post(new MainBean(true));
                                if (messageBean.getErr().equals("成功")) {
                                    RequestMessageBean.RstBean rst = messageBean.getRst();
                                    if (rst.getList() != null && rst.getList().size() > 0) {
                                        WeworkController.weworkService.companyBeans = rst.getList();
                                        WeworkController.weworkService.canUserCompanyNameList.clear();
                                        /**
                                         * @auth lkj
                                         * @Date 2023/6/1 14:11
                                         * @Describe 这里暂时注释 正式使用需打开
                                         * 2023/6/6 17:44 lkj 已打开
                                         */
                                        LogUtil.e("得到群发消息的数据 开始执行任务");
                                        WeworkController.weworkService.startOtherTask(true, taskBean);
                                    } else {
                                        Constant.sendGroupIsRuning = false;
                                        WeworkController.weworkService.runStop();
                                        LogUtil.e("群发执行 设置为false");
                                        /**
                                         * @auth lkj
                                         * @Date 2023/9/1 15:19
                                         * @Describe 单独只执行群发 需要将拉人和朋友圈停止执行 @ K,需要的单独版本
                                         * 出完版本已经解除注释 并恢复三个功能同时存在
                                         */
                                        SelectMethod.getInstance().selectMethod2(taskBean);
                                    }
                                } else {
                                    Constant.sendGroupIsRuning = false;
                                    WeworkController.weworkService.runStop();
                                    LogUtil.e("群发执行 设置为false");
                                    /**
                                     * @auth lkj
                                     * @Date 2023/9/1 15:19
                                     * @Describe 单独只执行群发 需要将拉人和朋友圈停止执行 @ K,需要的单独版本
                                     * 出完版本已经解除注释 并恢复三个功能同时存在
                                     */
                                    SelectMethod.getInstance().selectMethod2(taskBean);
                                }
                            }

                            @Override
                            public void fail(String error) {
                                LogUtil.e("请求失败：" + error);
                                WeworkController.weworkService.runStop();
                                Constant.sendGroupIsRuning = false;
                            }

                            @Override
                            public void requestComplete() {

                            }
                        });
                    }
                } catch (Exception e) {
                    Constant.sendGroupIsRuning = false;
                    WeworkController.weworkService.runStop();
                    e.printStackTrace();
                    MyCrashHandler.getInstance().dealException(e);
                }
            }
        }).start();
    }
}
