package com.kuxuan.autoclick.net;

import com.google.gson.Gson;
import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.MainBean;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.add_people_into_group.AddGroupBean;
import com.kuxuan.autoclick.model.add_people_into_group.GroupBean;
import com.kuxuan.autoclick.model.add_people_into_group.InviteListBean;
import com.kuxuan.autoclick.model.groupsend.CompanyBean;
import com.kuxuan.autoclick.net.callback.ResultCallBack;
import com.kuxuan.autoclick.net.request.AccessPresenter;
import com.kuxuan.autoclick.service.GroupSendImplKt;
import com.kuxuan.autoclick.service.SelectMethod;
import com.kuxuan.autoclick.service.WeworkController;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.StringSort;
import com.kuxuan.autoclick.utils.StringUtils;
import com.kuxuan.autoclick.utils.SystemUtils;

import org.greenrobot.eventbus.EventBus;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author lkj
 * @date 2024/4/28 10:20
 * @desc 退群用户重新补拉到指定群里执行请求网络
 */
public class OutGroupReturnTargetNet {
    private static OutGroupReturnTargetNet outGroupReturnTargetNet;

    public static OutGroupReturnTargetNet getInstance() {
        if (outGroupReturnTargetNet == null) {
            synchronized (OutGroupReturnTargetNet.class) {
                if (outGroupReturnTargetNet == null) {
                    outGroupReturnTargetNet = new OutGroupReturnTargetNet();
                }
            }
        }
        return outGroupReturnTargetNet;
    }

    /**
     * @author lkj
     * @date 2024/4/26 14:35
     * @desc 退群客户重新补拉 补拉到指定的群里
     */
    public void outGroupReturnTarget(TaskBean taskBean) {
        LogUtil.e("重新补拉到指定群 " + Constant.sendGroupIsRuning + "  " + Constant.addGroupIsRuning + "  " + Constant.friendSendIsRuning + "  " + Constant.isShareToColleague + "  " + Constant.isAddShareClient + "  " + Constant.isLeaderCreateGroup + "  " + Constant.isOutGroupCustomReturn + "  " + Constant.isRealTimeAddGroup);
        if (!Constant.sendGroupIsRuning && !Constant.addGroupIsRuning && !Constant.friendSendIsRuning && !Constant.isShareToColleague && !Constant.isAddShareClient && !Constant.isLeaderCreateGroup && !Constant.isOutGroupCustomReturn && !Constant.isRealTimeAddGroup) {
            Constant.isOutGroupCustomReturn = true;
            Constant.listIndex = 0;
            StringUtils.setMessageData("重新补拉到指定群……", 10, 0);
            EventBus.getDefault().post(new MainBean(true));
            long lastTime = System.currentTimeMillis() - 20 * 60 * 1000;
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String deviceid = SystemUtils.getDeviceId(WeworkController.mainActivity);
            String lastT = dateFormat.format(lastTime);
            String currTime = dateFormat.format(System.currentTimeMillis());
            Map<String, Object> map = new HashMap<>();
            map.put("device_id", deviceid);
            map.put("begin_time", lastT);
            map.put("end_time", currTime);
            String sortKey = StringSort.sortKey(map);
            Set<String> set = new HashSet<String>(Arrays.asList(Constant.testDevicesIds));
            AccessPresenter.getInstance().waitInviteTargetGroup(deviceid, lastT, currTime, sortKey, new ResultCallBack<AddGroupBean>() {
                @Override
                public void success(AddGroupBean addGroupBean) {
                    if (set.contains(deviceid)) {
//                        String json = "{\"rst\":{\"list\":[{\"companyName\":\"众课五常分公司\",\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"owner_type\":2,\"groupBeans\":[{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAA2VIIiqDCo0BwPWI1-JSDrQ\",\"sort\":0,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群YX#0426_1\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAA8eI8pW_SDnwW2xpilXmWkw\",\"sort\":1,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群YX#0420_2\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAAA2gpHxsxuwgGh6deKaCGag\",\"sort\":2,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群zjyx#0421_3\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAAAawd3DzN-rd7400V0xiIpQ\",\"sort\":3,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群YX#0420_1\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAAAHSnYU2TxhNU01dcohq3RQ\",\"sort\":4,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群zjyx#0421_2\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAACOV0c37M9Yq08fU28AZsLg\",\"sort\":5,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群zjyx#0421_1\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAADiY1gRqY-S3-U8RyJMHezQ\",\"sort\":6,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群YX#0422_1\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAAE7nuArrcUbR3qazCxu_XnQ\",\"sort\":7,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群zjyx#0409_1\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"people_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAAiJGlVNWgNnEWCvrSO5J2UA\",\"sort\":8,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群YX#0423_2\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAALl5HV77V9RF-d9qEUD6DvQ\",\"sort\":9,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群YX#0423_1\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAANli5BMF_YlmWXbnVtbHDFQ\",\"sort\":10,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群zjyx#0421_4\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAAVHHlup3CDPWaXL1K0PYXgQ\",\"sort\":11,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群zjyx#0424_1\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAAvRtp-bM9xwqrE1ocNTi7Yg\",\"sort\":12,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群zjyx#0403_1\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"people_list\":[]},{\"corpid\":\"wpezvKNwAAk2NAR10_CUaiszGenTCfGg\",\"chat_id\":\"wrvJB-ZAAAZQki1WODsxtbepleCqzxKw\",\"sort\":13,\"user_limit\":35,\"groupName\":\"\uD83D\uDCB0财源广进好剧群YX#0420_3\",\"owner\":\"woezvKNwAAIqVlt8VPUavl-F-Am_Lt3g\",\"owner_name\":\"雨嫣\",\"invite_list\":[]}]}]},\"errno\":\"0\",\"err\":\"成功\",\"timestamp\":\"1714373712\",\"v\":\"1.0.1\",\"auno\":\"0\"}";
//                        addGroupBean = new Gson().fromJson(json, addGroupBean.getClass());
                        LogUtil.e("这是测试手机的设备id");
                    } else {
                        LogUtil.e("这是正式手机的设备id ");
                    }
                    if (addGroupBean.getErr().equals("成功")) {
                        AddGroupBean.RstBean rstBean = addGroupBean.getRst();
                        if (rstBean != null) {//群聊2#0226_1
                            WeworkController.weworkService.companyBeans = rstBean.getList();
                            WeworkController.weworkService.canUserCompanyNameList.clear();
                            GroupSendImplKt.getGroupList().clear();
                            WeworkController.weworkService.testNameList.clear();
                            boolean isNullList = false;
                            if (WeworkController.weworkService.companyBeans != null && WeworkController.weworkService.companyBeans.size() > 0) {
                                for (CompanyBean companyBean : WeworkController.weworkService.companyBeans) {
                                    //单位名称
                                    String comName = companyBean.companyName;
                                    LogUtil.e("单位名称：" + comName);
                                    List<GroupBean> groupBeans = companyBean.groupBeans;
                                    if (groupBeans != null && groupBeans.size() > 0) {
                                        for (GroupBean groupBean : groupBeans) {
                                            //群聊名称
                                            List<InviteListBean> invite_list = groupBean.invite_list;
                                            if (invite_list != null && invite_list.size() > 0) {
                                                for (InviteListBean inviteListBean : invite_list) {
                                                    String group_name = inviteListBean.getGroup_name();
                                                    String owner_name = inviteListBean.getOwner_name();
                                                    LogUtil.e("群聊名称：" + group_name);
                                                    LogUtil.e("群 主 名：" + owner_name);
                                                    List<InviteListBean.CustomerListBean> customer_list = inviteListBean.getCustomer_list();
                                                    if (customer_list != null && customer_list.size() > 0) {
                                                        for (InviteListBean.CustomerListBean customerListBean : customer_list) {
                                                            String name = customerListBean.getName();
                                                            LogUtil.e("客户名字：" + name);
                                                        }
                                                    } else {
                                                        isNullList = true;
                                                        LogUtil.e("重新补拉到指定群企业列表为空");
                                                        Constant.isOutGroupCustomReturn = false;
                                                        WeworkController.weworkService.runStop();
                                                        SelectMethod.getInstance().selectMethod3(taskBean);
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                if (!isNullList) {
                                    WeworkController.weworkService.startOtherTask(true, taskBean);
                                    LogUtil.e("重新补拉到指定群企业列表为空");
                                    Constant.isOutGroupCustomReturn = false;
                                    WeworkController.weworkService.runStop();
                                    SelectMethod.getInstance().selectMethod3(taskBean);
                                }
                            } else {
                                LogUtil.e("重新补拉到指定群企业列表为空");
                                Constant.isOutGroupCustomReturn = false;
                                WeworkController.weworkService.runStop();
                                SelectMethod.getInstance().selectMethod3(taskBean);
//                                    friendSendMethod(taskBean);
                            }
                        } else {
                            LogUtil.e("重新补拉到指定群请求数据为空");
                            Constant.isOutGroupCustomReturn = false;
                            WeworkController.weworkService.runStop();
                            SelectMethod.getInstance().selectMethod3(taskBean);
                        }
                    } else {
                        LogUtil.e("重新补拉到指定群请求失败");
                        Constant.isOutGroupCustomReturn = false;
                        WeworkController.weworkService.runStop();
                        SelectMethod.getInstance().selectMethod3(taskBean);
                    }
                }

                @Override
                public void fail(String error) {
                    Constant.isOutGroupCustomReturn = false;
                    WeworkController.weworkService.runStop();
                }

                @Override
                public void requestComplete() {

                }
            });
        }
    }
}
