package com.kuxuan.autoclick.net;

import com.google.gson.Gson;
import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.MainBean;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.add_people_into_group.AddGroupBean;
import com.kuxuan.autoclick.model.add_people_into_group.GroupBean;
import com.kuxuan.autoclick.model.add_people_into_group.People;
import com.kuxuan.autoclick.model.groupsend.CompanyBean;
import com.kuxuan.autoclick.net.callback.ResultCallBack;
import com.kuxuan.autoclick.net.request.AccessPresenter;
import com.kuxuan.autoclick.service.GroupSendImplKt;
import com.kuxuan.autoclick.service.WeworkController;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.StringSort;
import com.kuxuan.autoclick.utils.StringUtils;
import com.kuxuan.autoclick.utils.SystemUtils;
import com.kuxuan.autoclick.utils.get_expection.MyCrashHandler;

import org.greenrobot.eventbus.EventBus;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @author lkj
 * @date 2024/4/28 10:20
 * @desc 实时邀请入群 执行请求网络
 */
public class RealTimeAddGroupNet {
    private static RealTimeAddGroupNet realTimeAddGroupNet;

    public static RealTimeAddGroupNet getInstance() {
        if (realTimeAddGroupNet == null) {
            synchronized (RealTimeAddGroupNet.class) {
                if (realTimeAddGroupNet == null) {
                    realTimeAddGroupNet = new RealTimeAddGroupNet();
                }
            }
        }
        return realTimeAddGroupNet;
    }

    /**
     * @author lkj
     * @date 2024/4/28 10:13
     * @desc 实时邀请入群
     */
    public void realTimeAddMethod(TaskBean taskBean) {
        try {
            LogUtil.e("实时邀请入群定时器执行任务 " + Constant.sendGroupIsRuning + "  " + Constant.addGroupIsRuning + "  " + Constant.friendSendIsRuning + "  " + Constant.isShareToColleague + "  " + Constant.isAddShareClient + "  " + Constant.isLeaderCreateGroup + "  " + Constant.isOutGroupCustomReturn + "  " + Constant.isRealTimeAddGroup);
            if (!Constant.sendGroupIsRuning && !Constant.addGroupIsRuning && !Constant.friendSendIsRuning && !Constant.isShareToColleague && !Constant.isAddShareClient && !Constant.isLeaderCreateGroup && !Constant.isOutGroupCustomReturn && !Constant.isRealTimeAddGroup) {
                LogUtil.e("发起请求任务呀  系统信息：" + android.os.Build.FINGERPRINT);
                Constant.listIndex = 0;
                Constant.isRealTimeAddGroup = true;
                StringUtils.setMessageData("正在执行实时邀请入群", 10, 0);
                EventBus.getDefault().post(new MainBean(true));
                String deviceid = SystemUtils.getDeviceId(WeworkController.mainActivity);
                long lastTime = System.currentTimeMillis() - 20 * 60 * 1000;
                SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                String lastT = dateFormat.format(lastTime);
                String currTime = dateFormat.format(System.currentTimeMillis());
                Map<String, Object> map = new HashMap<>();
//                lastT = "2023-06-15 17:20:00";
//                currTime = "2023-06-15 17:25:00";
                map.put("device_id", deviceid);
                map.put("begin_time", lastT);
                map.put("end_time", currTime);
                String sortKey = StringSort.sortKey(map);
                Set<String> set = new HashSet<String>(Arrays.asList(Constant.testDevicesIds));
//                AccessPresenter.getInstance().waitInvite(deviceid, lastT, currTime, sortKey, new ResultCallBack<AddGroupBean>() {
//                    @Override
//                    public void success(AddGroupBean addGroupBean) {
                AddGroupBean addGroupBean = null;
                if (set.contains(deviceid)) {
                    String json = StringUtils.readAssetsString(WeworkController.mainActivity);
                    addGroupBean = new Gson().fromJson(json, AddGroupBean.class);
                    LogUtil.e("这是测试手机的设备id");
                } else {
                    LogUtil.e("这是正式手机的设备id");
                }
                if (addGroupBean.getErr().equals("成功")) {
                    AddGroupBean.RstBean rstBean = addGroupBean.getRst();
                    if (rstBean != null) {//群聊2#0226_1
                        WeworkController.weworkService.companyBeans = rstBean.getList();
                        WeworkController.weworkService.canUserCompanyNameList.clear();
                        GroupSendImplKt.getGroupList().clear();
                        WeworkController.weworkService.testNameList.clear();
                        if (WeworkController.weworkService.companyBeans != null && WeworkController.weworkService.companyBeans.size() > 0) {
                            for (CompanyBean companyBean : WeworkController.weworkService.companyBeans) {
                                //单位名称
                                String comName = companyBean.companyName;
                                LogUtil.e("单位名称：" + comName);
                                List<GroupBean> groupBeans = companyBean.groupBeans;
                                if (groupBeans != null && groupBeans.size() > 0) {
                                    for (GroupBean groupBean : groupBeans) {
                                        //群聊名称
                                        String groupName = groupBean.groupName;
//                                                GroupSendImplKt.getGroupList().add(groupBean);
                                        LogUtil.e("群聊名称：" + groupName);
                                    }
                                }
                                List<People> peopleList = companyBean.peopleList;
                                if (peopleList != null && peopleList.size() > 0) {
                                    for (People people : peopleList) {
                                        //客户名称
                                        String peopleName = people.name;
//                                                GroupSendImplKt.getTestNameList().add(peopleName);
                                        LogUtil.e("客户名称：" + peopleName);
                                    }
                                }
                            }
                            WeworkController.weworkService.startOtherTask(true, taskBean);
                        } else {
                            LogUtil.e("实时邀请入群企业列表为空");
                            Constant.isRealTimeAddGroup = false;
                            WeworkController.weworkService.runStop();
                        }
                    } else {
                        LogUtil.e("拉人入群请求数据为空");
                        Constant.isRealTimeAddGroup = false;
                        WeworkController.weworkService.runStop();
                    }
                } else {
                    LogUtil.e("拉人入群请求失败");
                    Constant.isRealTimeAddGroup = false;
                    WeworkController.weworkService.runStop();
                }
//                    }
//
//                    @Override
//                    public void fail(String error) {
//                        Constant.isRealTimeAddGroup = false;
//                        WeworkController.weworkService.runStop();
//                    }
//
//                    @Override
//                    public void requestComplete() {
//
//                    }
//                });
            }
        } catch (Exception e) {
            Constant.isRealTimeAddGroup = false;
            WeworkController.weworkService.runStop();
            e.printStackTrace();
            MyCrashHandler.getInstance().dealException(e);
        }
    }
}
