package com.kuxuan.autoclick.net;

import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.MainBean;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.groupsend.CompanyBean;
import com.kuxuan.autoclick.model.groupsend.RequestMessageBean;
import com.kuxuan.autoclick.net.callback.ResultCallBack;
import com.kuxuan.autoclick.net.request.AccessPresenter;
import com.kuxuan.autoclick.service.SelectMethod;
import com.kuxuan.autoclick.service.WeworkController;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.StringSort;
import com.kuxuan.autoclick.utils.StringUtils;
import com.kuxuan.autoclick.utils.SystemUtils;

import org.greenrobot.eventbus.EventBus;

import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * @author lkj
 * @date 2024/4/28 10:20
 * @desc 共享客户给同事 执行请求网络
 */
public class Share2ColleagueNet {
    private static Share2ColleagueNet share2ColleagueNet;
    /**
     * @auth lkj
     * @Date 2023/6/7 18:31
     * @Describe 记录时间戳
     */
    private long shareLastTime = 0;

    public static Share2ColleagueNet getInstance() {
        if (share2ColleagueNet == null) {
            synchronized (Share2ColleagueNet.class) {
                if (share2ColleagueNet == null) {
                    share2ColleagueNet = new Share2ColleagueNet();
                }
            }
        }
        return share2ColleagueNet;
    }

    /**
     * @auth lkj
     * @Date 2023/10/16 16:03
     * @Describe 共享客户给同事
     */
    public void shareToColleague(TaskBean taskBean) {
        LogUtil.e("共享联系人执行任务 " + Constant.sendGroupIsRuning + "  " + Constant.addGroupIsRuning + "  " + Constant.friendSendIsRuning + "  " + Constant.isShareToColleague + "  " + Constant.isAddShareClient + "  " + Constant.isLeaderCreateGroup + "  " + Constant.isOutGroupCustomReturn + "  " + Constant.isRealTimeAddGroup);
        if (!Constant.sendGroupIsRuning && !Constant.addGroupIsRuning && !Constant.friendSendIsRuning && !Constant.isShareToColleague && !Constant.isAddShareClient && !Constant.isLeaderCreateGroup && !Constant.isOutGroupCustomReturn && !Constant.isRealTimeAddGroup) {
            String deviceid = SystemUtils.getDeviceId(WeworkController.mainActivity);
            if (shareLastTime == 0) {
                shareLastTime = System.currentTimeMillis() - 20 * 60 * 1000;
            }
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String lastT = dateFormat.format(shareLastTime);
            String currTime = dateFormat.format(System.currentTimeMillis());
            Map<String, Object> map = new HashMap<>();
            map.put("device_id", deviceid);
            map.put("begin_time", lastT);
            map.put("end_time", currTime);
            shareLastTime = System.currentTimeMillis();
            String sortKey = StringSort.sortKey(map);
            Set<String> set = new HashSet<String>(Arrays.asList(Constant.testDevicesIds));
            AccessPresenter.getInstance().waitShare(deviceid, lastT, currTime, sortKey, new ResultCallBack<RequestMessageBean>() {
                @Override
                public void success(RequestMessageBean messageBean) {
                    Constant.isShareToColleague = true;
                    StringUtils.setMessageData("正在执行共享联系人……", 10, 0);
                    EventBus.getDefault().post(new MainBean(true));
                    if (set.contains(deviceid)) {
                        LogUtil.e("这是测试手机的设备id");
//                        result = "{\"auno\":\"0\",\"err\":\"成功\",\"errno\":\"0\",\"rst\":{\"list\":[{\"companyName\":\"酷炫公司\",\"sharedBean\":{\"clientNames\":[\"加油凯哥\",\"名字很土\"],\"colleagueNames\":[\"侯晓华\",\"孙浩\"]}},{\"companyName\":\"北京时间科技有限公司\",\"sharedBean\":{\"clientNames\":[\"名字很土\",\"那年冬天\"],\"colleagueNames\":[\"侯晓华\",\"孙浩\"]}}]},\"timestamp\":\"1693481761\",\"v\":\"1.0.1\"}";
                    } else {
                        LogUtil.e("这是正式手机的设备id");
                    }
                    if (messageBean.getErr().equals("成功")) {
                        RequestMessageBean.RstBean rst = messageBean.getRst();
                        if (rst.getList() != null && rst.getList().size() > 0) {
                            WeworkController.weworkService.companyBeans = rst.getList();
                            for (CompanyBean companyBean : WeworkController.weworkService.companyBeans) {
                                LogUtil.e("companyBean: " + companyBean.toString());
                            }
                            WeworkController.weworkService.canUserCompanyNameList.clear();
                            LogUtil.e("得到共享客户给同事数据 开始执行任务");
                            WeworkController.weworkService.startOtherTask(true, taskBean);
                        } else {
                            Constant.isShareToColleague = false;
                            WeworkController.weworkService.runStop();
                            LogUtil.e("共享客户给同事执行 设置为false");
                            SelectMethod.getInstance().selectMethod5(taskBean);
                        }
                    } else {
                        Constant.isShareToColleague = false;
                        WeworkController.weworkService.runStop();
                        LogUtil.e("共享客户给同事执行 设置为false");
                        SelectMethod.getInstance().selectMethod5(taskBean);
                    }
                }

                @Override
                public void fail(String error) {
                    Constant.isShareToColleague = false;
                    WeworkController.weworkService.runStop();
                    LogUtil.e("共享客户给同事执行 设置为false");
                    SelectMethod.getInstance().selectMethod5(taskBean);
                }

                @Override
                public void requestComplete() {

                }
            });
        }
    }
}
