package com.kuxuan.autoclick.net.api;


import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.LeaderCreateBroupBean;
import com.kuxuan.autoclick.model.add_people_into_group.AddGroupBean;
import com.kuxuan.autoclick.model.groupsend.RequestMessageBean;

import io.reactivex.Observable;
import retrofit2.http.Field;
import retrofit2.http.FormUrlEncoded;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

/**
 * @Auth lkj
 * @Date 2023/6/27 16:20
 * @Describe 所有的网络请求接口
 */
public interface APIService {
    /**
     * @auth lkj
     * @Date 2023/9/20 18:22
     * @Describe 群发消息
     */
    @GET("/api/h5/massMsg/senderConfirm")
    Observable<RequestMessageBean> senderConfirm(@Query("device_id") String device_id,
                                                 @Query("sign") String sign);

    /**
     * @auth lkj
     * @Date 2023/9/20 18:23
     * @Describe 邀请入群
     */
    @FormUrlEncoded
    @POST("/api/h5/customer/waitInvite")
    Observable<AddGroupBean> waitInvite(@Field("device_id") String device_id,
                                        @Field("begin_time") String begin_time,
                                        @Field("end_time") String end_time,
                                        @Field("retry") int retry,
                                        @Field("corpid") String corpid,
                                        @Field("customer_number") int customer_number,
                                        @Field("sign") String sign);

    /**
     * @author lkj
     * @date 2024/4/9 18:12
     * @desc 用户退群补拉
     */
    @FormUrlEncoded
    @POST("/api/h5/customer/waitSupplementaryInvite")
    Observable<AddGroupBean> waitSupplementaryInvite(@Field("device_id") String device_id,
                                                     @Field("begin_time") String begin_time,
                                                     @Field("end_time") String end_time,
                                                     @Field("sign") String sign);

    /**
     * @author lkj
     * @date 2024/4/9 18:12
     * @desc 用户退群补拉 指定的群聊
     */
    @FormUrlEncoded
    @POST("/api/h5/customer/waitInviteTargetGroup")
    Observable<AddGroupBean> waitInviteTargetGroup(@Field("device_id") String device_id,
                                                   @Field("begin_time") String begin_time,
                                                   @Field("end_time") String end_time,
                                                   @Field("sign") String sign);

    /**
     * @auth lkj
     * @Date 2023/9/20 18:22
     * @Describe 朋友圈群发
     */
    @GET("/api/h5/momentMsg/senderConfirm")
    Observable<RequestMessageBean> friendSender(@Query("device_id") String device_id,
                                                @Query("sign") String sign);

    /**
     * @author lkj
     * @date 2024/4/11 16:12
     * @desc 共享客户给同事
     */
    @FormUrlEncoded
    @POST("/api/h5/customer/waitShare")
    Observable<RequestMessageBean> waitShare(@Field("device_id") String device_id,
                                             @Field("begin_time") String begin_time,
                                             @Field("end_time") String end_time,
                                             @Field("sign") String sign);

    /**
     * @author lkj
     * @date 2024/4/12 9:37
     * @desc 客服上报群主建群
     */
    @FormUrlEncoded
    @POST("/api/h5/chatGroup/receiveCreateChatGroupData")
    Observable<String> receiveCreateChatGroupData(@Field("device_id") String device_id,
                                                  @Field("corpid") String corpid,
                                                  @Field("user_name") String user_name,
                                                  @Field("group_list") String group_list,
                                                  @Field("sign") String sign);

    /**
     * @author lkj
     * @date 2024/4/11 16:25
     * @desc 群主创建群聊
     */
    @FormUrlEncoded
    @POST("/api/h5/chatGroup/getCreateGroupTask")
    Observable<LeaderCreateBroupBean> getCreateGroupTask(@Field("device_id") String device_id,
                                                         @Field("sign") String sign);

    /**
     * @author lkj
     * @date 2024/4/12 9:46
     * @desc 异常上报
     */
    @FormUrlEncoded
    @POST("/api/android/warnReport")
    Observable<String> warnReport(@Field("device_id") String device_id,
                                  @Field("exception") String exception,
                                  @Field("version") String version,
                                  @Field("sign") String sign);
}
