package com.kuxuan.autoclick.net.request;

import com.kuxuan.autoclick.model.LeaderCreateBroupBean;
import com.kuxuan.autoclick.model.add_people_into_group.AddGroupBean;
import com.kuxuan.autoclick.model.groupsend.RequestMessageBean;
import com.kuxuan.autoclick.net.api.APIService;
import com.kuxuan.autoclick.net.callback.ResultCallBack;
import com.kuxuan.autoclick.net.retrofit.RetrofitUtils;

import retrofit2.Retrofit;
import retrofit2.http.Field;
import retrofit2.http.Query;

/**
 * @Auth lkj
 * @Date 2023/9/19 18:34
 * @Describe
 */
public class AccessModel {

    private final APIService apiService;

    public AccessModel() {
        apiService = RetrofitUtils.getInstance().getApiService();
    }

    /**
     * @auth lkj
     * @Date 2023/9/20 18:09
     * @Describe 群发消息
     */
    public void senderConfirm(String device_id, String sign, ResultCallBack<RequestMessageBean> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.senderConfirm(device_id, sign), callBack);
    }

    /**
     * @auth lkj
     * @Date 2023/9/20 18:09
     * @Describe 邀请入群
     */
    public void waitInvite(String device_id, String begin_time, String end_time, int retry, String corpid, int customer_number, String sign, ResultCallBack<AddGroupBean> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.waitInvite(device_id, begin_time, end_time, retry, corpid, customer_number, sign), callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/9 18:13
     * @desc 用户退群补拉
     */
    public void waitSupplementaryInvite(String device_id, String begin_time, String end_time, String sign, ResultCallBack<AddGroupBean> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.waitSupplementaryInvite(device_id, begin_time, end_time, sign), callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/26 14:31
     * @desc 用户退群补拉, 指定的群聊
     */
    public void waitInviteTargetGroup(String device_id, String begin_time, String end_time, String sign, ResultCallBack<AddGroupBean> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.waitInviteTargetGroup(device_id, begin_time, end_time, sign), callBack);
    }

    /**
     * @auth lkj
     * @Date 2023/9/20 18:09
     * @Describe 朋友圈群发
     */
    public void friendSender(String device_id, String sign, ResultCallBack<RequestMessageBean> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.friendSender(device_id, sign), callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/11 16:16
     * @desc 共享客户给同事
     */
    public void waitShare(String device_id, String begin_time, String end_time, String sign, ResultCallBack<RequestMessageBean> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.waitShare(device_id, begin_time, end_time, sign), callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/12 9:39
     * @desc 客服上报群主建群
     */
    public void receiveCreateChatGroupData(String device_id, String corpid, String user_name, String group_list, String sign, ResultCallBack<String> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.receiveCreateChatGroupData(device_id, corpid, user_name, group_list, sign), callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/11 16:27
     * @desc 群主创建群聊
     */
    public void getCreateGroupTask(String device_id, String sign, ResultCallBack<LeaderCreateBroupBean> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.getCreateGroupTask(device_id, sign), callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/12 9:48
     * @desc 异常上报
     */
    public void warnReport(String device_id, String exception, String version, String sign, ResultCallBack<String> callBack) {
        RetrofitUtils.getInstance().getDataFromAPI(apiService.warnReport(device_id, exception, version, sign), callBack);
    }
}
