package com.kuxuan.autoclick.net.request;

import com.kuxuan.autoclick.model.LeaderCreateBroupBean;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.add_people_into_group.AddGroupBean;
import com.kuxuan.autoclick.model.groupsend.RequestMessageBean;
import com.kuxuan.autoclick.net.base.IBasePresenter;
import com.kuxuan.autoclick.net.callback.ResultCallBack;

import io.reactivex.Observable;

/**
 * @Auth lkj
 * @Date 2023/9/19 18:35
 * @Describe
 */
public class AccessPresenter extends IBasePresenter<IAccessView> {

    private final AccessModel accessModel;
    private static AccessPresenter presenter;

    public static AccessPresenter getInstance() {
        if (presenter == null) {
            synchronized (AccessPresenter.class) {
                if (presenter == null) {
                    presenter = new AccessPresenter();
                }
            }
        }
        return presenter;
    }

    public AccessPresenter() {
        accessModel = new AccessModel();
    }

    /**
     * @auth lkj
     * @Date 2023/9/20 18:09
     * @Describe 群发消息
     */
    public void senderConfirm(String device_id, String sign, ResultCallBack<RequestMessageBean> callBack) {
        accessModel.senderConfirm(device_id, sign, callBack);
    }

    /**
     * @auth lkj
     * @Date 2023/9/20 18:27
     * @Describe 邀请入群
     */
    public void waitInvite(String device_id, String begin_time, String end_time, int retry, String corpid, int customer_number, String sign, ResultCallBack<AddGroupBean> callBack) {
        accessModel.waitInvite(device_id, begin_time, end_time, retry, corpid, customer_number, sign, callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/9 18:14
     * @desc 用户退群后重新补拉
     */
    public void waitSupplementaryInvite(String device_id, String begin_time, String end_time, String sign, ResultCallBack<AddGroupBean> callBack) {
        accessModel.waitSupplementaryInvite(device_id, begin_time, end_time, sign, callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/26 14:32
     * @desc 用户退群补拉, 指定的群聊
     */
    public void waitInviteTargetGroup(String device_id, String begin_time, String end_time, String sign, ResultCallBack<AddGroupBean> callBack) {
        accessModel.waitInviteTargetGroup(device_id, begin_time, end_time, sign, callBack);
    }

    /**
     * @auth lkj
     * @Date 2023/9/20 18:27
     * @Describe 朋友圈群发
     */
    public void friendSender(String device_id, String sign, ResultCallBack<RequestMessageBean> callBack) {
        accessModel.friendSender(device_id, sign, callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/11 16:19
     * @desc 共享客户给同事
     */
    public void waitShare(String device_id, String begin_time, String end_time, String sign, ResultCallBack<RequestMessageBean> callBack) {
        accessModel.waitShare(device_id, begin_time, end_time, sign, callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/12 9:41
     * @desc 客服上报群主建群
     */
    public void receiveCreateChatGroupData(String device_id, String corpid, String user_name, String group_list, String sign, ResultCallBack<String> callBack) {
        accessModel.receiveCreateChatGroupData(device_id, corpid, user_name, group_list, sign, callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/11 16:28
     * @desc 群主创建群聊
     */
    public void getCreateGroupTask(String device_id, String sign, ResultCallBack<LeaderCreateBroupBean> callBack) {
        accessModel.getCreateGroupTask(device_id, sign, callBack);
    }

    /**
     * @author lkj
     * @date 2024/4/12 9:49
     * @desc 异常上报
     */
    public void warnReport(String device_id, String exception, String version, String sign, ResultCallBack<String> callBack) {
        accessModel.warnReport(device_id, exception, version, sign, callBack);
    }
}
