package com.kuxuan.autoclick.receiver;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;

import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.SPUtils;

import java.io.File;

public class FileCleanupReceiver extends BroadcastReceiver {
    private long TIME_TO_EXPIRE = 24 * 60 * 60 * 1000;

    @Override
    public void onReceive(Context context, Intent intent) {
        LogUtil.e("接收到定时清理过期文件的闹钟***********");
        // 这里写清理文件的逻辑
        testFile();
    }

    private void testFile() {
        String folderPath = "/storage/emulated/0/Android/media/com.kuxuan.autoclick/Log日志";
        File folder = new File(folderPath);
        File[] files = folder.listFiles();
        int autoCleanLogFile = SPUtils.getInstance().getInt("auto_clean_log_file", 1);
        int day = 3;
        switch (autoCleanLogFile) {
            case 0:
                day = 1;
                break;
            case 1:
                day = 3;
                break;
            case 2:
                day = 7;
                break;
            case 3:
                day = 15;
                break;
            case 4:
                day = 30;
                break;
        }
        LogUtil.e("文件夹的数量：" + files.length + " 保留日志的时间为： " + day);
        if (files != null) {
            //现在筛选的只是日志文件
            for (File file : files) {
                if (System.currentTimeMillis() - file.lastModified() > TIME_TO_EXPIRE * day) {
                    LogUtil.e(file.getName() + " 被自动删除了");
                    file.delete();
                } else {
                    LogUtil.e("依然保留的文件：" + file.getName());
                }
            }
        }
    }
}