package com.kuxuan.autoclick.receiver;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

import com.kuxuan.autoclick.model.MainNetStateBean;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.StringUtils;

import org.greenrobot.eventbus.EventBus;

public class NetworkReceiver extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        // 监听网络连接，包括wifi和移动数据的打开和关闭,以及连接上可用的连接都会接到监听
        // 特殊注意：如果if条件生效，那么证明当前是有连接wifi或移动网络的，如果有业务逻辑最好把esle场景酌情考虑进去！
        if (ConnectivityManager.CONNECTIVITY_ACTION.equals(intent.getAction())) {
            //获取联网状态的NetworkInfo对象
            NetworkInfo info = intent.getParcelableExtra(ConnectivityManager.EXTRA_NETWORK_INFO);
            if (info != null) {
                //如果当前的网络连接成功并且网络连接可用
                if (NetworkInfo.State.CONNECTED == info.getState() && info.isAvailable()) {
                    switch (info.getType()) {
                        case ConnectivityManager.TYPE_WIFI:
                            LogUtil.e("wifi网络" + "已连接");
                            break;
                        case ConnectivityManager.TYPE_MOBILE:
                            LogUtil.e("数据网络" + "已连接");
                            break;
                    }
                    StringUtils.setMessageData("网络正常",40, 0);
                    EventBus.getDefault().post(new MainNetStateBean(true));
                } else {
                    switch (info.getType()) {
                        case ConnectivityManager.TYPE_WIFI:
                            LogUtil.e("wifi网络" + "已断开");
                            break;
                        case ConnectivityManager.TYPE_MOBILE:
                            LogUtil.e("数据网络" + "已断开");
                            break;
                    }
                    StringUtils.setMessageData("网络异常",40, 0);
                    EventBus.getDefault().post(new MainNetStateBean(false));
                }
            } else {
                StringUtils.setMessageData("无网络",40, 0);
                EventBus.getDefault().post(new MainNetStateBean(false));
                LogUtil.e("无网络");
            }
        }
    }
}