package com.kuxuan.autoclick.service;

import android.os.SystemClock;
import android.view.accessibility.AccessibilityNodeInfo;

import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;

import java.util.List;

import static com.kuxuan.autoclick.service.WeworkController.weworkService;

/**
 * @Auth lkj
 * @Date 2023/10/18 16:12
 * @Describe 添加联系人
 */
public class AddClient {
    public static AddClient addClient;
    private String companyName;

    public static AddClient getInstance() {
        if (addClient == null) {
            synchronized (AddClient.class) {
                if (addClient == null) {
                    addClient = new AddClient();
                }
            }
        }
        return addClient;
    }

    /**
     * @auth lkj
     * @Date 2023/10/16 14:17
     * @Describe 跳到工作台寻找寻找 学员联系 或者 客户联系
     */
    public void findKfOrXy(TaskBean taskBean, int count, String companyname) {
        companyName = companyname;
        List<AccessibilityNodeInfo> xylxTexts = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("添加学员");
        if (xylxTexts != null) {
            if (!xylxTexts.isEmpty() && xylxTexts.size() > 0) {
                for (AccessibilityNodeInfo xylxText : xylxTexts) {
                    if (xylxText.getText().toString().equals("添加学员")) {
                        LogUtil.e("这里找到添加学员 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, xylxText);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                findNewPeople(taskBean, 0);
            } else {
                List<AccessibilityNodeInfo> khlxTexts = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("添加客户");
                if (khlxTexts != null) {
                    if (!khlxTexts.isEmpty() && khlxTexts.size() > 0) {
                        for (AccessibilityNodeInfo khlxText : khlxTexts) {
                            if (khlxText.getText().equals("添加客户")) {
                                LogUtil.e("这里找到添加客户 并进行点击！！");
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, khlxText);
                                SystemClock.sleep(NumberUtils.getRandom1000());
                            }
                        }
                        findNewPeople(taskBean, 0);
                    } else {
                        LogUtil.e("添加客户 和 添加学员都没找到");
                        LogUtil.e("返回首页");
                        GroupSendImplKt.returnHome(taskBean, 0);
                        GroupSendImplKt.isHaveCompany(4, taskBean);
                    }
                } else {
                    if (count > 4) {
                        LogUtil.e("寻找添加客户 4次 没找到");
                        LogUtil.e("返回首页");
                        GroupSendImplKt.returnHome(taskBean, 0);
                        GroupSendImplKt.isHaveCompany(5, taskBean);
                    } else {
                        SystemClock.sleep(1000);
                        findKfOrXy(taskBean, count + 1, companyname);
                    }
                }
            }
        } else {
            if (count > 4) {
                LogUtil.e("寻找添加学员 4次 没找到");
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
                GroupSendImplKt.isHaveCompany(5, taskBean);
            } else {
                SystemClock.sleep(1000);
                findKfOrXy(taskBean, count + 1, companyname);
            }
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/18 16:16
     * @Describe 找到 新的学员 或者 新的客户
     */
    private void findNewPeople(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> newXYs = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("新的学员");
        if (newXYs != null) {
            if (!newXYs.isEmpty() && newXYs.size() > 0) {
                for (AccessibilityNodeInfo newXY : newXYs) {
                    if (newXY.getText().equals("新的学员")) {
                        LogUtil.e("这里找到新的学员 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, newXY);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                findToMeClient(taskBean, 0);
            } else {
                List<AccessibilityNodeInfo> newKHs = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("新的客户");
                if (newKHs != null) {
                    if (!newKHs.isEmpty() && newKHs.size() > 0) {
                        for (AccessibilityNodeInfo newKH : newKHs) {
                            if (newKH.getText().equals("新的客户")) {
                                LogUtil.e("这里找到新的客户 并进行点击！！");
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, newKH);
                                SystemClock.sleep(NumberUtils.getRandom1000());
                            }
                        }
                        findToMeClient(taskBean, 0);
                    } else {
                        LogUtil.e("新的客户 没找到！！");
                        if (count > 4) {
                            LogUtil.e("寻找 新的客户 4次 没找到");
                            LogUtil.e("返回首页");
                            GroupSendImplKt.returnHome(taskBean, 0);
                            GroupSendImplKt.isHaveCompany(5, taskBean);
                        } else {
                            SystemClock.sleep(1000);
                            findNewPeople(taskBean, count + 1);
                        }
                    }
                } else {
                    LogUtil.e("newXYs 为空了！！");
                }
            }
        } else {
            LogUtil.e("newXYs 为空了！！");
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/18 16:48
     * @Describe 查看共享给我的 客户/学员
     */
    private void findToMeClient(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> toMeMessages = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("查看共享给我的");
        if (toMeMessages != null) {
            if (!toMeMessages.isEmpty() && toMeMessages.size() > 0) {
                LogUtil.e("这里找到新的客户 并进行点击！！");
                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, toMeMessages.get(0));
                SystemClock.sleep(NumberUtils.getRandom1000());
                findAddBtn(taskBean, 0);
            } else {
                if (count > 4) {
                    LogUtil.e("寻找 查看共享给我的 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(5, taskBean);
                } else {
                    SystemClock.sleep(1000);
                    findToMeClient(taskBean, count + 1);
                }
            }
        } else {
            LogUtil.e("toMeMessages 为空了！！");
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/18 16:52
     * @Describe 添加按钮
     */
    private void findAddBtn(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> addBtns = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("添加");
        if (addBtns != null) {
            if (!addBtns.isEmpty() && addBtns.size() > 0) {
                boolean haveBtn = false;
                for (AccessibilityNodeInfo addBtn : addBtns) {
                    if (addBtn.getText().equals("添加")) {
                        haveBtn = true;
                        LogUtil.e("这里找到 添加按钮 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, addBtn);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                if (haveBtn) {
                    findSendApply(taskBean, 0);
                } else {
                    LogUtil.e("当前没有找到 添加按钮！");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(5, taskBean);
                }
            } else {
                if (count > 4) {
                    LogUtil.e("寻找 添加 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(5, taskBean);
                } else {
                    SystemClock.sleep(1000);
                    findAddBtn(taskBean, count + 1);
                }
            }
        } else {
            LogUtil.e("addBtns 为空了！！");
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/25 14:01
     * @Describe 点击发送申请
     */
    private void findSendApply(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> sendApplys = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("发送申请");
        if (sendApplys != null) {
            if (!sendApplys.isEmpty() && sendApplys.size() > 0) {
                for (AccessibilityNodeInfo sendApply : sendApplys) {
                    if (sendApply.getText().equals("发送申请")) {
                        LogUtil.e("这里找到 发送申请 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, sendApply);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                LogUtil.e("结束 返回首页 进行下面的操作！！");
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
                GroupSendImplKt.isHaveCompany(4, taskBean);
            } else {
                if (count > 4) {
                    LogUtil.e("寻找 发送申请 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(5, taskBean);
                } else {
                    SystemClock.sleep(1000);
                    findAddBtn(taskBean, count + 1);
                }
            }
        } else {
            LogUtil.e("sendApplys 为空了！！");
        }
    }
}
