package com.kuxuan.autoclick.service;

import android.graphics.Rect;
import android.os.Bundle;
import android.os.SystemClock;
import android.text.TextUtils;
import android.view.accessibility.AccessibilityNodeInfo;
import android.view.accessibility.AccessibilityWindowInfo;

import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;
import com.kuxuan.autoclick.utils.Views;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static com.kuxuan.autoclick.service.WeworkController.weworkService;

/**
 * @Auth lkj
 * @Date 2023/10/30 14:26
 * @Describe 自动创建群聊
 */
public class AutoCreateGroup {
    private static AutoCreateGroup autoCreateGroup;
    private SimpleDateFormat dateFormat = new SimpleDateFormat("MMdd");

    public static AutoCreateGroup getInstance() {
        if (autoCreateGroup == null) {
            synchronized (AutoCreateGroup.class) {
                if (autoCreateGroup == null) {
                    autoCreateGroup = new AutoCreateGroup();
                }
            }
        }
        return autoCreateGroup;
    }

    /**
     * @auth lkj
     * @Date 2023/11/14 15:43
     * @Describe 点击 客户群 或者 学员群
     */
    public void clickGroup(TaskBean taskBean, List<String> peopleNameList, String groupName, String announcement, int groupCount, String companyname) {
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(GlobalMethodKt.getRootCopy(taskBean), new String[]{Views.TextView});
//        List<AccessibilityNodeInfo> clientGroups = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("客户群");
        if (allByClazz != null) {
            if (!allByClazz.isEmpty() && allByClazz.size() > 0) {
                for (AccessibilityNodeInfo clientGroup : allByClazz) {
                    if (!TextUtils.isEmpty(clientGroup.getText()) && clientGroup.getText().toString().equals("客户群")) {
                        LogUtil.e("点击了 客户群");
                        AccessibilityUtil.INSTANCE.performClick(clientGroup, true);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                        break;
                    }
                    if (!TextUtils.isEmpty(clientGroup.getText()) && clientGroup.getText().toString().equals("学员群")) {
                        LogUtil.e("点击了 学员群");
                        AccessibilityUtil.INSTANCE.performClick(clientGroup, true);
                        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                        break;
                    }
                }
                //弹出框中输入群聊名称
                clickXYQNode(taskBean, peopleNameList, groupName, announcement, groupCount, companyname);
            } else {
                LogUtil.e("没找到 客户群 文字");
                List<AccessibilityNodeInfo> studGroups = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("学员群");
                if (studGroups != null) {
                    if (!studGroups.isEmpty() && studGroups.size() > 0) {
                        for (AccessibilityNodeInfo studGroup : studGroups) {
                            if (studGroup.getText().toString().equals("学员群")) {
                                LogUtil.e("点击了 学员群");
                                AccessibilityUtil.INSTANCE.performClick(studGroup, true);
                                SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                                break;
                            }
                        }
                        //弹出框中输入群聊名称
                        clickXYQNode(taskBean, peopleNameList, groupName, announcement, groupCount, companyname);
                    } else {
                        LogUtil.e("没找到 学员群 文字");
                    }
                } else {
                    LogUtil.e("studGroups 为空了！");
                }
            }
        } else {
            LogUtil.e("clientGroups 为空了！");
        }
    }

    private void clickXYQNode(TaskBean taskBean, List<String> peopleNameList, String groupName, String announcement, int groupCount, String companyname) {
        List<AccessibilityNodeInfo> createOneStudGroups = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("创建一个学员群");
        if (createOneStudGroups != null) {
            if (!createOneStudGroups.isEmpty() && createOneStudGroups.size() > 0) {
                for (AccessibilityNodeInfo oneStudGroup : createOneStudGroups) {
                    if (oneStudGroup.getText().toString().equals("创建一个学员群")) {
                        LogUtil.e("点击了 创建一个学员群 ");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, oneStudGroup);
                        SystemClock.sleep(NumberUtils.getRandom1000() + 2000);
                    }
                }
                clickThreePos(taskBean, peopleNameList, groupName, announcement, groupCount, companyname);
            } else {
                LogUtil.e("没找到 创建一个学员群 文字 找 创建一个客户群");
                List<AccessibilityNodeInfo> createOneClientGroups = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("创建一个客户群");
                if (createOneClientGroups != null) {
                    if (!createOneClientGroups.isEmpty() && createOneClientGroups.size() > 0) {
                        for (AccessibilityNodeInfo oneClientGroup : createOneClientGroups) {
                            if (oneClientGroup.getText().toString().equals("创建一个客户群")) {
                                LogUtil.e("点击了 创建一个客户群 ");
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, oneClientGroup);
                                SystemClock.sleep(NumberUtils.getRandom1000() + 2000);
                            }
                        }
                        clickThreePos(taskBean, peopleNameList, groupName, announcement, groupCount, companyname);
                    } else {
                        LogUtil.e("没找到 创建一个客户群 文字");
                    }
                } else {
                    LogUtil.e("createOneClientGroups 为空了！");
                }
            }
        } else {
            LogUtil.e("createOneStudGroups 为空了！");
        }
    }

    private void clickThreePos(TaskBean taskBean, List<String> peopleNameList, String groupName, String announcement, int groupCount, String companyname) {
        LogUtil.e("点击群聊中右上角的三个点");
        String[] strings = new String[1];
        strings[0] = Views.TextView;
        AccessibilityNodeInfo root = weworkService.getRootInActiveWindow();
        for (AccessibilityWindowInfo window : weworkService.getWindows()) {
            if (window.getRoot() != null) {
                root = window.getRoot();
            } else {
                LogUtil.e("根节点检测： 检测为空");
            }
        }
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(root, strings);
        if (allByClazz != null) {
            boolean isFindPoint = false;
            for (AccessibilityNodeInfo threePoint : allByClazz) {
                Rect rect = new Rect();
                threePoint.getBoundsInScreen(rect);
                if ((rect.left >= 620 && rect.left <= 628) && (rect.top >= 47 && rect.top <= 51) && (rect.right >= 718 && rect.right <= 722) && (rect.bottom >= 143 && rect.bottom <= 147)) {
                    LogUtil.e("根据坐标值 找到右上角的三个点 开始点击");
                    AccessibilityUtil.INSTANCE.performClick(threePoint, true);
                    isFindPoint = true;
                    break;
                }
            }
            LogUtil.e("群聊中右上角的三个点 寻找：" + isFindPoint);
        }
        groupName = groupName + "#" + dateFormat.format(new Date()) + "_" + groupCount;
//        AccessibilityUtil.INSTANCE.clickByNode(weworkService, 627, 97);
        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
        //这里插入修改群名
        inputGroupName(taskBean, groupName);
        //这里再插入设置群公告
        if (!TextUtils.isEmpty(announcement)) {
            setAnnouncement(taskBean, announcement);
        } else {
            LogUtil.e("群公告内容为空！！");
        }
        //点击加号 拉人
        LogUtil.e("点击+号键拉人");
        AccessibilityUtil.INSTANCE.clickByNode(weworkService, 230, 395);
        SystemClock.sleep(NumberUtils.getRandom1000());
        //这一步 在选择联系人 界面去点放大镜
        AddGroupKt.clickBigGlass(peopleNameList, taskBean, 0, groupCount, companyname);
    }

    /**
     * @author lkj
     * @date 2024/3/20 17:18
     * @desc 设置群名称
     */
    private void inputGroupName(TaskBean taskBean, String groupName) {
        LogUtil.e("进入设置群名的方法中");
        List<AccessibilityNodeInfo> noSetNames = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("未设置群名");
        if (noSetNames != null) {
            if (!noSetNames.isEmpty() && noSetNames.size() > 0) {
                for (AccessibilityNodeInfo noSetName : noSetNames) {
                    if (!TextUtils.isEmpty(noSetName.getText())) {
                        if (noSetName.getText().toString().equals("未设置群名")) {
                            LogUtil.e("点击了 未设置群名 ");
                            AccessibilityUtil.INSTANCE.performClick(noSetName, true);
                            SystemClock.sleep(NumberUtils.getRandom1000());
                        }
                    } else {
                        LogUtil.e("noSetName.getText() 为空了！");
                    }
                }
            } else {
                LogUtil.e("noSetNames.size() < 0 ");
            }
        } else {
            LogUtil.e("noSetNames 为空了！");
        }
        String[] strings = new String[1];
        strings[0] = Views.EditText;
        AccessibilityNodeInfo inputGroupName = AccessibilityUtil.INSTANCE.findOnceByClazz(GlobalMethodKt.getRootCopy(taskBean), strings);
        if (inputGroupName != null) {
            LogUtil.e("向输入框中输入群聊名字: " + groupName);
            Bundle arguments = new Bundle();
            arguments.putCharSequence(AccessibilityNodeInfo.ACTION_ARGUMENT_SET_TEXT_CHARSEQUENCE, groupName);
            inputGroupName.performAction(AccessibilityNodeInfo.ACTION_SET_TEXT, arguments);
            SystemClock.sleep(NumberUtils.getRandom1000());
        } else {
            LogUtil.e("inputGroupNames 为空了！");
        }
        //输入完名字点击 确定按钮
        List<AccessibilityNodeInfo> confirmBtn = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("确定");
        if (confirmBtn != null) {
            if (!confirmBtn.isEmpty() && confirmBtn.size() > 0) {
                for (AccessibilityNodeInfo conBtn : confirmBtn) {
                    if (conBtn.getText().equals("确定")) {
                        AccessibilityUtil.INSTANCE.clickByNodeCopy(weworkService, conBtn);
                        LogUtil.e("设置群聊名字成功: " + groupName);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
            } else {
                LogUtil.e("没找到 确定 文字");
            }
        } else {
            LogUtil.e("confirmBtn 为空了！");
        }
    }

    /**
     * @author lkj
     * @date 2024/3/20 17:18
     * @desc 设置群公告
     */
    private void setAnnouncement(TaskBean taskBean, String announcement) {
        List<AccessibilityNodeInfo> noSetAnnouncements = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("群公告");
        if (noSetAnnouncements != null) {
            if (!noSetAnnouncements.isEmpty() && noSetAnnouncements.size() > 0) {
                for (AccessibilityNodeInfo noSetAnnouncement : noSetAnnouncements) {
                    if (noSetAnnouncement.getText().toString().equals("群公告")) {
                        LogUtil.e("点击了 群公告 ");
                        AccessibilityUtil.INSTANCE.performClick(noSetAnnouncement, true);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
            }
        }
        String[] strings = new String[1];
        strings[0] = Views.EditText;
        AccessibilityNodeInfo inputGroupAnnouncement = AccessibilityUtil.INSTANCE.findOnceByClazz(GlobalMethodKt.getRootCopy(taskBean), strings);
        if (inputGroupAnnouncement != null) {
            LogUtil.e("向输入框中输入群公告: " + announcement);
            Bundle arguments = new Bundle();
            arguments.putCharSequence(AccessibilityNodeInfo.ACTION_ARGUMENT_SET_TEXT_CHARSEQUENCE, announcement);
            inputGroupAnnouncement.performAction(AccessibilityNodeInfo.ACTION_SET_TEXT, arguments);
            SystemClock.sleep(NumberUtils.getRandom1000());
        } else {
            LogUtil.e("inputGroupNames 为空了！");
        }
        //输入完公告点击 发布按钮
        List<AccessibilityNodeInfo> publishs = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("发布");
        if (publishs != null) {
            if (!publishs.isEmpty() && publishs.size() > 0) {
                for (AccessibilityNodeInfo publish : publishs) {
                    if (publish.getText().equals("发布")) {
                        AccessibilityUtil.INSTANCE.clickByNodeCopy(weworkService, publish);
                        LogUtil.e("设置群公告: " + announcement);
                        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                        break;
                    }
                }
            } else {
                LogUtil.e("没找到 发布 文字");
            }
        } else {
            LogUtil.e("confirmBtn 为空了！");
        }
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(GlobalMethodKt.getRootCopy(taskBean), new String[]{Views.TextView});
        if (allByClazz != null) {
            if (!allByClazz.isEmpty() && allByClazz.size() > 0) {
                boolean isHave = false;
                for (AccessibilityNodeInfo textNode : allByClazz) {
                    if (!TextUtils.isEmpty(textNode.getText())) {
                        if (textNode.getText().toString().equals("该公告会通知全部群成员，是否发布？")) {
                            isHave = true;
                            break;
                        }
                    }
                }
                if (isHave) {
                    for (AccessibilityNodeInfo textNode : allByClazz) {
                        if (!TextUtils.isEmpty(textNode.getText())) {
                            if (textNode.getText().toString().equals("发布")) {
                                AccessibilityUtil.INSTANCE.performClick(textNode, true);
                                LogUtil.e("这里点击了弹框 发布公告 按钮");
                                SystemClock.sleep(NumberUtils.getRandom1000());
                                break;
                            }
                        }
                    }
                }
            } else {
                LogUtil.e("allByClazz 为空了！");
            }
        } else {
            LogUtil.e("allByClazz 为空了！");
        }
    }

}
