package com.kuxuan.autoclick.service;

import com.google.gson.Gson;
import com.kuxuan.autoclick.model.GroupUpLoadBean;
import com.kuxuan.autoclick.net.callback.ResultCallBack;
import com.kuxuan.autoclick.net.request.AccessPresenter;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.StringSort;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * @author lkj
 * @date 2024/2/5 14:00
 * @desc 检查 或者 上传群名
 */
public class CheckOrUpLoadGroup {
    private static CheckOrUpLoadGroup checkOrUpLoadGroup;

    public static CheckOrUpLoadGroup getInstance() {
        if (checkOrUpLoadGroup == null) {
            synchronized (CheckOrUpLoadGroup.class) {
                if (checkOrUpLoadGroup == null) {
                    checkOrUpLoadGroup = new CheckOrUpLoadGroup();
                }
            }
        }
        return checkOrUpLoadGroup;
    }

    /**
     * @author lkj
     * @date 2024/2/6 16:35
     * @desc 创建请求实体并上传
     */
    public void createJson(GroupUpLoadBean upLoadBean) {
        LogUtil.e("upLoad: " + upLoadBean.toString());
        String toJson = new Gson().toJson(upLoadBean.getGroup_list());
        Map<String, Object> map = new HashMap<>();
        List<Map<String, Object>> mapList = new ArrayList<>();
        for (GroupUpLoadBean.GroupListBean groupListBean : upLoadBean.getGroup_list()) {
            Map<String, Object> mapSub = new HashMap<>();
            mapSub.put("owner", groupListBean.getOwner());
            mapSub.put("groupName", groupListBean.getGroupName());
            mapList.add(mapSub);
        }
        String device_id = upLoadBean.getDevice_id();
        String corpid = upLoadBean.getCorpid();
        String user_name = upLoadBean.getUser_name();
        map.put("device_id", device_id);
        map.put("corpid", corpid);
        map.put("user_name", user_name);
        map.put("group_list", toJson);
        String sortKey = StringSort.sortKey(map);
        AccessPresenter.getInstance().receiveCreateChatGroupData(device_id, corpid, user_name, toJson, sortKey, new ResultCallBack<String>() {
            @Override
            public void success(String result) {
                LogUtil.e("上传 群名 返回结果：" + result);
            }

            @Override
            public void fail(String error) {
                LogUtil.e("上传 群名 返回结果：" + error);
            }

            @Override
            public void requestComplete() {

            }
        });
    }
}
