package com.kuxuan.autoclick.service;

import android.accessibilityservice.AccessibilityService;
import android.os.SystemClock;
import android.view.accessibility.AccessibilityNodeInfo;

import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;
import com.kuxuan.autoclick.utils.StringUtils;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author lkj
 * @date 2024/2/18 15:22
 * @desc 朋友圈消息发送流程
 */
public class FriendSendJava {
    public static SimpleDateFormat addGroupDateFormat = new SimpleDateFormat("MMdd");
    private static SimpleDateFormat dateFormat = new SimpleDateFormat("MM月dd日");

    public static void startFriendSend(TaskBean taskBean) {
        AccessibilityNodeInfo nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
        List firendCricles = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("朋友圈") : null;
        if (firendCricles != null && !firendCricles.isEmpty() && firendCricles.size() > 0) {
            LogUtil.e("在工作台中 点击一下朋友圈");
            if (!taskBean.isLive()) {
                LogUtil.e("任务取消 " + GroupSendImplKt.getDafor().format(taskBean.getId()) + ' ' + taskBean.isLive());
                WeworkController.INSTANCE.getWeworkService().taskList.remove(taskBean);
                return;
            }

            AccessibilityUtil.INSTANCE.clickByNodeInScreen((AccessibilityService) WeworkController.INSTANCE.getWeworkService(), (AccessibilityNodeInfo) firendCricles.get(0));
            SystemClock.sleep(NumberUtils.getRandom1000());
            clickToSend(taskBean);
        } else {
            GroupSendImplKt.showToast("没有找到朋友圈");
            LogUtil.e("返回首页");
            GroupSendImplKt.returnHome(taskBean, 0);
            GroupSendImplKt.isHaveCompany(3, taskBean);
        }
    }

    public static void clickToSend(TaskBean taskBean) {
        if (!taskBean.isLive()) {
            LogUtil.e("任务取消 " + GroupSendImplKt.getDafor().format(taskBean.getId()) + ' ' + taskBean.isLive());
            WeworkController.INSTANCE.getWeworkService().taskList.remove(taskBean);
        } else {
            AccessibilityNodeInfo nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
            List friendMsg1 = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("条内容待你发表") : null;
            nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
            List friendMsg2 = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("管理员通知你发表朋友圈") : null;
            if (friendMsg1 != null && !friendMsg1.isEmpty() && friendMsg1.size() > 0) {
                LogUtil.e("点击：条内容待你发表");
                AccessibilityUtil.INSTANCE.clickByNodeInScreen((AccessibilityService) WeworkController.INSTANCE.getWeworkService(), (AccessibilityNodeInfo) friendMsg1.get(0));
                SystemClock.sleep(NumberUtils.getRandom1000() + (long) 1000);
                findFriendMsgNum(taskBean);
            } else if (friendMsg2 != null && !friendMsg2.isEmpty() && friendMsg2.size() > 0) {
                LogUtil.e("点击：管理员通知你发表朋友圈");
                AccessibilityUtil.INSTANCE.clickByNodeInScreen((AccessibilityService) WeworkController.INSTANCE.getWeworkService(), (AccessibilityNodeInfo) friendMsg2.get(0));
                SystemClock.sleep(NumberUtils.getRandom1000());
                findFriendMsgNum(taskBean);
            } else {
                LogUtil.e("没有需要发表的消息 结束！");
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
                GroupSendImplKt.isHaveCompany(3, taskBean);
            }

        }
    }

    public static void findFriendMsgNum(TaskBean taskBean) {
        if (!taskBean.isLive()) {
            LogUtil.e("任务取消 " + GroupSendImplKt.getDafor().format(taskBean.getId()) + ' ' + taskBean.isLive());
            WeworkController.INSTANCE.getWeworkService().taskList.remove(taskBean);
        } else {
            AccessibilityNodeInfo nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
            List title = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("待你发表的·") : null;
            if (title != null && !title.isEmpty() && title.size() > 0) {
                StringBuilder stringBuilder = (new StringBuilder()).append("找到了 待你发表的  ");
                Object var10001 = title.get(0);
                LogUtil.e(stringBuilder.append(((AccessibilityNodeInfo) var10001).getText().toString()).toString());
                Object var4 = title.get(0);
                int pointLaterNumber = StringUtils.getPointLaterNumber(((AccessibilityNodeInfo) var4).getText().toString());
                LogUtil.e("直接点击发表按钮  " + pointLaterNumber);
                clickPublishButton(pointLaterNumber, taskBean);
                LogUtil.e("发表完毕 返回首页 结束任务");
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
                GroupSendImplKt.isHaveCompany(3, taskBean);
            } else {
                LogUtil.e("没找到标题");
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
                GroupSendImplKt.isHaveCompany(3, taskBean);
            }

        }
    }

    public static void clickPublishButton(int pointLaterNumber, TaskBean taskBean) {
        int var2 = 0;

        for (int var3 = pointLaterNumber; var2 < var3; ++var2) {
            AccessibilityNodeInfo nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
            List goPublish417 = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("发表") : null;
            if (goPublish417 != null) {
                boolean goPublish1 = goPublish1(goPublish417);
                if (!goPublish1) {
                    break;
                }
            } else {
                LogUtil.e("没找到 发表 两个字");
            }
        }

    }

    public static boolean goPublish1(List goPublish) {
        if (goPublish.size() > 0) {
            Iterator var2 = goPublish.iterator();

            while (var2.hasNext()) {
                AccessibilityNodeInfo goPublishb = (AccessibilityNodeInfo) var2.next();
                if (goPublishb.getText().equals("发表")) {
                    boolean checkPublishTime = checkPublishTime(goPublishb);
                    if (checkPublishTime) {
                        LogUtil.e((new StringBuilder()).append("点击朋友圈发送按钮 ").append(goPublishb.getText()).toString());
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen((AccessibilityService) WeworkController.INSTANCE.getWeworkService(), goPublishb);
                        SystemClock.sleep(NumberUtils.getRandom1000() + (long) 1000);
                        return checkPublishTime;
                    }

                    LogUtil.e("朋友圈消息已经过期了！！");
                    return checkPublishTime;
                }

                LogUtil.e((new StringBuilder()).append("不被点击的文字是  ").append(goPublishb.getText()).toString());
            }
        }

        return true;
    }

    public static boolean checkPublishTime(AccessibilityNodeInfo goPublishb) {
        AccessibilityNodeInfo parent = goPublishb.getParent().getParent().getParent().getParent();
        AccessibilityNodeInfo child = parent.getChild(2).getChild(0);
        LogUtil.e("当前朋友圈的时间：" + child.getText().toString());
        if (child.getText().toString().contains(dateFormat.format(new Date()))) {
            return true;
        }
        return false;
    }
}
