package com.kuxuan.autoclick.service

import android.annotation.SuppressLint
import android.graphics.Rect
import android.os.SystemClock
import android.text.TextUtils
import android.view.accessibility.AccessibilityNodeInfo
import android.widget.Toast
import com.blankj.utilcode.util.ThreadUtils.runOnUiThread
import com.kuxuan.autoclick.model.Constant
import com.kuxuan.autoclick.model.MainBean
import com.kuxuan.autoclick.model.TaskBean
import com.kuxuan.autoclick.model.add_people_into_group.GroupBean
import com.kuxuan.autoclick.model.groupsend.CompanyBean
import com.kuxuan.autoclick.net.OutGroupCustomNet
import com.kuxuan.autoclick.net.OutGroupReturnTargetNet
import com.kuxuan.autoclick.net.RealTimeAddGroupNet
import com.kuxuan.autoclick.service.WeworkController.weworkService
import com.kuxuan.autoclick.utils.*
import org.greenrobot.eventbus.EventBus
import java.lang.Thread.sleep
import java.text.SimpleDateFormat

val dafor = SimpleDateFormat("yyyy-MM-dd HH:mm:ss")

/**
 * @auth lkj
 * @Date 2023/5/26 10:14
 * @Describe 判断当前界面是否在企业微信App内，在的话直接开始执行模拟点击操作，否则回到主屏幕找到企业微信模拟点击进入
 */
@SuppressLint("NewApi")
fun isAtApp(taskBean: TaskBean) {
    if (isAtHome(taskBean)) {
        LogUtil.e("在首页中")
        /**
         * @auth lkj
         * @Date 2023/6/1 14:12·
         * @Describe 暂时注释群发功能 使用时需打开
        023/6/6 17:40 lkj 已打开
         */
        if (taskBean.isLive) {
            LogUtil.e("走进了执行！！")
            sendMessage(taskBean, 0)
        } else {
            weworkService.taskList.remove(taskBean)
        }
    } else {
        LogUtil.e("不在首页中")
        if (weworkService.currentPackage.equals(Constant.PACKAGE_NAMES)) {
            LogUtil.e("在企业微信里")
            if (weworkService.currentClass.equals(Constant.MESSAGE_MAIN_UI)) {
                //在消息界面
                LogUtil.e("在消息界面")
                sendMessage(taskBean, 0)
            } else {
                //对界面进行判断
                val workStatus = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText("选择工作身份")
                LogUtil.e("找一下 是否有 选择工作身份")
                if (workStatus != null && workStatus.size > 0) {
                    LogUtil.e("有 选择工作身份")
                    toWorkStatus(taskBean)
                } else {
                    LogUtil.e("没有 选择工作身份")
                    LogUtil.e("返回首页")
                    returnHome(taskBean, 0)
                    //如果还有企业没有查看 就继续查看
                    sendMessage(taskBean, 0)
                }
            }
        } else {
            LogUtil.e("不在在企业微信里")
//            clickScreenApp(taskBean)
            getRootCopy(taskBean)
        }
    }
}

fun sendMessage(taskBean: TaskBean, count: Int) {
    if (isAtHome(taskBean)) {
        LogUtil.e("执行切换企业")
        switchCompany(true, taskBean)
    } else {
        //检查当前页面中是否有返回箭头 有就点击返回
        val friendBack = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText("待你发表的·")
        val workStatus = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText("选择工作身份")
        val isLogin = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText("已阅读并同意 软件许可及服务协议 和 隐私政策")
        if (workStatus != null && !workStatus.isEmpty() && workStatus.size > 0) {
            toWorkStatus(taskBean)
            return
        } else {
            LogUtil.e("任务标识 全部设置 false")
            setFalse()
        }
        if (friendBack != null && friendBack.isEmpty() && friendBack.size > 0) {
            LogUtil.e("返回首页")
            returnHome(taskBean, 0)
            return
        } else {
            LogUtil.e("任务标识 全部设置 false")
            setFalse()
        }
        if (isLogin != null && isLogin.isEmpty() && isLogin.size > 0) {
            runOnUiThread(Runnable {
                showToast("企业微信已退出登录，请重新登陆！")
            })
            return
        } else {
            LogUtil.e("任务标识 全部设置 false")
            setFalse()
        }
        LogUtil.e("不在首页，不去切换企业")
        if (count >= 10) {
            LogUtil.e("执行了 10 次切换企业 没成功！")
            LogUtil.e("任务标识 全部设置 false")
            setFalse()
        } else {
            sendMessage(taskBean, count + 1)
        }
    }
}

/**
 * 需要选择工作身份时 选择其中一个进入主界面
 */
@SuppressLint("NewApi")
fun toWorkStatus(taskBean: TaskBean) {
    //需要选择工作身份时 选择其中一个进入主界面
    LogUtil.e("选择工作身份")
    val workStatusList413 = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText("选择工作身份")
    if (workStatusList413 != null) {
        selectWorkStatus(workStatusList413, taskBean)
    } else {
        LogUtil.e("任务标识 全部设置 false")
        setFalse()
    }
}

fun selectWorkStatus(workStatusList: List<AccessibilityNodeInfo>, taskBean: TaskBean) {
    if (!workStatusList.isEmpty() && workStatusList.size > 0) {
        //点击一个工作身份进入
        AccessibilityUtil.clickByNode(weworkService, 246, 310)
        LogUtil.e("点击工作工作身份列表")
        sleep(NumberUtils.getRandom1000())
        val goInto = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText("进入")
        if (goInto != null && !goInto.isEmpty() && goInto.size > 0) {
            //点击一个工作身份进入
            if (!taskBean.isLive) {
                LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
                weworkService.taskList.remove(taskBean)
                return
            }
            AccessibilityUtil.clickByNodeInScreen(weworkService, goInto.get(0))
            LogUtil.e("点击工作身份")
            sleep(NumberUtils.getRandom1000())
            sendMessage(taskBean, 0)
        } else {
            LogUtil.e("任务标识 全部设置 false")
            setFalse()
        }
    } else {
        LogUtil.e("任务标识 全部设置 false")
        setFalse()
    }
}

/**
 * @Date 2023/5/31 18:43
 * @Describe 切换企业
 */
var groupList: List<GroupBean> = ArrayList()
fun switchCompany(isJump: Boolean, taskBean: TaskBean) {
    if (taskBean.isLive) {
        if (getWindow(0) != null) {
            val workTai = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText("工作台")
            if (workTai != null) {
                findWorkTai(workTai, isJump, taskBean)
            } else {
                showToast("未找到 工作台")
                LogUtil.e("任务标识 全部设置 false")
                setFalse()
            }
        } else {
            LogUtil.e("任务标识 全部设置 false")
            setFalse()
        }
    } else {
        weworkService.taskList.remove(taskBean)
    }
}

fun getWindow(findCount: Int): AccessibilityNodeInfo? {
    var rootInActiveWindow = weworkService.rootInActiveWindow
    for (window in weworkService.windows) {
        if (!ScreenUtil.isScreenOn(weworkService)) {
            LogUtil.e("判断当前屏幕是黑屏状态，重新唤醒一下")
            ScreenUtil.wakeAndUnlock(weworkService, true)
            SystemClock.sleep(1000)
        }
        if (window.root != null) {
            rootInActiveWindow = window.root
        } else {
            LogUtil.e("根节点检测： 检测为空")
        }
    }
    if (rootInActiveWindow != null) {
        return rootInActiveWindow
    } else {
        if (findCount >= 5) {
            LogUtil.e("这里获取为null了！ $findCount")
            LogUtil.e("任务标识 全部设置 false")
            setFalse()
            return null
        } else {
            sleep(1000)
            LogUtil.e("寻找次数： $findCount")
            return getWindow(findCount + 1)
        }
    }
}

/**
 * @auth lkj
 * @Date 2023/7/17 18:22
 * @Describe 寻找工作台 判断位置 抽屉状态是否开启或关闭
 */
var checkCount: Int = 0;
fun findWorkTai(workTai: List<AccessibilityNodeInfo>, isJump: Boolean, taskBean: TaskBean) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    if (!workTai.isEmpty() && workTai.size > 0) {
        checkCount = 0
        val rect = Rect()
        workTai.get(0).getBoundsInScreen(rect)
        LogUtil.e("找到工作台文字 " + rect.left + "   " + rect.right)
        if (rect.left < 600) {
            waitTime()
//            AccessibilityUtil.scrollByXY(weworkService, 100, 1000, 400, 0)
//            sleep(NumberUtils.getRandom1000())
//            LogUtil.e("关闭状态向右滑动一下")
            findCompany(isJump, taskBean)
        } else {
            LogUtil.e("打开状态直接选择主体")
            waitTime()
            findCompany(isJump, taskBean)
        }
    } else {
        LogUtil.e("没有找到工作台的文字")
        LogUtil.e("任务标识 全部设置 false")
        setFalse()
    }
}

/**
 * 等待时间
 */
fun waitTime() {
    if (Constant.sendGroupIsRuning) {
        val seek_bar = SPUtils.getInstance().getInt("seek_bar", 10)
        if (seek_bar != 0) {
            StringUtils.setMessageData("等待", 40, seek_bar)
            sleep((seek_bar * 1000).toLong())
        }
        if (!ScreenUtil.isScreenOn(weworkService)) {
            LogUtil.e("判断当前屏幕是黑屏状态，重新唤醒一下")
            ScreenUtil.wakeAndUnlock(weworkService, true)
            SystemClock.sleep(1000)
        }
    }
}

/**
 * @auth lkj
 * @Date 2023/6/29 17:05
 * @Describe 遍历 查找企业名称
 */
fun findCompany(isJump: Boolean, taskBean: TaskBean) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    LogUtil.e("isJump: " + isJump)
    if (isJump) {
        //遍历企业列表
        seeCompanyList(taskBean)
    }
    LogUtil.e("当前索引：${Constant.listIndex}   可用主体名数量：${weworkService.canUserCompanyNameList.size}")
    if (weworkService.canUserCompanyNameList != null && !weworkService.canUserCompanyNameList.isEmpty() && weworkService.canUserCompanyNameList.size > 0) {
        //判断索引是否小于现有企业数量
        if (Constant.listIndex < weworkService.canUserCompanyNameList.size) {
            //按顺序获取列表中的一个企业
            val companyListBean = weworkService.canUserCompanyNameList.get(Constant.listIndex)
            LogUtil.e("取出 " + companyListBean.companyName)//^(?!.*(gralloc4)).*$
            Constant.currCompany = companyListBean.companyName
            Constant.corpid = companyListBean.corpid
            LogUtil.e("取出 的主体id：" + Constant.corpid)
            SPUtils.getInstance().put("currCompany", companyListBean.companyName)
            getCurrUserName(companyListBean)
            //头像右边获取当前企业
            if (companyListBean != null && !TextUtils.isEmpty(companyListBean.companyName)) {
                findNodeInfo4(companyListBean, taskBean, 0)
            } else {
                LogUtil.e("没找到 ${companyListBean.companyName}")
            }
        } else {
            LogUtil.e("索引 大于 现有企业数量了 ${Constant.listIndex}  ${weworkService.canUserCompanyNameList.size}")
            isLoop(taskBean)
        }
    } else {
        LogUtil.e("没有符合要求的企业，返回到主页面 ${Constant.friendSendIsRuning}")
        isLoop(taskBean)
        //返回到主页面
    }
}

/**
 * 获取当前的用户名
 */
fun getCurrUserName(companyBean: CompanyBean) {
    val userNames = AccessibilityUtil.findAllByClazz(getWindow(0), Views.TextView)
    LogUtil.e("二次检测当前用户名")
    for (userName in userNames) {
        if (!TextUtils.isEmpty(userName.text)) {
            var rect = Rect()
            userName.getBoundsInScreen(rect)
            //[192,122][272,176]
            if ((rect.top >= 122 && rect.top <= 128) && (rect.bottom >= 173 && rect.bottom <= 179)) {
                Constant.currUser = userName.text.toString()
                SPUtils.getInstance().put("currUser", userName.text.toString())
//                LogUtil.e("当前用户名：${Constant.currUser}")
            }
            //[192,183][348,219]
            if ((rect.top >= 180 && rect.top <= 185) && (rect.bottom >= 217 && rect.bottom <= 221)) {
                Constant.currCompany = userName.text.toString()
                SPUtils.getInstance().put("currCompany", userName.text.toString())
                StringUtils.setMessageData("当前主体《" + userName.text.toString() + "》", 20, 0)
            }
        }
    }
    if (Constant.sendGroupIsRuning) {
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 群发消息")
    } else if (Constant.addGroupIsRuning) {
        for (groupBean in companyBean.groupBeans) {
            LogUtil.e("群聊名字：" + groupBean.groupName)
            LogUtil.e("人数：" + weworkService.testNameList.size)
        }
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 邀请入群")
    } else if (Constant.friendSendIsRuning) {
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 朋友圈群发")
    } else if (Constant.isShareToColleague) {
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 共享联系人")
    } else if (Constant.isAddShareClient) {
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 添加共享联系人")
    } else if (Constant.isOneWayFriend) {
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 单向好友")
    } else if (Constant.isLeaderCreateGroup) {
        for (groupBean in weworkService.groupBeans) {
            LogUtil.e("群聊名字：" + groupBean.groupName)
        }
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 群主建群")
    } else if (Constant.isOutGroupCustomReturn) {
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 退群用户补拉")
    } else if (Constant.isRealTimeAddGroup) {
        LogUtil.e("当前用户名：${Constant.currUser}  ${Constant.currCompany} 实时邀请入群")
    }
}

fun findNodeInfo4(companyBean: CompanyBean, taskBean: TaskBean, count: Int) {
//    companyListBean.companyName = "杭州众课五常"
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    if (!TextUtils.isEmpty(companyBean.companyName)) {
        if (getWindow(0) != null) {
            val findNames = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText(companyBean.companyName)
            if ((findNames != null && !findNames.isEmpty() && findNames.size > 0)) {
                LogUtil.e("判断取出的企业和当前企业是否相等 " + companyBean.companyName)
                var selectNames = mutableListOf<AccessibilityNodeInfo>()
                selectNames.clear()
                for (i in 0 until findNames.size) {
                    LogUtil.e("遍历 查找到的所有主体名字： ${findNames.get(i).text}")
                    //先筛选出来
                    if (findNames.get(i).text.equals(companyBean.companyName)) {
                        LogUtil.e("符合名字条件的主体： ${findNames.get(i).text}")
                        selectNames.add(findNames.get(i))
                    }
                }
                if (selectNames.size == 0) {
                    LogUtil.e("名字没有 合适的公司 ")
                    Constant.listIndex++
                    switchCompany(false, taskBean)
                } else if (selectNames.size == 1) {
                    LogUtil.e("符合条件的一个主体：${selectNames.get(0).text}")
                    val rect = Rect()
                    selectNames.get(0).getBoundsInScreen(rect)

                    //					if (rect.bottom > 360 && rect.top < 1433) {
                    if (!taskBean.isLive) {
                        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
                        weworkService.taskList.remove(taskBean)
                        return
                    }
                    scrollToRight(taskBean)
                    StringUtils.setMessageData("当前主体《" + companyBean.companyName + "》", 20, 0)
                    AccessibilityUtil.performClick(selectNames.get(0), true)
                    LogUtil.e("点击了：" + companyBean.companyName)
                    //这里 做一个不同客服名的兼容 再打开侧边栏检测一次 当前用户是谁
//                    LogUtil.e("右划 再打开侧边栏检测一次 当前用户是谁")
                    sleep(NumberUtils.getRandom1000())
//                    AccessibilityUtil.scrollByXY(weworkService, 100, 1000, 400, 0)
//                    sleep(NumberUtils.getRandom1000())
                    getCurrUserName(companyBean)
//                    LogUtil.e("左划 关闭侧边栏")
//                    AccessibilityUtil.scrollByXY(weworkService, 500, 1000, -400, 0)
//                    sleep(NumberUtils.getRandom1000())
                    waitTime()
                    toRunWhere(taskBean, companyBean, 0)
                } else if (selectNames.size == 2) {
                    LogUtil.e("相等的话 直接左滑 去执行任务")
                    if (!taskBean.isLive) {
                        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
                        weworkService.taskList.remove(taskBean)
                        return
                    }
//                    AccessibilityUtil.scrollByXY(weworkService, 500, 1000, -400, 0)
//                    sleep(NumberUtils.getRandom1000())
                    //这里 做一个不同客服名的兼容 再打开侧边栏检测一次 当前用户是谁
//                    LogUtil.e("右划 再打开侧边栏检测一次 当前用户是谁")
//                    AccessibilityUtil.scrollByXY(weworkService, 100, 1000, 400, 0)
//                    sleep(NumberUtils.getRandom1000())
                    getCurrUserName(companyBean)
//                    LogUtil.e("左划 关闭侧边栏")
//                    AccessibilityUtil.scrollByXY(weworkService, 500, 1000, -400, 0)
//                    sleep(NumberUtils.getRandom1000())
                    //这里增加判断 是否在首页面 并且处于抽屉关闭的状态
                    if (getWindow(0) != null) {
                        val topLeftIcon413 = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText("消息")
                        if (topLeftIcon413 != null) {
                            topLeftIcon3(topLeftIcon413, taskBean, companyBean)
                        } else {
                            LogUtil.e("消息 寻找失败 全部设置 false")
                            LogUtil.e("任务标识 全部设置 false")
                            setFalse()
                        }
                    } else {
                        LogUtil.e("getWindow() = null 全部设置 false")
                        LogUtil.e("任务标识 全部设置 false")
                        setFalse()
                    }
                }
            } else {
                LogUtil.e("${companyBean.companyName}寻找失败 ")
                if (count > 3) {
                    LogUtil.e("3次都没找到 ${companyBean.companyName} 寻找失败 应该继续下一个主体")
                    Constant.listIndex++
                    findCompany(false, taskBean)
                } else {
                    sleep(1000)
                    findNodeInfo4(companyBean, taskBean, count + 1)
                }
            }
        } else {
            LogUtil.e("getWindow() = null 全部设置 false")
            LogUtil.e("任务标识 全部设置 false")
            setFalse()
        }
    } else {
        LogUtil.e("没找到 ${companyBean.companyName}")
        LogUtil.e("任务标识 全部设置 false")
        setFalse()
    }
}

/**
 * 向右滑动一下
 */
fun scrollToRight(taskBean: TaskBean) {
    LogUtil.e("右滑一次")
    AccessibilityUtil.scrollByXY(weworkService, 100, 1000, 400, 0)
    sleep(NumberUtils.getRandom1000() - 1000)
    LogUtil.e("判断右滑是否成功")
    val localWhere = OutGroupCustomReturn.getInstance().localWhereNode(taskBean, "日程")
    if (localWhere != null) {
        val rect = Rect()
        localWhere.getBoundsInScreen(rect)
        if (rect.left > 500) {
            LogUtil.e("右滑成功")
        } else {
            LogUtil.e("右滑不成功")
            scrollToRight(taskBean)
        }
    } else {

    }
}

/**
 * @auth lkj
 * @Date 2023/7/17 16:51
 * @Describe 在首页面 并且处于抽屉关闭的状态 直接执行任务
 */
fun topLeftIcon3(topLeftIcon: List<AccessibilityNodeInfo>, taskBean: TaskBean, companyBean: CompanyBean) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    if (!topLeftIcon.isEmpty() && topLeftIcon.size > 0) {
        val rect = Rect()
        topLeftIcon.get(0).getBoundsInScreen(rect)
        if (rect.left > 300) {
            LogUtil.e("在首页面 并且处于抽屉打开的状态 直接执行任务")
            AccessibilityUtil.scrollByXY(weworkService, 500, 1000, -400, 0)
            sleep(NumberUtils.getRandom1000())
        }
        toRunWhere(taskBean, companyBean, 0)
    }
}

/**
 * @auth lkj
 * @Date 2023/7/24 11:07
 * @Describe 寻找匹配的企业
 */
@SuppressLint("NewApi")
fun seeCompanyList(taskBean: TaskBean) {
    LogUtil.e("遍历企业列表")
    if (!taskBean.isLive) {
        LogUtil.e("GlobalMethod任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    if (weworkService.companyBeans != null && weworkService.companyBeans.size > 0) {
        for (companyBean in weworkService.companyBeans) {
            LogUtil.e("需要寻找的主体：${companyBean.companyName}")
        }
        for (companyBean in weworkService.companyBeans) {
            val companyName = companyBean.companyName
            if (!TextUtils.isEmpty(companyName)) {
                if (getWindow(0) != null) {
                    val findName = getWindow(0)?.findAccessibilityNodeInfosByText(companyName)
                    if (findName != null && !findName.isEmpty() && findName.size > 0) {
                        for (comName in findName) {
                            if (comName.text.toString().equals(companyName)) {
                                LogUtil.e("找到√ √ √ √：$companyName ")
                                var isContain = false;
                                for (companyBean in weworkService.canUserCompanyNameList) {
                                    if (companyBean.companyName.equals(companyName)) {
                                        LogUtil.e("列表里有重复的 主体名字")
                                        isContain = true;
                                    }
                                }
                                if (!isContain) {
                                    weworkService.canUserCompanyNameList.add(companyBean)
                                }
                            } else {
                                LogUtil.e("找到的主体不正确：${comName.text}")
                                continue
                            }
                        }
                        continue
                    }
                    LogUtil.e("没找到 × × × ×$companyName")
                }
            } else {
                LogUtil.e("企业名称为空了 $companyName")
                isLoop(taskBean)
            }
        }
    } else {
        //添加联系人单独处理 因为这个任务时不需要请求网络获取数据的
        if (Constant.isAddShareClient || Constant.isOneWayFriend) {
            val textViews = AccessibilityUtil.findAllByClazz(getWindow(0), Views.TextView)
            if (textViews != null) {
                if (!textViews.isEmpty() && textViews.size > 0) {
                    for (textView in textViews) {
                        val rect = Rect()
                        textView.getBoundsInScreen(rect)
                        if (rect.left == 148 && !textView.text.equals("创建/加入企业")) {
                            LogUtil.e("找的所有的TextView： 坐标 ${rect.left}   ${rect.right}    ${textView.text} ")
                            var companyBean = CompanyBean()
                            companyBean.companyName = textView.text.toString()
                            weworkService.canUserCompanyNameList.add(companyBean)
                        }
                    }
                } else {
                    LogUtil.e("textViews 没找打节点！！")
                }
            } else {
                LogUtil.e("textViews 为空了")
            }
        }
        LogUtil.e("找到可用企业名：")
    }
}

/**
 * @auth lkj
 * @Date 2023/7/17 14:02
 * @Describe 切换到工作台的界面
 */
fun toWorkPlate(clickName: String, taskBean: TaskBean, count: Int): Boolean {
    var success: Boolean = false
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
    }
    LogUtil.e("寻找 $clickName")
    val workPlates = AccessibilityUtil.findAllByClazz(getRootCopy(taskBean), Views.TextView)
    for (workPlate in workPlates) {
        if (!TextUtils.isEmpty(workPlate.text)) {
            LogUtil.e("打印所有 的text 节点： " + workPlate.text)
            if (workPlate.text.equals(clickName)) {
                AccessibilityUtil.performClick(workPlate)
                LogUtil.e("切换到了 $clickName")
                success = true
                break
            }
        }
    }
    return success
}

/**
 * @auth lkj
 * @Date 2023/7/17 14:27
 * @Describe 在工作台界面寻找元素 可以滚动寻找
 */
fun findText(str: String, str2: String, count: Int, taskBean: TaskBean, companyBean: CompanyBean) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    if (getWindow(0) != null) {
        val textManager1 = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText(str)
        val textManager2 = getRootCopy(taskBean)?.findAccessibilityNodeInfosByText(str2)
        if ((textManager1 != null && !textManager1.isEmpty() && textManager1.size > 0) || (textManager2 != null && !textManager2.isEmpty() && textManager2.size > 0)) {
            //			sleep(NumberUtils.getRandom1000())
            LogUtil.e("找到了$str  $str2")
            selectWhere(taskBean, 0, companyBean)
            return
        } else {
            if (!taskBean.isLive) {
                LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
                weworkService.taskList.remove(taskBean)
                return
            }
            if (count >= 4) {
                LogUtil.e("不找了$str   $str2 直接返回 执行下一个")
                LogUtil.e("返回首页")
                returnHome(taskBean, 0)
                isHaveCompany(3, taskBean)
            } else {
                LogUtil.e("没找到$str   $str2")
                //滚动再次寻找
                sleep(3000)
                //findText(str, str2, count + 1)
                toRunWhere(taskBean, companyBean, count + 1)
            }
            return
        }
    }
    return
}

fun toRunWhere(taskBean: TaskBean, companyBean: CompanyBean, findCount: Int) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    if (Constant.sendGroupIsRuning) {
        //这里加入切换到工作台
        val toWorkPlate = toWorkPlate("工作台", taskBean, 0)
        //		sleep(NumberUtils.getRandom1000())
        if (toWorkPlate) {
            selectWhere(taskBean, findCount, companyBean)
        } else {
            if (!weworkService.currentClass.equals(Constant.MESSAGE_MAIN_UI)) {
                LogUtil.e("当前不在主界面，需要返回才能切换工作台")
                LogUtil.e("返回首页")
                returnHome(taskBean, 0)
            }
            toRunWhere(taskBean, companyBean, findCount)
        }
    } else if (Constant.addGroupIsRuning) {
        selectWhere(taskBean, 0, companyBean)
    } else if (Constant.friendSendIsRuning) {
        //这里加入切换到工作台
        val toWorkPlate = toWorkPlate("工作台", taskBean, 0)
        if (toWorkPlate) {
            findText("客户联系与管理", "学员联系", findCount, taskBean, companyBean)
        } else {
            if (!weworkService.currentClass.equals(Constant.MESSAGE_MAIN_UI)) {
                LogUtil.e("当前不在主界面，需要返回才能切换工作台")
                LogUtil.e("返回首页")
                returnHome(taskBean, 0)
            }
            toRunWhere(taskBean, companyBean, findCount)
        }
    } else if (Constant.isShareToColleague || Constant.isAddShareClient) {
        //这里加入切换到通讯录
        val toWorkPlate = toWorkPlate("通讯录", taskBean, 0)
        //		sleep(NumberUtils.getRandom1000())
        if (toWorkPlate) {
            selectWhere(taskBean, findCount, companyBean)
        } else {
            if (!weworkService.currentClass.equals(Constant.MESSAGE_MAIN_UI)) {
                LogUtil.e("当前不在主界面，需要返回才能切换工作台")
                LogUtil.e("返回首页")
                returnHome(taskBean, 0)
            }
            toRunWhere(taskBean, companyBean, findCount)
        }
    } else if (Constant.isOneWayFriend) {
        Constant.listIndex++
        OneWayFriendUp.getInstance().findTxl(taskBean, 0)
    } else if (Constant.isLeaderCreateGroup) {
        for (groupBean in weworkService.groupBeans) {
            LogUtil.e("for循环开始群主建群！！")
            LeaderCreateGroup.getInstance().findGZT(taskBean, groupBean.groupName, groupBean.manager, 0)
        }
        loopRequest(6, taskBean)
    } else if (Constant.isOutGroupCustomReturn) {
        Constant.listIndex++
        val out_group_model = SPUtils.getInstance().getInt("out_group_model", 2)
        if (out_group_model == 1) {
            for (companyBean in weworkService.companyBeans) {
                if (companyBean.companyName.equals(companyBean.companyName)) {
                    val groupBeans = companyBean.groupBeans
                    for (groupBean in groupBeans) {
                        val peopleList = groupBean.people_list
                        for (people in peopleList) {
                            weworkService.testNameList.add(people.name)
                        }
                    }
                }
            }
            if (companyBean.owner_type == 1) {
                OutGroupCustomReturn.getInstance().findGZT(taskBean, companyBean, 0)
            } else {
                OutGroupCustomReturn.getInstance().findGroupList(taskBean, companyBean)
            }
        } else {
            OutFixGroupReturn.getInstance().findGroupList(taskBean, companyBean)
        }
        loopRequest(8, taskBean)
    } else if (Constant.isRealTimeAddGroup) {
        Constant.listIndex++
        RealTimeAddGroup.getInstance().firstMethod(taskBean, companyBean)
        loopRequest(9, taskBean)
    } else {
        LogUtil.e("哪条路子都走不通：send： " + Constant.sendGroupIsRuning + " add: " + Constant.addGroupIsRuning + " friend: " + Constant.friendSendIsRuning + " share: " + Constant.isShareToColleague + " addShare: " + Constant.isAddShareClient + " groupLeader: " + Constant.isLeaderCreateGroup + " outGroupCustom: " + Constant.isOutGroupCustomReturn + " RealTimeAddGroup：" + Constant.isRealTimeAddGroup)
        LogUtil.e("任务标识 全部设置 false")
        setFalse()
    }
}

/**
 * @auth lkj
 * @Date 2023/6/8 14:33
 * @Describe 到底执行群发消息 还是 拉人入群 在此判断
 */
fun selectWhere(taskBean: TaskBean, findCount: Int, companyBean: CompanyBean) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    LogUtil.e("判断走哪个分支 " + Constant.sendGroupIsRuning + "  " + Constant.addGroupIsRuning + "  " + Constant.friendSendIsRuning + "  " + Constant.isShareToColleague + "  " + Constant.isAddShareClient + "  " + Constant.isOneWayFriend + "  " + Constant.isOutGroupCustomReturn + "  " + Constant.isRealTimeAddGroup)
    if (Constant.sendGroupIsRuning) {
        /**
         * @auth lkj
         * @Date 2023/7/17 14:57
         * @Describe 在工作台中 用文字的形式寻找元素
         */
        sleep(NumberUtils.getRandom1000() - 2000)
        Constant.listIndex++
        GroupSendJava.startGroupSend(taskBean, findCount)
    } else if (Constant.addGroupIsRuning) {
        Constant.listIndex++
        /**
         * @auth lkj
         * @Date 2023/6/5 17:49
         * @Describe 这里需要加入判断 判断该执行群发消息 还是拉人入群
         */
        //增加一个自动切换群聊的功能
        LogUtil.e("自动切换群聊")
        for (companyBean in weworkService.companyBeans) {
            if (companyBean.companyName.equals(companyBean.companyName)) {
                groupList = companyBean.getGroupBeans()
            }
        }
        for (companyBean in weworkService.companyBeans) {
            if (companyBean.companyName.equals(companyBean.companyName)) {
                val peopleList = companyBean.peopleList
                for (people in peopleList) {
                    weworkService.testNameList.add(people.name)
                }
            }
        }
        startAddFriendGroup(taskBean, companyBean)
    } else if (Constant.friendSendIsRuning) {
        Constant.listIndex++
        FriendSendJava.startFriendSend(taskBean)
    } else if (Constant.isShareToColleague) {
        Constant.listIndex++
        ShareStudent.getInstance().findKfOrXy(taskBean, 0, companyBean.companyName)
    } else if (Constant.isAddShareClient) {
        Constant.listIndex++
        AddClient.getInstance().findKfOrXy(taskBean, 0, companyBean.companyName)
    } else if (Constant.isOneWayFriend) {
        Constant.listIndex++
        OneWayFriendUp.getInstance().findTxl(taskBean, 0)
    } else if (Constant.isLeaderCreateGroup) {
        for (groupBean in weworkService.groupBeans) {
            LeaderCreateGroup.getInstance().findGZT(taskBean, groupBean.groupName, groupBean.manager, 0)
        }
        loopRequest(6, taskBean)
    } else if (Constant.isOutGroupCustomReturn) {
        Constant.listIndex++
        val out_group_model = SPUtils.getInstance().getInt("out_group_model", 2)
        if (out_group_model == 1) {
            for (companyBean in weworkService.companyBeans) {
                if (companyBean.companyName.equals(companyBean.companyName)) {
                    val groupBeans = companyBean.groupBeans
                    for (groupBean in groupBeans) {
                        val peopleList = groupBean.people_list
                        for (people in peopleList) {
                            weworkService.testNameList.add(people.name)
                        }
                    }
                }
            }
            if (companyBean.owner_type == 1) {
                OutGroupCustomReturn.getInstance().findGZT(taskBean, companyBean, 0)
            } else {
                OutGroupCustomReturn.getInstance().findGroupList(taskBean, companyBean)
            }
        } else {
            OutFixGroupReturn.getInstance().findGroupList(taskBean, companyBean)
        }
        loopRequest(8, taskBean)
    } else if (Constant.isRealTimeAddGroup) {
        Constant.listIndex++
        RealTimeAddGroup.getInstance().firstMethod(taskBean, companyBean)
        loopRequest(8, taskBean)
    } else {
        LogUtil.e("哪条路子都走不通：send： " + Constant.sendGroupIsRuning + "  " + Constant.addGroupIsRuning + "  " + Constant.friendSendIsRuning + "  " + Constant.isShareToColleague + "  " + Constant.isAddShareClient + "  " + Constant.isLeaderCreateGroup)
        LogUtil.e("任务标识 全部设置 false")
        setFalse()
    }
}

/**
 * @auth lkj
 * @Date 2023/6/6 14:37
 * @Describe 加入判断 自主返回到消息列表界面
 */
fun returnHome(taskBean: TaskBean, count: Int) {
    if (!isAtHome(taskBean)) {
        //40 108 60 128
        //0  84  49 145
        LogUtil.e("执行返回 ")
        if (weworkService.currentPackage.equals(Constant.PACKAGE_NAMES)) {
            Constant.retry = 0
            val builder = StringBuilder()
            var countadd = 0
            val findAllByClazz = AccessibilityUtil.findAllByClazz(weworkService.rootInActiveWindow, Views.TextView)
            for (byClazz in findAllByClazz) {
                if (byClazz.text != null) {
                    countadd++
                    builder.append(count.toString() + ". " + byClazz.text.toString() + "  ")
                }
            }
            if (builder.toString().contains("工作台") && builder.toString().contains("文档") && builder.toString().contains("通讯录")) {
                LogUtil.e("已经到达首界面！！")
            } else {
                AccessibilityUtil.scrollByXY(weworkService, 0, 1000, 400, 0)
                sleep(NumberUtils.getRandom1000())
                if (count >= 20) {
                    LogUtil.e("执行了 20 返回！不能再返回了")
                } else {
                    LogUtil.e("返回首页")
                    returnHome(taskBean, 0)
                }
            }
        }
    }
}

@SuppressLint("NewApi")
fun clickScreenApp(taskBean: TaskBean) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    val appNames = getWindow(0)?.findAccessibilityNodeInfosByText(Constant.APP_ICON_NAME)
    if (appNames != null && !appNames.isEmpty() && appNames.size > 0) {
        LogUtil.e("找到企业微信图标，点一下")
        for (appName in appNames) {
            if (appName.text != null && appName.text.equals(Constant.APP_ICON_NAME)) {
                var rect = Rect()
                appName.getBoundsInScreen(rect)
                AccessibilityUtil.performClick(appName, false)
                LogUtil.e("企业微信图标，点击完成: " + rect.left + "   " + rect.top)
                sleep(2000)
                if (weworkService.currentClass.equals(Constant.enterPrisemgr)) {
                    //重新点击企登录
                    toStatus(taskBean)
                }
            }
        }
    } else {
        showToast("未发现企业微信的图标")
    }
}

fun showToast(txt: String) {
    runOnUiThread(Runnable {
        LogUtil.e(txt)
        Toast.makeText(weworkService.context, txt, Toast.LENGTH_SHORT).show()
    })
}

/**
 * @auth lkj
 * @Date 2023/6/20 15:12
 * @Describe 是否还有企业需要检查 执行任务
 */
fun isHaveCompany(type: Int, taskBean: TaskBean) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    if (Constant.listIndex >= weworkService.canUserCompanyNameList.size) {
        Constant.listIndex = 0
        //当群发消息的任务执行完毕 将执行标签置位false
        Constant.currCompany = "";
        LogUtil.e("设置为false 我亚索贼溜 $type")
        loopRequest(type, taskBean)
        return
    }
    LogUtil.e("继续下一个企业")
    switchCompany(false, taskBean)
}

fun isLoop(taskBean: TaskBean) {
    if (!taskBean.isLive) {
        LogUtil.e("任务取消 ${dafor.format(taskBean.id)} ${taskBean.isLive}")
        weworkService.taskList.remove(taskBean)
        return
    }
    //返回到主页面
    AccessibilityUtil.scrollByXY(weworkService, 500, 1000, -400, 0)
    LogUtil.e("返回到主页面")
    if (Constant.sendGroupIsRuning) {
        LogUtil.e("执行拉人 进群任务")
        loopRequest(1, taskBean)
    } else if (Constant.addGroupIsRuning) {
        LogUtil.e("执行 退群用户重新补拉任务")
        loopRequest(2, taskBean)
    } else if (Constant.friendSendIsRuning) {
        LogUtil.e("执行 共享联系人任务")
        loopRequest(3, taskBean)
    } else if (Constant.isShareToColleague) {
        LogUtil.e("执行 添加联系人任务")
        loopRequest(4, taskBean)
    } else if (Constant.isAddShareClient) {
        LogUtil.e("执行 单向好友")
        loopRequest(5, taskBean)
    } else if (Constant.isOneWayFriend) {
        LogUtil.e("任务结束 全部设置false")
        loopRequest(6, taskBean)
    } else if (Constant.isLeaderCreateGroup) {
        LogUtil.e("任务结束 全部设置false")
        loopRequest(7, taskBean)
    } else if (Constant.isOutGroupCustomReturn) {
        LogUtil.e("执行朋友圈 群发任务")
        loopRequest(8, taskBean)
    } else if (Constant.isRealTimeAddGroup) {
        LogUtil.e("执行实时拉群 群发任务")
        loopRequest(9, taskBean)
    }
}

fun loopRequest(requestCount: Int, taskBean: TaskBean) {
    LogUtil.e("任务标识 全部设置 false")
    setFalse()
    LogUtil.e("返回首页")
    returnHome(taskBean, 0)
    if (requestCount == 1) {
        /**
         * @auth lkj
         * @Date 2023/9/1 15:19
         * @Describe 单独只执行群发 需要将拉人和朋友圈停止执行 @ K,需要的单独版本
         * 出完版本已经解除注释 并恢复三个功能同时存在
         */
        LogUtil.e("执行拉人任务")
        SelectMethod.getInstance().selectMethod2(taskBean)
    } else if (requestCount == 2) {
        val out_group_model = SPUtils.getInstance().getInt("out_group_model", 2)
        if (out_group_model == 1) {
            OutGroupCustomNet.getInstance().outGroupCustom(taskBean)
        } else {
            OutGroupReturnTargetNet.getInstance().outGroupReturnTarget(taskBean)
        }
    } else if (requestCount == 3) {
        LogUtil.e("执行共享联系人任务")
        SelectMethod.getInstance().selectMethod4(taskBean)
    } else if (requestCount == 4) {
        LogUtil.e("执行添加联系人任务")
        SelectMethod.getInstance().selectMethod5(taskBean)
    } else if (requestCount == 8) {
        LogUtil.e("执行朋友圈任务")
        SelectMethod.getInstance().selectMethod3(taskBean)
    } else if (requestCount == 9) {
        LogUtil.e("执行实时拉群任务")
        SelectMethod.getInstance().selectMethod6(taskBean)
    }
}

fun setFalse() {
    Constant.sendGroupIsRuning = false
    Constant.addGroupIsRuning = false
    Constant.friendSendIsRuning = false
    Constant.isShareToColleague = false
    Constant.isAddShareClient = false
    Constant.isOneWayFriend = false
    Constant.isLeaderCreateGroup = false
    Constant.isOutGroupCustomReturn = false
    Constant.isRealTimeAddGroup = false
    StringUtils.setMessageData("", 10, 0)
    StringUtils.setMessageData("", 20, 0)
    EventBus.getDefault().post(MainBean(false))
    LogUtil.e("任务标识 全部设置 false")
}
