package com.kuxuan.autoclick.service;

import android.accessibilityservice.AccessibilityService;
import android.annotation.SuppressLint;
import android.os.SystemClock;
import android.view.accessibility.AccessibilityNodeInfo;

import androidx.annotation.RequiresApi;

import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.groupsend.CompanyBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;
import com.kuxuan.autoclick.utils.StringUtils;

import org.jetbrains.annotations.NotNull;

import java.util.Iterator;
import java.util.List;


/**
 * @author lkj
 * @date 2024/2/18 15:06
 * @desc
 */
public class GroupSendJava {
    public static void startGroupSend(@NotNull TaskBean taskBean, int findCount) {
        AccessibilityNodeInfo nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
        List groupSendTools = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("群发助手") : null;
        if (groupSendTools != null && !groupSendTools.isEmpty() && groupSendTools.size() > 0) {
            LogUtil.e("在工作台中 点击一下群发助手");
            AccessibilityUtil.INSTANCE.clickByNodeInScreen((AccessibilityService) WeworkController.INSTANCE.getWeworkService(), (AccessibilityNodeInfo) groupSendTools.get(0));
            SystemClock.sleep(NumberUtils.getRandom1000());
            findqyxxdfs(0, taskBean);
        } else {
            LogUtil.e("没找到 群发助手 重新找一下");
            if (findCount > 5) {
                LogUtil.e("没找到 群发助手 执行下一个主体");
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
                GroupSendImplKt.isHaveCompany(1, taskBean);
            } else {
                SystemClock.sleep(1000L);
                startGroupSend(taskBean, findCount + 1);
            }
        }

    }

    @SuppressLint({"NewApi"})
    public static void findqyxxdfs(int findCount, @NotNull TaskBean taskBean) {
        if (!taskBean.isLive()) {
            LogUtil.e("任务取消 " + GroupSendImplKt.getDafor().format(taskBean.getId()) + ' ' + taskBean.isLive());
            WeworkController.INSTANCE.getWeworkService().taskList.remove(taskBean);
        } else {
            AccessibilityNodeInfo nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
            List msgListTitle = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("企业消息待发送") : null;
            if (msgListTitle != null) {
                if (msgListTitle.size() > 0) {
                    LogUtil.e("点击一下带发送消息的title");
                    AccessibilityUtil.INSTANCE.clickByNodeInScreen((AccessibilityService) WeworkController.INSTANCE.getWeworkService(), (AccessibilityNodeInfo) msgListTitle.get(0));
                    SystemClock.sleep(NumberUtils.getRandom1000() + (long) 1000);
                    clickSendBtn(0, taskBean);
                } else if (findCount >= 2) {
                    LogUtil.e("企业消息待发送找到为 0 此时没有待发送的消息 直接返回 执行请求拉人接口");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    LogUtil.e("返回首页");
                    GroupSendImplKt.isHaveCompany(1, taskBean);
                } else {
                    SystemClock.sleep(1000L);
                    LogUtil.e("重复寻找 企业消息待发送 次数：" + findCount);
                    findqyxxdfs(findCount + 1, taskBean);
                }
            } else {
                LogUtil.e("msgListTitle null 此时没有待发送的消息 直接返回 执行请求拉人接口");
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
                GroupSendImplKt.isHaveCompany(1, taskBean);
            }

        }
    }

    @RequiresApi(30)
    public static void clickSendBtn(int findCount, @NotNull TaskBean taskBean) {
        if (!taskBean.isLive()) {
            LogUtil.e("任务取消 " + GroupSendImplKt.getDafor().format(taskBean.getId()) + ' ' + taskBean.isLive());
            WeworkController.INSTANCE.getWeworkService().taskList.remove(taskBean);
        } else {
            AccessibilityNodeInfo nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
            List sendBtns = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("发送") : null;
            if (sendBtns != null  && sendBtns.size() > 0&& !sendBtns.isEmpty()) {
                LogUtil.e("点击一下待发送消息的button");
                AccessibilityNodeInfo sendBtn = new AccessibilityNodeInfo();
                Iterator iterator1 = sendBtns.iterator();

                while (iterator1.hasNext()) {
                    AccessibilityNodeInfo sendBtnA = (AccessibilityNodeInfo) iterator1.next();
                    if (sendBtnA.getText().toString().equals("发送")) {
                        sendBtn = sendBtnA;
                        break;
                    }
                }

                nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
                List<AccessibilityNodeInfo> sendTitle = nodeInfo.findAccessibilityNodeInfosByText("待发送的企业消息");
                if (sendTitle != null && !sendTitle.isEmpty() && sendTitle.size() > 0) {
                    Object var14 = sendTitle.get(0);
                    CharSequence text = ((AccessibilityNodeInfo) var14).getText();
                    int pointLaterNumber = StringUtils.getPointLaterNumber(text.toString());
                    LogUtil.e("还有消息数：" + pointLaterNumber);
                    if (pointLaterNumber == 0) {
                        LogUtil.e("没有消息了 返回主页面 执行请求 拉人 接口");
                        LogUtil.e("返回首页");
                        GroupSendImplKt.returnHome(taskBean, 0);
                        GroupSendImplKt.isHaveCompany(1, taskBean);
                    } else {
                        boolean checkTime = checkTime(sendBtn);
                        if (!taskBean.isLive()) {
                            LogUtil.e("任务取消 " + GroupSendImplKt.getDafor().format(taskBean.getId()) + ' ' + taskBean.isLive());
                            WeworkController.INSTANCE.getWeworkService().taskList.remove(taskBean);
                            return;
                        }
                        if (checkTime) {
                            nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
                            List managers = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("管理员 通知你群发消息给") : null;
                            if (managers != null && managers.size() > 0) {
                                nodeInfo = GlobalMethodKt.getRootCopy(taskBean);
                                List sendBtn2s = nodeInfo != null ? nodeInfo.findAccessibilityNodeInfosByText("发送") : null;
                                if (sendBtn2s != null && sendBtn2s.size() > 0) {
                                    Iterator iterator = sendBtn2s.iterator();

                                    while (iterator.hasNext()) {
                                        AccessibilityNodeInfo sendBtn2 = (AccessibilityNodeInfo) iterator.next();
                                        if (sendBtn2.getText().toString().equals("发送")) {
                                            AccessibilityUtil.INSTANCE.clickByNodeInScreen((AccessibilityService) WeworkController.INSTANCE.getWeworkService(), sendBtn2);
                                            LogUtil.e("点一次发送 按钮");
                                            SystemClock.sleep(3000L);
//                                            AccessibilityUtil.INSTANCE.scrollByXY((AccessibilityService) WeworkController.INSTANCE.getWeworkService(), 0, 1000, 400, 0);
//                                            LogUtil.e("发送一次后 返回上一页面");
//                                            SystemClock.sleep(NumberUtils.getRandom1000());
                                            break;
                                        }
                                    }
                                }
                                clickSendBtn(0, taskBean);
                            }
                        } else {
                            LogUtil.e("消息时间不是当天的！！");
                            LogUtil.e("没有消息了 返回主页面 执行请求 拉人 接口");
                            LogUtil.e("返回首页");
                            GroupSendImplKt.returnHome(taskBean, 0);
                            GroupSendImplKt.isHaveCompany(1, taskBean);
                        }
                    }
                } else {
                    LogUtil.e("这次真没有消息了 返回主页面 执行请求 拉人 接口");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(1, taskBean);
                }
            } else if (findCount > 4) {
                LogUtil.e("寻找 发送按钮 4次 没找到");
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
                GroupSendImplKt.isHaveCompany(1, taskBean);
            } else {
                SystemClock.sleep(1000L);
                clickSendBtn(findCount + 1, taskBean);
            }

        }
    }

    public static boolean checkTime(@NotNull AccessibilityNodeInfo sendBtn) {
        AccessibilityNodeInfo btnParent = sendBtn.getParent();
        if (btnParent != null) {
            AccessibilityNodeInfo timeParent = btnParent.getChild(0);
            if (timeParent != null) {
                AccessibilityNodeInfo child = timeParent.getChild(1);
                if (child != null) {
                    String text = child.getText().toString();
                    if (text.contains("分钟前") || text.contains("上午") || text.contains("下午") || text.contains("刚刚")) {
                        LogUtil.e("当前时间检测为 当天 消息：" + text);
                        return true;
                    } else {
                        LogUtil.e("当前时间检测为 过期 消息：" + text);
                        return false;
                    }
                } else {
                    LogUtil.e("没找到：时间文字类");
                    return false;
                }
            } else {
                LogUtil.e("没找到：时间文字的父类");
                return false;
            }
        } else {
            LogUtil.e("没找到：发送按钮的父类");
            return false;
        }
    }
}
