package com.kuxuan.autoclick.service;

import android.graphics.Rect;
import android.os.Bundle;
import android.os.SystemClock;
import android.view.accessibility.AccessibilityNodeInfo;
import android.view.accessibility.AccessibilityWindowInfo;

import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;
import com.kuxuan.autoclick.utils.Views;

import java.util.ArrayList;
import java.util.List;

import static com.kuxuan.autoclick.service.WeworkController.weworkService;

/**
 * @author lkj
 * @date 2024/2/5 10:15
 * @desc 群主创建群
 */
public class LeaderCreateGroup {
    private static LeaderCreateGroup groupLeader;

    public static LeaderCreateGroup getInstance() {
        if (groupLeader == null) {
            synchronized (LeaderCreateGroup.class) {
                if (groupLeader == null) {
                    groupLeader = new LeaderCreateGroup();
                }
            }
        }
        return groupLeader;
    }

    /**
     * @author lkj
     * @date 2024/1/8 11:19
     * @desc 点击 工作台
     */
    public void findGZT(TaskBean taskBean, String groupName, String groupLeaderName, int count) {
        List<AccessibilityNodeInfo> gzts = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("工作台");
        if (gzts != null) {
            if (!gzts.isEmpty() && gzts.size() > 0) {
                for (AccessibilityNodeInfo gzt : gzts) {
                    if (gzt.getText().toString().equals("工作台")) {
                        LogUtil.e("这里找到工作台 并进行点击！！");
                        AccessibilityUtil.INSTANCE.performClick(gzt,true);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                        //去点击 客户群 或者 学员群
                        LogUtil.e("开始寻找 客户群 或者 学员群");
                        createNewGroup(taskBean, groupName, groupLeaderName);
                    }
                }
            } else {
                LogUtil.e("gzts 为空了！！或者 gzts.size()<=0");
                if (count > 4) {
                    LogUtil.e("寻找 工作台 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                } else {
                    SystemClock.sleep(1000);
                    findGZT(taskBean, groupName, groupLeaderName, count + 1);
                }
            }
        } else {
            LogUtil.e("gzts 为空了！！");
        }
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:19
     * @desc 点击客户群
     */
    private void createNewGroup(TaskBean taskBean, String groupName, String groupLeaderName) {
        List<AccessibilityNodeInfo> clientGroups = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("客户群");
        if (clientGroups != null) {
            if (!clientGroups.isEmpty() && clientGroups.size() > 0) {
                for (AccessibilityNodeInfo clientGroup : clientGroups) {
                    if (clientGroup.getText().toString().equals("客户群")) {
                        LogUtil.e("点击了 客户群");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, clientGroup);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                //弹出框中输入群聊名称
                clickXYQNode(taskBean, groupName, groupLeaderName);
            } else {
                LogUtil.e("没找到 客户群 文字");
                List<AccessibilityNodeInfo> studGroups = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("学员群");
                if (studGroups != null) {
                    if (!studGroups.isEmpty() && studGroups.size() > 0) {
                        for (AccessibilityNodeInfo studGroup : studGroups) {
                            if (studGroup.getText().toString().equals("学员群")) {
                                LogUtil.e("点击了 学员群");
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, studGroup);
                                SystemClock.sleep(NumberUtils.getRandom1000());
                            }
                        }
                        //弹出框中输入群聊名称
                        clickXYQNode(taskBean, groupName, groupLeaderName);
                    } else {
                        LogUtil.e("没找到 学员群 文字");
                    }
                } else {
                    LogUtil.e("studGroups 为空了！");
                }
            }
        } else {
            LogUtil.e("clientGroups 为空了！");
        }
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:20
     * @desc 点击学员群创建
     */
    private void clickXYQNode(TaskBean taskBean, String groupName, String groupLeaderName) {
        List<AccessibilityNodeInfo> createOneStudGroups = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("创建一个学员群");
        if (createOneStudGroups != null) {
            if (!createOneStudGroups.isEmpty() && createOneStudGroups.size() > 0) {
                for (AccessibilityNodeInfo oneStudGroup : createOneStudGroups) {
                    if (oneStudGroup.getText().toString().equals("创建一个学员群")) {
                        LogUtil.e("点击了 创建一个学员群 ");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, oneStudGroup);
                        SystemClock.sleep(NumberUtils.getRandom1000() + 2000);
                    }
                }
                clickThreePos(taskBean, groupName, groupLeaderName);
            } else {
                LogUtil.e("没找到 创建一个学员群 文字 找 创建一个客户群");
                List<AccessibilityNodeInfo> createOneClientGroups = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("创建一个客户群");
                if (createOneClientGroups != null) {
                    if (!createOneClientGroups.isEmpty() && createOneClientGroups.size() > 0) {
                        for (AccessibilityNodeInfo oneClientGroup : createOneClientGroups) {
                            if (oneClientGroup.getText().toString().equals("创建一个客户群")) {
                                LogUtil.e("点击了 创建一个客户群 ");
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, oneClientGroup);
                                SystemClock.sleep(NumberUtils.getRandom1000() + 2000);
                            }
                        }
                        clickThreePos(taskBean, groupName, groupLeaderName);
                    } else {
                        LogUtil.e("没找到 创建一个客户群 文字");
                    }
                } else {
                    LogUtil.e("createOneClientGroups 为空了！");
                }
            }
        } else {
            LogUtil.e("createOneStudGroups 为空了！");
        }
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:21
     * @desc 点击聊天界面 右上角的三个点
     */
    private void clickThreePos(TaskBean taskBean, String groupName, String groupLeaderName) {
        LogUtil.e("点击群聊中右上角的三个点");
        String[] strings = new String[1];
        strings[0] = Views.TextView;
        AccessibilityNodeInfo root = weworkService.getRootInActiveWindow();
        for (AccessibilityWindowInfo window : weworkService.getWindows()) {
            if (window.getRoot() != null) {
                root = window.getRoot();
            } else {
                LogUtil.e("根节点检测： 检测为空");
            }
        }
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(root, strings);
        if (allByClazz != null) {
            for (AccessibilityNodeInfo threePoint : allByClazz) {
                Rect rect = new Rect();
                threePoint.getBoundsInScreen(rect);
                if ((rect.left >= 620 && rect.left <= 628) && (rect.top >= 47 && rect.top <= 51) && (rect.right >= 718 && rect.right <= 722) && (rect.bottom >= 143 && rect.bottom <= 147)) {
                    LogUtil.e("根据坐标值 找到右上角的三个点 开始点击");
                    AccessibilityUtil.INSTANCE.performClick(threePoint, true);
                    break;
                }
            }
        }
        SystemClock.sleep(NumberUtils.getRandom1000() - 1000);
        //这里插入修改群名
        inputGroupName(taskBean, groupName);

        //点击加号 拉人
        LogUtil.e("点击+号键拉人");
//        [182,343][278,439]
        AccessibilityNodeInfo rootX = weworkService.getRootInActiveWindow();
        for (AccessibilityWindowInfo window : weworkService.getWindows()) {
            if (window.getRoot() != null) {
                rootX = window.getRoot();
            } else {
                LogUtil.e("根节点检测： 检测为空");
            }
        }
        //注释这里 加号键不知道为什么其他手机都点不到 测试机都可以
        ArrayList<AccessibilityNodeInfo> allByClazzX = AccessibilityUtil.INSTANCE.findAllByClazz(rootX, new String[]{"android.widget.ImageView"});
        if (allByClazzX != null) {
            boolean findAdd = false;
            for (AccessibilityNodeInfo addImg : allByClazzX) {
                Rect rect = new Rect();
//                [182,344][278,440] 或者 [182,343][278,439]
                addImg.getBoundsInScreen(rect);
                LogUtil.e("检测 +号键 " + rect.toString());
                if ((rect.left >= 180 && rect.left <= 184) && (rect.top >= 341 && rect.top <= 345) && (rect.right >= 276 && rect.right <= 280) && (rect.bottom >= 438 && rect.bottom <= 442)) {
                    LogUtil.e("找到 +号键 开始点击 " + rect.toString());
                    findAdd = true;
                    AccessibilityUtil.INSTANCE.performClick(addImg, true);
                    break;
                }
            }
            if (!findAdd) {
                LogUtil.e("加号键没找到 再直接点击一次坐标位置");
                AccessibilityUtil.INSTANCE.clickByNode(weworkService, 230, 392);
            }
        }
        SystemClock.sleep(NumberUtils.getRandom1000() - 1000);
        //直接点击右上角放大镜
        LogUtil.e("直接点击右上角放大镜！！");
        rightCorBiglass(taskBean, groupLeaderName);
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:27
     * @desc 设置群名称
     */
    private void inputGroupName(TaskBean taskBean, String groupName) {
        List<AccessibilityNodeInfo> noSetNames = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("未设置群名");
        if (noSetNames != null) {
            if (!noSetNames.isEmpty() && noSetNames.size() > 0) {
                for (AccessibilityNodeInfo noSetName : noSetNames) {
                    if (noSetName.getText().toString().equals("未设置群名")) {
                        LogUtil.e("点击了 未设置群名 ");
                        AccessibilityUtil.INSTANCE.performClick(noSetName, true);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
            }
        }
        String[] strings = new String[1];
        strings[0] = Views.EditText;
        AccessibilityNodeInfo inputGroupName = AccessibilityUtil.INSTANCE.findOnceByClazz(GlobalMethodKt.getRootCopy(taskBean), strings);
        if (inputGroupName != null) {
            LogUtil.e("向输入框中输入群聊名字: " + groupName);
            Bundle arguments = new Bundle();
            arguments.putCharSequence(AccessibilityNodeInfo.ACTION_ARGUMENT_SET_TEXT_CHARSEQUENCE, groupName);
            inputGroupName.performAction(AccessibilityNodeInfo.ACTION_SET_TEXT, arguments);
            SystemClock.sleep(NumberUtils.getRandom1000() - 1000);
        } else {
            LogUtil.e("inputGroupNames 为空了！");
        }
        //输入完名字点击 确定按钮
        List<AccessibilityNodeInfo> confirmBtn = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("确定");
        if (confirmBtn != null) {
            if (!confirmBtn.isEmpty() && confirmBtn.size() > 0) {
                for (AccessibilityNodeInfo conBtn : confirmBtn) {
                    if (conBtn.getText().equals("确定")) {
                        AccessibilityUtil.INSTANCE.clickByNodeCopy(weworkService, conBtn);
                        LogUtil.e("设置群聊名字成功: " + groupName);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
            } else {
                LogUtil.e("没找到 确定 文字");
            }
        } else {
            LogUtil.e("confirmBtn 为空了！");
        }
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:27
     * @desc 点击通讯录
     */
    private void addressBook(TaskBean taskBean, String groupLeaderName) {
        LogUtil.e("没找到 企业通讯录 文字");
        List<AccessibilityNodeInfo> addressBooks = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("企业通讯录");
        if (addressBooks != null) {
            if (!addressBooks.isEmpty() && addressBooks.size() > 0) {
                for (AccessibilityNodeInfo studGroup : addressBooks) {
                    if (studGroup.getText().toString().equals("企业通讯录")) {
                        LogUtil.e("点击了 企业通讯录");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, studGroup);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                //点击企业通讯录右上角放大镜
                rightCorBiglass(taskBean, groupLeaderName);
            } else {
                LogUtil.e("没找到 企业通讯录 文字");
            }
        } else {
            LogUtil.e("studGroups 为空了！");
        }
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:30
     * @desc 企业通讯录 右上角放大镜
     * [624,49][720,145]
     */
    private void rightCorBiglass(TaskBean taskBean, String groupLeaderName) {
        ArrayList<AccessibilityNodeInfo> bigGlassX = AccessibilityUtil.INSTANCE.findAllByClazz(GlobalMethodKt.getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo bigGlass : bigGlassX) {
            if (bigGlass != null) {
                Rect rect = new Rect();
                bigGlass.getBoundsInScreen(rect);
                if ((rect.left >= 620 && rect.left <= 628) && (rect.top >= 47 && rect.top <= 51) && (rect.right >= 718 && rect.right <= 722) && (rect.bottom >= 143 && rect.bottom <= 147)) {
                    LogUtil.e("找到了 企业通讯录中 右上角的放大镜 并点击它 " + rect.toShortString());
                    AccessibilityUtil.INSTANCE.performClick(bigGlass, true);
                    SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                    //找到搜索框 然后输入名字
                    findSearchBox(taskBean, groupLeaderName);
                } else {
                    LogUtil.e("未被点击的坐标点：" + rect.toShortString());
                }
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:59
     * @desc 寻找搜索框
     */
    private void findSearchBox(TaskBean taskBean, String groupLeaderName) {
//        AccessibilityNodeInfo onceByClazz = AccessibilityUtil.INSTANCE.findOnceByClazz(GlobalMethodKt.getRootCopy(false, taskBean), new String[]{"android.widget.EditText"}, null, 0, 0, null);
        boolean textInput = AccessibilityUtil.INSTANCE.findTextInput(GlobalMethodKt.getRootCopy(taskBean), groupLeaderName, true, false);
        if (textInput) {
            List<AccessibilityNodeInfo> leaderNames = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText(groupLeaderName);
            if (leaderNames != null) {
                if (!leaderNames.isEmpty() && leaderNames.size() > 0) {
                    for (AccessibilityNodeInfo leaderName : leaderNames) {
                        if (leaderName.getText().toString().contains(groupLeaderName)) {
                            Rect rect = new Rect();
                            leaderName.getBoundsInScreen(rect);
                            LogUtil.e(leaderName.getText().toString() + "  的坐标位置：" + rect.toString());
                            if (rect.left >= 230 && rect.left <= 240) {
                                LogUtil.e("点击了 " + groupLeaderName);
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, leaderName);
                            } else {
                                LogUtil.e("查无此人 " + leaderName.toString());
                            }
                            SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                        }
                    }
                    //选择群主后，直接点 确定 邀请入群
                    clickConfirmBtn(taskBean);
                } else {
                    LogUtil.e("没找到 " + groupLeaderName + " 文字");
                }
            } else {
                LogUtil.e("studGroups 为空了！");
            }
        }
    }

    //找到确定按钮并点击
    private void clickConfirmBtn(TaskBean taskBean) {
        List<AccessibilityNodeInfo> confirmBtns = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("确定(");
        if (confirmBtns != null) {
            if (!confirmBtns.isEmpty() && confirmBtns.size() > 0) {
                for (AccessibilityNodeInfo confirmBtn : confirmBtns) {
                    if (confirmBtn.getText().toString().contains("确定(")) {
                        LogUtil.e("点击了 确定");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, confirmBtn);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                //这里在返回到聊天界面后需要发一句话，否则群主找不到群聊
                AccessibilityUtil.INSTANCE.scrollByXY(weworkService, 0, 1000, 400, 0);
                boolean textInput = AccessibilityUtil.INSTANCE.findTextInput(GlobalMethodKt.getRootCopy(taskBean), "欢迎", true, false);
                if (textInput) {
                    //点一下发送
                    List<AccessibilityNodeInfo> sendBtns = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("发送");
                    if (confirmBtns != null) {
                        if (!confirmBtns.isEmpty() && confirmBtns.size() > 0) {
                            for (AccessibilityNodeInfo sendBtn : sendBtns) {
                                if (sendBtn.getText().toString().equals("发送")) {
                                    LogUtil.e("点击了 发送");
                                    AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, sendBtn);
                                    SystemClock.sleep(NumberUtils.getRandom1000());
                                }
                            }
                        } else {
                            LogUtil.e("没找到 发送 文字");
                        }
                    } else {
                        LogUtil.e("studGroups 为空了！");
                    }
                }
                //点完发送后直接返回 进行下一个
//                clickConfirmBtn(taskBean);
                taskBean.setCreateGroup(false);
                taskBean.setCreateGroup(false);
                LogUtil.e("返回首页");
                GroupSendImplKt.returnHome(taskBean, 0);
//                GroupSendImplKt.isHaveCompany(6, taskBean);
            } else {
                LogUtil.e("没找到 确定( 文字");
            }
        } else {
            LogUtil.e("studGroups 为空了！");
        }
    }
}
