package com.kuxuan.autoclick.service;

import android.graphics.Rect;
import android.text.TextUtils;
import android.view.accessibility.AccessibilityNodeInfo;
import android.view.accessibility.AccessibilityWindowInfo;

import com.google.gson.Gson;
import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.OneWayBean;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.UpLoadOneWayBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;
import com.kuxuan.autoclick.utils.Views;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import static com.kuxuan.autoclick.service.WeworkController.weworkService;

/**
 * @author lkj
 * @date 2024/1/8 11:16
 * @desc 单向好友 获取 上传
 * 接受json  {"rst":{"customer":"追剧助手","list":[{"date":"2023-12-20","companyName":"有限公司"},{"date":"2023-12-20","companyName":"有限公司"}]},"errno":"0","err":"成功","timestamp":"1704870527","v":"1.0.1","auno":"0"}
 * 上传json  {"customer":"追剧达人","mainbodys":[{"companyName":"实力公司","oneways":[{"date":"2023-10-10","oneWayFriendName":"王朝"},{"date":"2023-10-11","oneWayFriendName":"马汉"}]},{"companyName":"能力公司","oneways":[{"date":"2023-12-10","oneWayFriendName":"张龙"},{"date":"2023-12-11","oneWayFriendName":"赵虎"}]}]}
 */
public class OneWayFriendUp {
    private static OneWayFriendUp oneWayFriendUp;

    public static OneWayFriendUp getInstance() {
        if (oneWayFriendUp == null) {
            synchronized (OneWayFriendUp.class) {
                if (oneWayFriendUp == null) {
                    oneWayFriendUp = new OneWayFriendUp();
                }
            }
        }
        return oneWayFriendUp;
    }

    /**
     * @author lkj
     * @date 2024/1/8 11:19
     * @desc 点击 通讯录
     */
    public void findTxl(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> txls = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("通讯录");
        if (txls != null) {
            if (!txls.isEmpty() && txls.size() > 0) {
                for (AccessibilityNodeInfo txl : txls) {
                    if (txl.getText().toString().equals("通讯录")) {
                        LogUtil.e("这里找到通讯录 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, txl);
                        try {
                            Thread.sleep(NumberUtils.getRandom1000());
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                        //去点击 我的学员 或者 我的客户
                        LogUtil.e("开始寻找 我的客户 或者 我的学员");
                        findMyStudent(taskBean, 0);
                    }
                }
            } else {
                LogUtil.e("txls 为空了！！或者 txls.size()<=0");
                if (count > 4) {
                    LogUtil.e("寻找 通讯录 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(6, taskBean);
                } else {
                    try {
                        Thread.sleep(1000);
                        findTxl(taskBean, count + 1);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        } else {
            LogUtil.e("txls 为空了！！");
        }
    }

    /**
     * @param taskBean
     * @author lkj
     * @date 2024/1/8 11:30
     * @desc 我的学员 或者 我的客户
     */
    private void findMyStudent(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> myStudents = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("我的学员");
        if (myStudents != null) {
            if (!myStudents.isEmpty() && myStudents.size() > 0) {
                for (AccessibilityNodeInfo myStudent : myStudents) {
                    Rect rect = new Rect();
                    //[128,231][688,274]
                    myStudent.getBoundsInScreen(rect);
                    if (myStudent.getText().toString().equals("我的学员") && rect.left == 128 && rect.top == 231 && rect.right == 688 && rect.bottom == 274) {
                        LogUtil.e("这里找到我的学员 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, myStudent);
                        try {
                            Thread.sleep(NumberUtils.getRandom1000());
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
                //这里添加一个 点击筛选方式 按时间筛选
                screenTime(taskBean, 0);
            } else {
                LogUtil.e("myStudents 为空了！！或者 myStudents.size()<=0");
                if (count > 4) {
                    LogUtil.e("寻找 我的学员 4次 没找到");
                    List<AccessibilityNodeInfo> myClients = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("我的客户");
                    if (myClients != null) {
                        if (!myClients.isEmpty() && myClients.size() > 0) {
                            for (AccessibilityNodeInfo myClient : myClients) {
                                Rect rect = new Rect();
                                //[128,231][688,274]
                                myClient.getBoundsInScreen(rect);
                                if (myClient.getText().toString().equals("我的客户") && rect.left == 128 && rect.top == 231 && rect.right == 688 && rect.bottom == 274) {
                                    LogUtil.e("这里找到我的客户 并进行点击！！");
                                    AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, myClient);
                                    try {
                                        Thread.sleep(NumberUtils.getRandom1000());
                                    } catch (InterruptedException e) {
                                        e.printStackTrace();
                                    }
                                }
                            }
                            //点击 全部客户
                            LogUtil.e("开始寻找 全部客户");
                            findAllStudents(taskBean, "全部客户   ", 0);
                        } else {
                            LogUtil.e("myClients 为空了！！或者 myClients.size()<=0");
                            if (count > 4) {
                                LogUtil.e("寻找 我的客户 4次 没找到");
                                LogUtil.e("返回首页");
                                GroupSendImplKt.returnHome(taskBean, 0);
                                GroupSendImplKt.isHaveCompany(6, taskBean);
                            } else {
                                try {
                                    Thread.sleep(1000);
                                    findMyStudent(taskBean, count + 1);
                                } catch (InterruptedException e) {
                                    e.printStackTrace();
                                }
                            }
                        }
                    } else {
                        LogUtil.e("myClients 为空了！！");
                    }
                } else {
                    try {
                        Thread.sleep(1000);
                        findMyStudent(taskBean, count + 1);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        } else {
            LogUtil.e("myStudents 为空了！！");
        }
    }

    /**
     * @author lkj
     * @date 2024/1/12 11:10
     * @desc 点击屏幕右上角的 筛选按钮
     */
    private void screenTime(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> adds = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("添加");
        if (adds != null) {
            if (!adds.isEmpty() && adds.size() > 0) {
                for (AccessibilityNodeInfo add : adds) {
                    if (add.getText().toString().equals("添加")) {
                        LogUtil.e("这里找到添加,计算左边的排序按钮 并进行点击！！");
                        AccessibilityNodeInfo parent = add.getParent().getParent();
                        AccessibilityNodeInfo child = parent.getChild(1).getChild(0);
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, child);
                        try {
                            Thread.sleep(NumberUtils.getRandom1000());
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
                //点击弹框中的 按添加时间排序
                timeSorting(taskBean, 0);
            } else {
                LogUtil.e("adds 为空了！！或者 adds.size()<=0");
                if (count > 4) {
                    LogUtil.e("寻找 添加 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(6, taskBean);
                } else {
                    try {
                        Thread.sleep(1000);
                        screenTime(taskBean, count + 1);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        } else {
            LogUtil.e("adds 为空了！！");
        }
    }

    /**
     * @author lkj
     * @date 2024/1/12 11:10
     * @desc 弹框中的 排序方式
     */
    private void timeSorting(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> timeSorts = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("按添加时间排序");
        if (timeSorts != null) {
            if (!timeSorts.isEmpty() && timeSorts.size() > 0) {
                for (AccessibilityNodeInfo timeSort : timeSorts) {
                    if (timeSort.getText().toString().equals("按添加时间排序")) {
                        LogUtil.e("这里找到按添加时间排序 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, timeSort);
                        try {
                            Thread.sleep(NumberUtils.getRandom1000());
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
                //点击 全部学员
                LogUtil.e("开始寻找 全部学员");
                findAllStudents(taskBean, "全部学员   ", 0);
            } else {
                LogUtil.e("timeSorts 为空了！！或者 allStudentsX.size()<=0");
                if (count > 4) {
                    LogUtil.e("寻找 按添加时间排序 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(6, taskBean);
                } else {
                    try {
                        Thread.sleep(1000);
                        timeSorting(taskBean, count + 1);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        } else {
            LogUtil.e("timeSorts 为空了！！");
        }
    }

    /**
     * @author lkj
     * @date 2024/1/8 11:37
     * @desc 全部学员 或者 客户
     */
    private void findAllStudents(TaskBean taskBean, String allStudentsa, int count) {
        List<AccessibilityNodeInfo> allStudentsX = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText(allStudentsa);
        if (allStudentsX != null) {
            if (!allStudentsX.isEmpty() && allStudentsX.size() > 0) {
                for (AccessibilityNodeInfo allStudents : allStudentsX) {
                    if (allStudents.getText().toString().equals(allStudentsa)) {
                        LogUtil.e("这里找到" + allStudentsa + " 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, allStudents);
                        try {
                            Thread.sleep(NumberUtils.getRandom1000());
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
                //点击 弹框中的“单向学员或者客户”
                LogUtil.e("开始寻找 单向学员或者客户");
                findOneWay(taskBean, 0);
            } else {
                LogUtil.e("allStudentsX 为空了！！或者 allStudentsX.size()<=0");
                if (count > 4) {
                    LogUtil.e("寻找 " + allStudentsa + " 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(6, taskBean);
                } else {
                    try {
                        Thread.sleep(1000);
                        findAllStudents(taskBean, allStudentsa, count + 1);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        } else {
            LogUtil.e("allStudentsX 为空了！！");
        }
    }

    /**
     * @author lkj
     * @date 2024/1/8 11:42
     * @desc 单向学员  或者 单向客户
     */
    private void findOneWay(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> oneWays = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("对方开启了免验证且未添加你");
        if (oneWays != null) {
            if (!oneWays.isEmpty() && oneWays.size() > 0) {
                for (AccessibilityNodeInfo oneWay : oneWays) {
                    if (oneWay.getText().toString().contains("对方开启了免验证且未添加你")) {
                        LogUtil.e("这里找到" + oneWay + " 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, oneWay);
                        try {
                            Thread.sleep(NumberUtils.getRandom1000());
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                }
                List<OneWayBean> nameList = new ArrayList<>();
                String date = "";
                int countName = 0;
                //开始遍历列表
                ergodicList(taskBean, nameList, date, countName);
            } else {
                LogUtil.e("oneWays 为空了！！或者 oneWays.size()<=0");
                if (count > 4) {
                    LogUtil.e("寻找 对方开启了免验证且未添加你 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                    GroupSendImplKt.isHaveCompany(6, taskBean);
                } else {
                    try {
                        Thread.sleep(1000);
                        findOneWay(taskBean, count + 1);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        } else {
            LogUtil.e("oneWays 为空了！！");
        }
    }

    /**
     * @author lkj
     * @date 2024/1/8 13:52
     * @desc 遍历单向客户列表
     */
    private String lastTime = "";

    @SuppressWarnings("AlibabaAvoidCallStaticSimpleDateFormat")
    private void ergodicList(TaskBean taskBean, List<OneWayBean> nameList, String date, int countName) {
        SimpleDateFormat dateFormat1 = new SimpleDateFormat("yyyy-MM-dd");
        SimpleDateFormat dateFormat2 = new SimpleDateFormat("yyyy");
        LogUtil.e("开始遍历列表");
        String[] strings = new String[1];
        strings[0] = Views.TextView;
        AccessibilityNodeInfo root = weworkService.getRootInActiveWindow();
        for (AccessibilityWindowInfo window : weworkService.getWindows()) {
            if (window.getRoot() != null) {
                root = window.getRoot();
            } else {
                LogUtil.e("根节点检测： 检测为空");
            }
        }
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(root, strings);
        StringBuilder builder = new StringBuilder();
        int count = 0;
        int nameRight = -1;
        AccessibilityNodeInfo nameFlag = null;
        for (AccessibilityNodeInfo byClazz : allByClazz) {
            if (!TextUtils.isEmpty(byClazz.getText())) {
                count++;
                builder.append(count + ". " + byClazz.getText().toString() + "  ");
                if (byClazz.getText().toString().contains("个学员")) {
                    LogUtil.e("结束标签： " + byClazz.getText().toString());
                }
                Rect rect = new Rect();
                byClazz.getBoundsInScreen(rect);
                //这个是时间
                OneWayBean oneWayBean = new OneWayBean();
                if (rect.bottom - rect.top == 55) {
                    date = byClazz.getText().toString();
                }
                //另外这里有个bug  如果最后一页有时间节点 或者中途有时间节点 ，这时就会出现 同名 不同时间的重复 需要解决这个问题；该问题已解决（使用content-desc作为标记）

                //先找出@微信
                if (byClazz.getText().toString().equals("@微信") && rect.left == nameRight) {
                    //根据时间节点 继续查找 类似断点续传
                    if (!TextUtils.isEmpty(lastTime)) {
                        try {
                            long lasttime = dateFormat1.parse(lastTime).getTime();
                            long currdate = dateFormat1.parse(date).getTime();
                            if (currdate > lasttime) {
                                LogUtil.e("日期不符合！  限制时间：" + lastTime + "   读取时间：" + date + "   " + nameFlag.getText().toString());
                                continue;
                            }
                        } catch (ParseException e) {
                            try {
                                String nowYear = dateFormat2.format(new Date());
                                long lasttime = dateFormat1.parse(lastTime).getTime();
                                long currdate = dateFormat1.parse(nowYear + "-" + date).getTime();
                                if (currdate > lasttime) {
                                    LogUtil.e("日期不符合！  限制时间：" + lastTime + "   读取时间：" + nowYear + "-" + date + "   " + nameFlag.getText().toString());
                                    continue;
                                }
                            } catch (ParseException e1) {
                                e1.printStackTrace();
                            }
                        }
                    }
                    countName++;
                    Rect rect1 = new Rect();
                    nameFlag.getBoundsInScreen(rect1);
                    CharSequence description = nameFlag.getContentDescription();
                    LogUtil.e("text 信息： " + countName + ".  " + date + " --- " + description.toString() + " --- " + nameFlag.getText().toString());
                    oneWayBean.setDate(date);
                    oneWayBean.setName(nameFlag.getText().toString());
                    oneWayBean.setIndex(countName);
                    oneWayBean.setDesc(description.toString());
                    oneWayBean.setLeft(rect1.left);
                    oneWayBean.setTop(rect1.top);
                    oneWayBean.setRight(rect1.right);
                    oneWayBean.setBottom(rect1.bottom);
                    nameList.add(oneWayBean);
                }
                nameFlag = byClazz;
                nameRight = rect.right;
            }
        }
        if ((builder.toString().contains("支持加微信") && builder.toString().contains("我的学员")) || (builder.toString().contains("支持加微信") && builder.toString().contains("我的客户"))) {
        } else {
            LogUtil.e("已经不在单向好友界面 需要重新进入！！");
            findTxl(taskBean, 0);
            return;
        }
        LogUtil.e("结束标签： " + builder.toString());
        if (builder.toString().contains("个学员") || builder.toString().contains("个客户") || builder.toString().contains("暂无单向学员") || builder.toString().contains("暂无单向客户")) {
            //nameList去重
            ArrayList<OneWayBean> wayBeans = removeDouble(nameList);
            LogUtil.e("nameList的个数：" + wayBeans.size());
            //排序
            Collections.sort(wayBeans);
            for (OneWayBean wayBean : wayBeans) {
                LogUtil.e("客户名：  " + wayBean.getIndex() + "--" + wayBean.getDate() + "--" + wayBean.getName());
            }
            //开始执行上传方法
            upLoadToServer(taskBean, wayBeans, 1);
        } else {
            AccessibilityUtil.INSTANCE.scrollByXY_sec(weworkService, 10, 1569, 0, -1360);
            ergodicList(taskBean, nameList, date, countName);
        }
    }

    /**
     * @param taskBean
     * @param wayBeans
     * @author lkj
     * @date 2024/1/11 10:26
     * @desc 上传信息到服务器
     */
    private void upLoadToServer(TaskBean taskBean, ArrayList<OneWayBean> wayBeans, int page) {
        //组装实体类
        UpLoadOneWayBean upLoadOneWayBean = new UpLoadOneWayBean();
        upLoadOneWayBean.setCustomer(Constant.currUser);
        upLoadOneWayBean.setCompanyName(Constant.currCompany);
        upLoadOneWayBean.setPage(page);
        List<UpLoadOneWayBean.OnewaysBean> onewaysBeanList = new ArrayList<>();
        if ((page - 1) * 100 < wayBeans.size()) {
            for (int i = 0; i + (page - 1) * 100 < wayBeans.size(); i++) {
                if (i < 100) {
                    UpLoadOneWayBean.OnewaysBean onewaysBean = new UpLoadOneWayBean.OnewaysBean();
                    onewaysBean.setDate(wayBeans.get(i + (page - 1) * 100).getDate());
                    onewaysBean.setOneWayFriendName(wayBeans.get(i + (page - 1) * 100).getName());
                    onewaysBeanList.add(onewaysBean);
                } else {
                    break;
                }
            }
            if ((page - 1) * 100 + 1 == wayBeans.size()) {
                upLoadOneWayBean.setEndUpLoad(true);
            } else {
                upLoadOneWayBean.setEndUpLoad(false);
            }
            upLoadOneWayBean.setPageSize(onewaysBeanList.size());
            upLoadOneWayBean.setOneways(onewaysBeanList);
            String json = new Gson().toJson(upLoadOneWayBean);
            LogUtil.e("当前上传的信息：" + json);
            page++;
            upLoadToServer(taskBean, wayBeans, page);
        } else {
            LogUtil.e("上传完毕！");
            LogUtil.e("返回首页");
            GroupSendImplKt.returnHome(taskBean, 0);
            GroupSendImplKt.isHaveCompany(6, taskBean);
        }
    }

    /**
     * @author lkj
     * @date 2024/1/9 11:36
     * @desc 数组去重
     */
    private ArrayList<OneWayBean> removeDouble(List<OneWayBean> nameList) {
        Set<OneWayBean> playerSet = null;
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.N) {
            playerSet = new TreeSet<>(Comparator.comparing(o -> (o.getDesc() + " - " + o.getName())));
        }
        playerSet.addAll(nameList);
        ArrayList<OneWayBean> oneWayBeans = new ArrayList<>(playerSet);
        for (OneWayBean oneWayBean : nameList) {
            if (!oneWayBeans.contains(oneWayBean)) {
                LogUtil.e("被移除的元素：" + oneWayBean.getIndex() + "  " + oneWayBean.getDate() + "--" + oneWayBean.getDesc() + "--" + oneWayBean.getName());
            }
        }
        return oneWayBeans;
    }
}
