package com.kuxuan.autoclick.service;

import android.graphics.Rect;
import android.os.SystemClock;
import android.text.TextUtils;
import android.view.accessibility.AccessibilityNodeInfo;

import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.add_people_into_group.GroupBean;
import com.kuxuan.autoclick.model.add_people_into_group.InviteListBean;
import com.kuxuan.autoclick.model.groupsend.CompanyBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;
import com.kuxuan.autoclick.utils.Views;

import java.util.ArrayList;
import java.util.List;

import static com.kuxuan.autoclick.service.AddGroupKt.removeExceptDialog;
import static com.kuxuan.autoclick.service.GlobalMethodKt.getRootCopy;
import static com.kuxuan.autoclick.service.WeworkController.weworkService;

/**
 * @author lkj
 * @date 2024/4/26 9:44
 * @desc 用户退群补拉到固定的群组中
 */
public class OutFixGroupReturn {
    private static OutFixGroupReturn fixGroupReturn;
    private CompanyBean companyBean;
    private static final String tag = "OutFixGroupReturn - ";

    public static OutFixGroupReturn getInstance() {
        if (fixGroupReturn == null) {
            synchronized (OutFixGroupReturn.class) {
                if (fixGroupReturn == null) {
                    fixGroupReturn = new OutFixGroupReturn();
                }
            }
        }
        return fixGroupReturn;
    }

    /**
     * @author lkj
     * @date 2024/4/26 11:34
     * @desc 从首页面 点击右上放大镜搜索群名
     */
    public void findGroupList(TaskBean taskBean, CompanyBean companyBean) {
        this.companyBean = companyBean;
        ArrayList<AccessibilityNodeInfo> allByClazz1 = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), Views.TextView);
        for (AccessibilityNodeInfo nodeInfo : allByClazz1) {
            if (nodeInfo != null) {
                Rect rect = new Rect();
                nodeInfo.getBoundsInScreen(rect);
//                LogUtil.e(tag + rect.toShortString());//[528,49][624,145]
                if ((rect.left >= 526 && rect.left <= 530) && (rect.top >= 47 && rect.top <= 51) && (rect.right >= 622 && rect.right <= 626) && (rect.bottom >= 143 && rect.bottom <= 147)) {
                    LogUtil.e(tag + "找到了 首界面的放大镜 并点击它");
                    AccessibilityUtil.INSTANCE.performClick(nodeInfo, true);
                    SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                    List<GroupBean> groupBeans = companyBean.getGroupBeans();
                    LogUtil.e(tag + "遍历groupBeans 按群名开始找群");
                    for (GroupBean groupBean : groupBeans) {
                        LogUtil.e(tag + "输入群名 找到后直接点击群名");
                        int groupPeopleLimit = groupBean.user_limit;
                        if (groupPeopleLimit == 0) {
                            groupPeopleLimit = 35;
                        }
                        Constant.GROUP_PERSON_NUMBER = groupPeopleLimit;
                        //再增加一个 拿到群人数
                        List<InviteListBean.CustomerListBean> customer_list = null;
                        List<InviteListBean> invite_list = groupBean.invite_list;
                        if (invite_list != null) {
                            for (InviteListBean inviteListBean : invite_list) {
                                customer_list = inviteListBean.getCustomer_list();
                            }
                        }
                        OutGroupCustomReturn.getInstance().findInputSearchBox(taskBean, groupBean.groupName);
                        clickGroupName(taskBean, groupBean, customer_list, 0);
                    }
                }
            }
        }
        LogUtil.e(tag + "任务执行到最后返回首页");
    }

    /**
     * @author lkj
     * @date 2024/4/26 9:57
     * @desc 点击群名字 进入群聊天界面
     */
    private void clickGroupName(TaskBean taskBean, GroupBean groupBean, List<InviteListBean.CustomerListBean> customer_list, int clickCount) {
        LogUtil.e(tag + "再检测一下群组名称，然后点击：" + groupBean.groupName);
        OutGroupCustomReturn.getInstance().clickButtonText(taskBean, groupBean.groupName, "");
        LogUtil.e(tag + "判断一下是否到了群聊天界面" + groupBean.groupName);
        boolean nodeListLike = OutGroupCustomReturn.getInstance().getNodeListLike(taskBean, "发起收款", "应用提醒");
        if (nodeListLike) {
            LogUtil.e(tag + "进入到群聊天界面，点击右上角三个点");
            clickRThreePoint(taskBean, customer_list, 0);
        } else {
            clickCount++;
            if (clickCount < 5) {
                LogUtil.e(tag + "没有进入到群聊天界面，重复点击一次");
                clickGroupName(taskBean, groupBean, customer_list, clickCount);
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/26 10:52
     * @desc 点击群聊右上角三个点
     */
    private void clickRThreePoint(TaskBean taskBean, List<InviteListBean.CustomerListBean> customer_list, int clickCount) {
        LogUtil.e("点击群聊右上角三个点！！");
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), Views.TextView);
        if (allByClazz != null) {
            if (!allByClazz.isEmpty() && allByClazz.size() > 0) {
                for (AccessibilityNodeInfo byClazz : allByClazz) {
                    Rect rect = new Rect();
                    byClazz.getBoundsInScreen(rect);
                    if ((rect.left >= 620 && rect.left <= 628) && (rect.top >= 47 && rect.top <= 51) && (rect.right >= 718 && rect.right <= 722) && (rect.bottom >= 143 && rect.bottom <= 147)) {
                        LogUtil.e(tag + "根据坐标值 找到右上角的三个点 开始点击");
                        AccessibilityUtil.INSTANCE.performClick(byClazz, true);
                        SystemClock.sleep(NumberUtils.getRandom1000() - 1000);
                        LogUtil.e(tag + "判断一下是否到了群设置界面");
                        boolean nodeListLike = OutGroupCustomReturn.getInstance().getNodeListLike(taskBean, "由企业微信用户创建", "发起收款");
                        if (nodeListLike) {
                            LogUtil.e(tag + "进入到群设置界面了");
                            inGroupSetingPage(taskBean, customer_list);
                        } else {
                            clickCount++;
                            if (clickCount <= 5) {
                                LogUtil.e(tag + "没有进入到群设置界面，重复点击一次");
                                clickRThreePoint(taskBean, customer_list, clickCount);
                            }
                        }
                        break;
                    }
                }
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/26 13:41
     * @desc 进入群设置界面后进行的操作
     */
    private void inGroupSetingPage(TaskBean taskBean, List<InviteListBean.CustomerListBean> customer_list) {
        LogUtil.e(tag + "计算一下群聊中的人数");
        int number = 0;
        ArrayList<AccessibilityNodeInfo> allPeoples = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        LogUtil.e(tag + "循环节点");
        for (AccessibilityNodeInfo allPeople : allPeoples) {
            LogUtil.e(tag + "判断节点 文字不能为空 " + (!TextUtils.isEmpty(allPeople.getText())));
            if (!TextUtils.isEmpty(allPeople.getText())) {
                Rect rect = new Rect();
                allPeople.getBoundsInScreen(rect);//[577,540][630,586]
                LogUtil.e(tag + "获取存在文字节点的坐标：" + rect.right + "  " + allPeople.getText().toString());
                if (!TextUtils.isEmpty(allPeople.getText()) && allPeople.getText().toString().contains("人") && (rect.right >= 628 && rect.right <= 632)) {
                    LogUtil.e(tag + "得到准确的节点！");
                    number = Integer.valueOf(allPeople.getText().toString().replace("人", ""));
                    break;
                }
            }
        }
        LogUtil.e(tag + "判断节点人数 " + number + " 是否小于单群人数的限制 " + Constant.GROUP_PERSON_NUMBER);
        if (number < Constant.GROUP_PERSON_NUMBER) {
            //从这里开始 未单个群聊进行补充人数的操作
            LogUtil.e(tag + "群里还差多少人");
            int different = differentNumber(number);
            LogUtil.e(tag + "群里还差多少人 " + different);
            addReturnPeople(taskBean, different, customer_list);
        } else {
            LogUtil.e(tag + "群人数已满 返回到指定页面");
//            OutGroupCustomReturn.getInstance().backWhere(taskBean, "应用提醒");
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 17:13
     * @desc 群里还差多少人 的计算
     */
    private int differentNumber(int number) {
        int differentx = Constant.GROUP_PERSON_NUMBER - number;
        //如果列表中剩余的人数不足够时，就以列表的数量为准
        if (differentx <= WeworkController.weworkService.testNameList.size()) {
            LogUtil.e(tag + "剩余的人数不足 只有" + WeworkController.weworkService.testNameList.size() + " 人");
        } else {
            LogUtil.e(tag + "剩余的人数充足 有" + WeworkController.weworkService.testNameList.size() + " 人");
            differentx = WeworkController.weworkService.testNameList.size();
        }
        return differentx;
    }

    /**
     * @author lkj
     * @date 2024/4/8 15:31
     * @desc 从查看全部群成员 开始操作
     */
    private void addReturnPeople(TaskBean taskBean, int different, List<InviteListBean.CustomerListBean> customer_list) {
        LogUtil.e(tag + "从这里开始 未单个群聊进行补充人数的操作");
        boolean text = OutGroupCustomReturn.getInstance().clickButtonText(taskBean, "查看全部群成员", null);
        if (text) {
            LogUtil.e(tag + "点击右上角的位置");
            AccessibilityUtil.INSTANCE.clickByNode(WeworkController.weworkService, 672, 97);
            SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
            LogUtil.e(tag + "点击添加成员");
            OutGroupCustomReturn.getInstance().clickButtonText(taskBean, "添加成员", null);
        } else {
            LogUtil.e(tag + "没有 查看全部群成员 只能点击+号键");
            AccessibilityUtil.INSTANCE.clickByNode(weworkService, 230, 395);
            SystemClock.sleep(NumberUtils.getRandom1000());
        }
        LogUtil.e(tag + "点击放大镜");
        clickBigGlass(taskBean);
        if (customer_list != null && customer_list.size() > 0) {
            for (InviteListBean.CustomerListBean customerListBean : customer_list) {
                String name = customerListBean.getName();
                LogUtil.e(tag + "向输入框中输入用户名: " + name);
                OutGroupCustomReturn.getInstance().findInputSearchBox(taskBean, name);
                LogUtil.e(tag + "判断用户名 并点击: " + name);
                OutGroupCustomReturn.getInstance().clickUserName(taskBean, name);
            }
        } else {
            LogUtil.e(tag + "没有得到退群客户的数据");
        }
        LogUtil.e(tag + "选择完用户后 再点确定按钮 如果没有确定按钮需要返回四次 重新找人数");
        boolean isClick = OutGroupCustomReturn.getInstance().clickButtonText(taskBean, null, "确定(");
        SystemClock.sleep(NumberUtils.getRandom1000());
        if (isClick) {
            LogUtil.e(tag + "有确定键 又要对弹框进行判断");
            removeExceptDialog(taskBean);
        } else {
            LogUtil.e(tag + "没有确定键 返回4次");
            if (text) {
                LogUtil.e(tag + "有查看全部群成员的情况增加一次返回");
                LogUtil.e(tag + "返回一次");
                OutGroupCustomReturn.getInstance().backScroll();
                SystemClock.sleep(1000);
            }
            LogUtil.e(tag + "返回一次");
            OutGroupCustomReturn.getInstance().backScroll();
            SystemClock.sleep(1000);
            LogUtil.e(tag + "返回一次");
            OutGroupCustomReturn.getInstance().backScroll();
            SystemClock.sleep(1000);
        }
        //这里要判断一次 点击完确定后 在那个界面 才能返回
        boolean localWhere = OutGroupCustomReturn.getInstance().localWhere(taskBean, "由企业微信用户创建");
        if (!localWhere) {
            LogUtil.e(tag + "返回一次");
            OutGroupCustomReturn.getInstance().backScroll();
        }
        SystemClock.sleep(1000);
        LogUtil.e(tag + "拉人人后 直接返回到搜索界面，让for循环执行下一个群聊的操作");
        LogUtil.e(tag + "backScroll 2次！");
        OutGroupCustomReturn.getInstance().backScroll();
        SystemClock.sleep(1000);
        OutGroupCustomReturn.getInstance().backScroll();
        SystemClock.sleep(1000);

//        LogUtil.e(tag + "这里对群人数进行计算，判断是否将群补满了");
//        calculateGroupNumber(taskBean);
    }

    /**
     * @author lkj
     * @date 2024/4/8 17:17
     * @desc 这里对群人数进行计算，判断是否将群补满了
     */
    private void calculateGroupNumber(TaskBean taskBean) {
        boolean haveCount = false;
        ArrayList<AccessibilityNodeInfo> allPeoples = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo allPeople : allPeoples) {
            if (!TextUtils.isEmpty(allPeople.getText())) {
                Rect rect = new Rect();
                allPeople.getBoundsInScreen(rect);//[577,540][630,586]
                if (!TextUtils.isEmpty(allPeople.getText()) && allPeople.getText().toString().contains("人") && (rect.right >= 628 && rect.right <= 632)) {
                    int number = Integer.valueOf(allPeople.getText().toString().replace("人", ""));
                    haveCount = true;
                    LogUtil.e(tag + "此时的群人数：" + number + "  限制为：" + Constant.GROUP_PERSON_NUMBER);
                    if (number < Constant.GROUP_PERSON_NUMBER) {
                        LogUtil.e(tag + "当前的群 没有拉满 !!");
                        //距离群允许的最大人数还差几个人
                        int differentx = differentNumber(number);
                        LogUtil.e(tag + "还可以拉 " + differentx + " 个人");
                        if (differentx > 0) {
                            LogUtil.e(tag + "还有剩余人数 继续拉群！！");
//                            addReturnPeople(taskBean, differentx, customer_list);
                        } else {

                        }
                        return;
                    }
                }
            }
        }
        if (!haveCount) {
            LogUtil.e(tag + "没有找到计算人数的那个 只有群主 这时得点加号键拉人");
            int differentx = differentNumber(1);
            LogUtil.e(tag + "还可以拉 " + differentx + " 个人");
            if (differentx > 0) {
                if (WeworkController.weworkService.testNameList.size() <= 0) {
                    LogUtil.e("粉丝已经用尽了，提前结束");
                } else {
                    LogUtil.e(tag + "继续拉群！！");
//                    addReturnPeople(taskBean, differentx, customer_list);
                }
            } else {
                LogUtil.e(tag + "人数已经满了 返回一次 执行下一个群的操作");
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 15:43
     * @desc 根据选择联系人的位置 找打放大镜的位置
     */
    private void clickBigGlass(TaskBean taskBean) {
        ArrayList<AccessibilityNodeInfo> allByClazzs = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo allByClazz : allByClazzs) {
            if (allByClazz != null && !TextUtils.isEmpty(allByClazz.getText())) {
                if (allByClazz.getText().toString().equals("选择联系人")) {
                    LogUtil.e(tag + "找到了 选择联系人 计算一下放大镜的位置");
                    groupBigGlass(allByClazz);
                }
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 15:58
     * @desc 放大镜的具体位置
     */
    private void groupBigGlass(AccessibilityNodeInfo allByClazz) {
        Rect rect = new Rect();
        allByClazz.getBoundsInScreen(rect);
        int x = rect.right + 400;
        int y = (rect.top + rect.bottom) / 2;
        AccessibilityUtil.INSTANCE.clickByNode(WeworkController.weworkService, x, y);
        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
        LogUtil.e(tag + "点击了 选择联系人  界面 右上角的放大镜");
    }
}
