package com.kuxuan.autoclick.service;

import android.graphics.Rect;
import android.os.Bundle;
import android.os.SystemClock;
import android.text.TextUtils;
import android.view.accessibility.AccessibilityNodeInfo;

import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.add_people_into_group.GroupBean;
import com.kuxuan.autoclick.model.groupsend.CompanyBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;
import com.kuxuan.autoclick.utils.StringUtils;
import com.kuxuan.autoclick.utils.Views;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import static com.kuxuan.autoclick.service.AddGroupKt.removeExceptDialog;
import static com.kuxuan.autoclick.service.GlobalMethodKt.getRootCopy;
import static com.kuxuan.autoclick.service.WeworkController.weworkService;

/**
 * @author lkj
 * @date 2024/4/8 11:29
 * @desc 退群客户重新补拉
 * 流程：1.根据群模板搜索群聊
 * 流程：2.按群聊名从上到下检测群人数，缺人就塞
 * 流程：3.
 */
public class OutGroupCustomReturn {

    private static OutGroupCustomReturn outGroupCustomReturn;
    private String tag = "退群客户重新补拉 - ";

    public static OutGroupCustomReturn getInstance() {
        if (outGroupCustomReturn == null) {
            synchronized (OutGroupCustomReturn.class) {
                if (outGroupCustomReturn == null) {
                    outGroupCustomReturn = new OutGroupCustomReturn();
                }
            }
        }
        return outGroupCustomReturn;
    }

    private CompanyBean companyBean;
    private String currType2GroupName;

    /**
     * @param taskBean
     * @param companyBean
     * @author lkj
     * @date 2024/1/8 11:19
     * @desc 点击 工作台
     */
    public void findGZT(TaskBean taskBean, CompanyBean companyBean, int count) {
        this.companyBean = companyBean;
        LogUtil.e(tag + "找到工作台 并点击");
        List<AccessibilityNodeInfo> gzts = getRootCopy(taskBean).findAccessibilityNodeInfosByText("工作台");
        if (gzts != null) {
            if (!gzts.isEmpty() && gzts.size() > 0) {
                for (AccessibilityNodeInfo gzt : gzts) {

                    if (gzt.getText().toString().equals("工作台")) {
                        LogUtil.e(tag + "这里找到工作台 并进行点击！！");
                        AccessibilityUtil.INSTANCE.performClick(gzt, true);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                        //去点击 客户群 或者 学员群
                        LogUtil.e(tag + "开始寻找 客户群 或者 学员群");
                        findStudentOrCustomGroup(taskBean, companyBean);
                    }
                }
            } else {
                LogUtil.e(tag + "gzts 为空了！！或者 gzts.size()<=0");
                if (count > 4) {
                    LogUtil.e(tag + "寻找 工作台 4次 没找到");
                    LogUtil.e("返回首页");
                    GroupSendImplKt.returnHome(taskBean, 0);
                } else {
                    SystemClock.sleep(1000);
                    findGZT(taskBean, companyBean, count + 1);
                }
            }
        } else {
            LogUtil.e(tag + "gzts 为空了！！");
        }
    }

    /**
     * @author lkj
     * @date 2024/2/5 10:19
     * @desc 点击客户群 或者 学员群
     */
    private void findStudentOrCustomGroup(TaskBean taskBean, CompanyBean companyBean) {
        LogUtil.e(tag + "点击客户群 或者 学员群");
        List<AccessibilityNodeInfo> clientGroups = getRootCopy(taskBean).findAccessibilityNodeInfosByText("客户群");
        if (clientGroups != null) {
            if (!clientGroups.isEmpty() && clientGroups.size() > 0) {
                for (AccessibilityNodeInfo clientGroup : clientGroups) {

                    if (clientGroup.getText().toString().equals("客户群")) {
                        LogUtil.e(tag + "点击了 客户群");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, clientGroup);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                //点击我的 客户群
                if (companyBean.getOwner_type() == 1) {
                    clickText1(taskBean, companyBean, "我的客户群");
                } else {
                    clickText1(taskBean, companyBean, "企业全部客户群");
                }
            } else {
                LogUtil.e(tag + "没找到 客户群 文字");
                List<AccessibilityNodeInfo> studGroups = getRootCopy(taskBean).findAccessibilityNodeInfosByText("学员群");
                if (studGroups != null) {
                    if (!studGroups.isEmpty() && studGroups.size() > 0) {
                        for (AccessibilityNodeInfo studGroup : studGroups) {

                            if (studGroup.getText().toString().equals("学员群")) {
                                LogUtil.e(tag + "点击了 学员群");
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, studGroup);
                                SystemClock.sleep(NumberUtils.getRandom1000());
                            }
                        }
                        //点击我的 学员群
                        if (companyBean.getOwner_type() == 1) {
                            clickText1(taskBean, companyBean, "我的学员群");
                        } else {
                            clickText1(taskBean, companyBean, "企业全部学员群");
                        }
                    } else {
                        LogUtil.e(tag + "没找到 学员群 文字");
                    }
                } else {
                    LogUtil.e(tag + "studGroups 为空了！");
                }
            }
        } else {
            LogUtil.e(tag + "clientGroups 为空了！");
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 14:19
     * @desc 点击我的客户群 或者 我的学员群
     */
    private void clickText1(TaskBean taskBean, CompanyBean companyBean, String textName) {
        LogUtil.e(tag + "准备点击文字：" + textName);
        ArrayList<AccessibilityNodeInfo> allByClazzs = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo allByClazz : allByClazzs) {
            if (allByClazz != null && !TextUtils.isEmpty(allByClazz.getText())) {
                if (allByClazz.getText().toString().equals(textName)) {
                    LogUtil.e(tag + "发现了 " + textName + " 并进行了点击");
                    AccessibilityUtil.INSTANCE.performClick(allByClazz, true);
                    SystemClock.sleep(NumberUtils.getRandom1000() - 1000);
                    if (textName.equals("按群名筛选   ") || textName.equals("按条件筛选   ")) {//如果是按群名筛选 说明已经点击过了，就要输入关键字了
                        for (GroupBean groupBean : companyBean.groupBeans) {
                            if (WeworkController.weworkService.testNameList.size() > 0) {
                                int groupPeopleLimit = groupBean.user_limit;
                                if (groupPeopleLimit == 0) {
                                    groupPeopleLimit = 35;
                                }
                                Constant.GROUP_PERSON_NUMBER = groupPeopleLimit;
                                LogUtil.e(tag + "遍历群组 " + groupBean.groupName);
                                findInputSearchBox(taskBean, groupBean.groupName + "#");
                                //输入完成以后 就要点击一下确定键
                                clickButtonText(taskBean, "确定", null);
                                //匹配群名 检查人数
                                matchGroupName(taskBean);
                            } else {
                                LogUtil.e("粉丝已经用尽了，提前结束");
                                break;
                            }
                        }
                        GroupSendImplKt.returnHome(taskBean, 0);
                        /**
                         * @author lkj
                         * @date 2024/4/12 18:18
                         * @desc 如果还有剩余人数需要重新创建新群 然后将群主转移 当 owner_type == 2 的情况下
                         */

                        GroupSendImplKt.isHaveCompany(8, taskBean);
                    } else {//如果不是按群名筛选 就要点击一下 才能取输入关键字
                        //接下来点击 按群名筛选
                        if (companyBean.getOwner_type() == 1) {
                            clickText1(taskBean, companyBean, "按群名筛选   ");
                        } else {
                            clickText1(taskBean, companyBean, "按条件筛选   ");
                        }
                    }
                } else {
//                    LogUtil.e(tag + "这是其他的文字：" + allByClazz.getText().toString());
                }
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/17 16:42
     * @desc 其他客服群聊模式执行的第一步
     */
    public void findGroupList(TaskBean taskBean, CompanyBean companyBean) {
        this.companyBean = companyBean;
        ArrayList<AccessibilityNodeInfo> allByClazz1 = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), Views.TextView);
        for (AccessibilityNodeInfo nodeInfo : allByClazz1) {
            if (nodeInfo != null) {
                Rect rect = new Rect();
                nodeInfo.getBoundsInScreen(rect);
                LogUtil.e(tag + rect.toShortString());//[528,49][624,145]
                if ((rect.left >= 526 && rect.left <= 530) && (rect.top >= 47 && rect.top <= 51) && (rect.right >= 622 && rect.right <= 626) && (rect.bottom >= 143 && rect.bottom <= 147)) {
                    LogUtil.e(tag + "找到了 首界面的放大镜 并点击它");
                    AccessibilityUtil.INSTANCE.performClick(nodeInfo, true);
                    SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                    List<GroupBean> groupBeans = companyBean.getGroupBeans();
                    LogUtil.e(tag + "遍历groupBeans 按群模板名开始找群");
                    for (GroupBean groupBean : groupBeans) {
                        LogUtil.e(tag + "输入群模板 检查有多少群");
                        int groupPeopleLimit = groupBean.user_limit;
                        if (groupPeopleLimit == 0) {
                            groupPeopleLimit = 35;
                        }
                        Constant.GROUP_PERSON_NUMBER = groupPeopleLimit;
                        currType2GroupName = groupBean.groupName + "#";
                        findInputSearchBox(taskBean, currType2GroupName);
                        LogUtil.e(tag + "判断一下搜索界面顶部标签是否有多个");
                        boolean localWhere = localWhere(taskBean, "应用提醒");

                        LogUtil.e(tag + "点击tab标签的 群聊 两个字");
                        clickButtonText(taskBean, "群聊", "");
                        findGroupName(taskBean, true);
                        break;
                    }
                    break;
                }
            }
        }
        LogUtil.e(tag + "任务执行到最后要清空 记录list");
        flagAddList.clear();
    }

    /**
     * @author lkj
     * @date 2024/4/17 17:25
     * @desc 其他客服群聊 查找群名
     */
    private List<String> flagAddList = new ArrayList<>();

    private void findGroupName(TaskBean taskBean, boolean needBackScroll) {
        if (needBackScroll) {
            LogUtil.e(tag + "右滑一下，去掉软键盘");
            backScroll();
            SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
        }
        int index = 0;
        LogUtil.e(tag + "再检查一遍 多少群");
        List<AccessibilityNodeInfo> newAddList = new ArrayList<>();
        ArrayList<AccessibilityNodeInfo> nodeList = getNodeList(taskBean, currType2GroupName);
        for (AccessibilityNodeInfo info : nodeList) {
            if (info != null && !TextUtils.isEmpty(info.getText()) && info.getText().toString().contains(currType2GroupName)) {
                index++;
                LogUtil.e(tag + "群聊计数：" + index + " 名称：" + info.getText().toString());
                newAddList.add(info);
            }
        }
        //增加一步去重
        ArrayList<AccessibilityNodeInfo> nodeInfos = removeDouble(newAddList);
        for (AccessibilityNodeInfo nodeInfo : nodeInfos) {
            LogUtil.e(tag + " 去重的群名还剩几个 " + nodeInfo.getText().toString());
        }
        boolean isRunTask = false;
        for (int i = 0; i < nodeInfos.size(); i++) {
            if (WeworkController.weworkService.testNameList.size() == 0) {
                LogUtil.e("补群人数已经消耗完，返回到首页吧");
                GroupSendImplKt.returnHome(taskBean, 0);
                return;
            }
            AccessibilityNodeInfo info = nodeInfos.get(i);
            if (info != null && !TextUtils.isEmpty(info.getText()) && info.getText().toString().contains(currType2GroupName)) {
                LogUtil.e(tag + "判断一下滑动以后 去重的群名还剩几个 0个就停止");
                if (flagAddList.contains(info.getText().toString())) {
                    LogUtil.e(tag + "记录数组中包含这个群名，跳过执行");
                } else {
                    isRunTask = true;
                    flagAddList.add(info.getText().toString());
                    LogUtil.e(tag + "记录数组中没有这个群名，可以执行");
                    AccessibilityUtil.INSTANCE.performClick(info, true);
                    SystemClock.sleep(NumberUtils.getRandom1000() - 1000);
                    LogUtil.e("当前点击的群聊名字为：" + info.getText().toString() + ", 下次不再点击！");
                    clickRThreePoint(taskBean);
                }
            }
        }
        LogUtil.e(tag + "判断一下 是否需要上滑");
        if (nodeInfos.size() >= 9) {
            LogUtil.e(tag + "数量大于等于 9 了 上滑重新检查一次");
            if (isRunTask) {
                upScroll();
                findGroupName(taskBean, false);
            } else {
                LogUtil.e(tag + "上次滑动都没有执行 说明已经到头了 清空记录list");
                flagAddList.clear();
            }
        } else {
            LogUtil.e(tag + "数量大小于 9 了 不需要上滑");
        }
    }

    /**
     * @author lkj
     * @date 2024/4/17 17:32
     * @desc 点击群聊右上角三个点
     */
    private void clickRThreePoint(TaskBean taskBean) {
        LogUtil.e("点击群聊右上角三个点！！");
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), Views.TextView);
        if (allByClazz != null) {
            if (!allByClazz.isEmpty() && allByClazz.size() > 0) {
                for (AccessibilityNodeInfo byClazz : allByClazz) {
                    Rect rect = new Rect();
                    byClazz.getBoundsInScreen(rect);
                    if ((rect.left >= 620 && rect.left <= 628) && (rect.top >= 47 && rect.top <= 51) && (rect.right >= 718 && rect.right <= 722) && (rect.bottom >= 143 && rect.bottom <= 147)) {
                        LogUtil.e(tag + "根据坐标值 找到右上角的三个点 开始点击");
                        AccessibilityUtil.INSTANCE.performClick(byClazz, true);
                        SystemClock.sleep(NumberUtils.getRandom1000() - 1000);
                        break;
                    }
                }
            }
        }
        LogUtil.e(tag + "计算一下群聊中的人数");
        int number = 0;
        ArrayList<AccessibilityNodeInfo> allPeoples = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        LogUtil.e(tag + "循环节点");
        for (AccessibilityNodeInfo allPeople : allPeoples) {
            LogUtil.e(tag + "判断节点 文字不能为空 " + (!TextUtils.isEmpty(allPeople.getText())));
            if (!TextUtils.isEmpty(allPeople.getText())) {
                Rect rect = new Rect();
                allPeople.getBoundsInScreen(rect);//[577,540][630,586]
                LogUtil.e(tag + "获取存在文字节点的坐标：" + rect.right + "  " + allPeople.getText().toString());
                if (!TextUtils.isEmpty(allPeople.getText()) && allPeople.getText().toString().contains("人") && (rect.right >= 628 && rect.right <= 632)) {
                    LogUtil.e(tag + "得到准确的节点！");
                    number = Integer.valueOf(allPeople.getText().toString().replace("人", ""));
                    break;
                }
            }
        }
        LogUtil.e(tag + "判断节点人数 " + number + " 是否小于单群人数的限制 " + Constant.GROUP_PERSON_NUMBER);
        if (number < Constant.GROUP_PERSON_NUMBER) {
            //从这里开始 未单个群聊进行补充人数的操作
            LogUtil.e(tag + "群里还差多少人");
            int different = differentNumber(number);
            LogUtil.e(tag + "群里还差多少人 " + different);
            addReturnPeople(taskBean, different);
        } else {
            LogUtil.e(tag + "群人数已满 返回到指定页面");
            backWhere(taskBean, "应用提醒");
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 14:45
     * @desc 匹配群名 检查群内人数
     */
    private void matchGroupName(TaskBean taskBean) {
        boolean isNeedScroll = false;
        LogUtil.e(tag + " 检查群内人数");
        StringBuilder builder = new StringBuilder();
        ArrayList<AccessibilityNodeInfo> allByClazzs = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        /**
         * 这里需要注意的是 在这个for循环中检查人数时  是要向里面塞人的，所以这里是循环的开始，不要回退进行不必要的操作
         */
        for (AccessibilityNodeInfo allByClazz : allByClazzs) {
            if (WeworkController.weworkService.testNameList.size() <= 0) {
                LogUtil.e("粉丝已经用尽了，提前结束");
                break;
            }
            if (allByClazz != null && !TextUtils.isEmpty(allByClazz.getText())) {
                builder.append(allByClazz.getText().toString() + "   ");
                if (allByClazz.getText().toString().contains("人  | 群主 :")) {
                    LogUtil.e(tag + "√√√√√ 人  | 群主 : " + allByClazz.getText().toString());
                    int number1 = StringUtils.getNumber1(allByClazz.getText().toString());
                    if (number1 < Constant.GROUP_PERSON_NUMBER) {
                        isNeedScroll = true;
                        int different = Constant.GROUP_PERSON_NUMBER - number1;
                        LogUtil.e(tag + "还缺少 " + different + "人");
                        AccessibilityUtil.INSTANCE.performClick(allByClazz, true);
                        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                        //从这里开始 未单个群聊进行补充人数的操作
                        addReturnPeople(taskBean, different);
                        break;
                    } else {
                        LogUtil.e(tag + "这个群不缺人");
                    }
                } else {
                    LogUtil.e(tag + "XXXXX 人  | 群主 : " + allByClazz.getText().toString());
                }
            }
        }
        if (companyBean.getOwner_type() == 1) {
            if (builder.toString().contains("个群")||builder.toString().contains("无学员群")) {//true的时候说明已经找到了，就停止翻页，false说明没有找到 得翻页寻找
                //找到了 就返回首页
            } else {
                // 进行翻页处理
                if (!isNeedScroll) {
                    LogUtil.e(tag + "上滑 需要翻页，然后再执行一次这个方法");
                    upScroll();
                }
                if (WeworkController.weworkService.testNameList.size() <= 0) {
                    LogUtil.e("粉丝已经用尽了，提前结束");
                } else {
                    SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                    matchGroupName(taskBean);
                }
            }
        } else {

        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 15:31
     * @desc 从查看全部群成员 开始操作
     */
    private void addReturnPeople(TaskBean taskBean, int different) {
        LogUtil.e(tag + "从这里开始 未单个群聊进行补充人数的操作");
        boolean text = clickButtonText(taskBean, "查看全部群成员", null);
        if (text) {
            LogUtil.e(tag + "点击右上角的位置");
            AccessibilityUtil.INSTANCE.clickByNode(WeworkController.weworkService, 672, 97);
            SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
            LogUtil.e(tag + "点击添加成员");
            clickButtonText(taskBean, "添加成员", null);
        } else {
            LogUtil.e(tag + "没有 查看全部群成员 只能点击+号键");
            AccessibilityUtil.INSTANCE.clickByNode(weworkService, 230, 395);
            SystemClock.sleep(NumberUtils.getRandom1000());
        }
        LogUtil.e(tag + "点击放大镜");
        clickBigGlass(taskBean);
        List<String> peopleNameList = new ArrayList<>();
        if (different <= WeworkController.weworkService.testNameList.size()) {
            LogUtil.e("剩余的人数不足 只有 " + WeworkController.weworkService.testNameList.size() + "人");
        } else {
            LogUtil.e("剩余的人数充足 有" + WeworkController.weworkService.testNameList.size() + " 人");
            different = WeworkController.weworkService.testNameList.size();
        }
        NumberUtils.randomTopic(WeworkController.weworkService.testNameList, different, peopleNameList);
        //将被选中的人从总列表中移除
        for (String people : peopleNameList) {

            WeworkController.weworkService.testNameList.remove(people);
        }
        for (String peopleName : peopleNameList) {
            LogUtil.e(tag + "向输入框中输入用户名");
            findInputSearchBox(taskBean, peopleName);
            LogUtil.e(tag + "判断用户名 并点击");
            clickUserName(taskBean, peopleName);
        }
        LogUtil.e(tag + "选择完用户后 再点确定按钮 如果没有确定按钮需要返回四次 重新找人数");
        boolean isClick = clickButtonText(taskBean, null, "确定(");
        SystemClock.sleep(NumberUtils.getRandom1000());
        if (isClick) {
            LogUtil.e(tag + "有确定键 又要对弹框进行判断");
            removeExceptDialog(taskBean);
        } else {
            LogUtil.e(tag + "没有确定键 返回4次");
            if (text) {
                LogUtil.e(tag + "有查看全部群成员的情况增加一次返回");
                LogUtil.e(tag + "返回一次");
                backScroll();
                SystemClock.sleep(1000);
            }
            LogUtil.e(tag + "返回一次");
            backScroll();
            SystemClock.sleep(1000);
            LogUtil.e(tag + "返回一次");
            backScroll();
            SystemClock.sleep(1000);
        }
        //这里要判断一次 点击完确定后 在那个界面 才能返回
        boolean localWhere = localWhere(taskBean, "由企业微信用户创建");
        if (!localWhere) {
            LogUtil.e(tag + "返回一次");
            backScroll();
        }
        SystemClock.sleep(1000);
        LogUtil.e(tag + "这里对群人数进行计算，判断是否将群补满了");
        calculateGroupNumber(taskBean);
    }

    /**
     * @author lkj
     * @date 2024/4/8 17:17
     * @desc 这里对群人数进行计算，判断是否将群补满了
     */
    private void calculateGroupNumber(TaskBean taskBean) {
        boolean haveCount = false;
        ArrayList<AccessibilityNodeInfo> allPeoples = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo allPeople : allPeoples) {
            if (!TextUtils.isEmpty(allPeople.getText())) {
                Rect rect = new Rect();
                allPeople.getBoundsInScreen(rect);//[577,540][630,586]
                if (!TextUtils.isEmpty(allPeople.getText()) && allPeople.getText().toString().contains("人") && (rect.right >= 628 && rect.right <= 632)) {
                    int number = Integer.valueOf(allPeople.getText().toString().replace("人", ""));
                    LogUtil.e(tag + "此时的群人数：" + number + "  限制为：" + Constant.GROUP_PERSON_NUMBER);
                    if (number < Constant.GROUP_PERSON_NUMBER) {
                        LogUtil.e(tag + "当前的群 没有拉满 !!");
                        //距离群允许的最大人数还差几个人
                        int differentx = differentNumber(number);
                        LogUtil.e(tag + "还可以拉 " + differentx + " 个人");
                        if (differentx > 0) {
                            LogUtil.e(tag + "还有剩余人数 继续拉群！！");
                            addReturnPeople(taskBean, differentx);
                        } else {
                            LogUtil.e(tag + "人数已经满了 返回一次 执行下一个群的操作");
                            haveCount = true;
                            if (companyBean.getOwner_type() == 1) {
                                LogUtil.e(tag + "返回一次");
                                backScroll();
                            } else {
                                LogUtil.e(tag + "返回2次");
                                backScroll();
                                SystemClock.sleep(1000);
                                backScroll();
                            }
                            SystemClock.sleep(1000);
                            break;
                        }
                    } else {
                        LogUtil.e(tag + "人数已经满了 返回一次 执行下一个群的操作");
                        haveCount = true;
                        if (companyBean.getOwner_type() == 1) {
                            LogUtil.e(tag + "返回一次");
                            backScroll();
                            SystemClock.sleep(1000);
                        } else {
                            LogUtil.e(tag + "返回到指定页面");
                            backWhere(taskBean, "应用提醒");
//                            LogUtil.e(tag + "返回2次");
//                            backScroll();
//                            SystemClock.sleep(1000);
//                            backScroll();
                        }
                        break;
                    }
                }
            }
        }
        if (!haveCount) {
            LogUtil.e(tag + "没有找到计算人数的那个 只有群主 这时得点加号键拉人");
            int differentx = differentNumber(1);
            LogUtil.e(tag + "还可以拉 " + differentx + " 个人");
            if (differentx > 0) {
                if (WeworkController.weworkService.testNameList.size() <= 0) {
                    LogUtil.e("粉丝已经用尽了，提前结束");
                } else {
                    LogUtil.e(tag + "继续拉群！！");
                    if (companyBean.getOwner_type() == 1) {
                        matchGroupName(taskBean);
                    } else {
                        findGroupName(taskBean, false);
                    }
                }
            } else {
                LogUtil.e(tag + "人数已经满了 返回一次 执行下一个群的操作");
                if (companyBean.getOwner_type() == 1) {
                    LogUtil.e(tag + "返回一次");
                    backScroll();
                } else {
                    LogUtil.e(tag + "返回2次");
                    backScroll();
                    SystemClock.sleep(1000);
                    backScroll();
                }
                SystemClock.sleep(1000);
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 17:13
     * @desc 群里还差多少人 的计算
     */
    private int differentNumber(int number) {
        int differentx = Constant.GROUP_PERSON_NUMBER - number;
        //如果列表中剩余的人数不足够时，就以列表的数量为准
        if (differentx <= WeworkController.weworkService.testNameList.size()) {
            LogUtil.e(tag + "剩余的人数不足 只有" + WeworkController.weworkService.testNameList.size() + " 人");
        } else {
            LogUtil.e(tag + "剩余的人数充足 有" + WeworkController.weworkService.testNameList.size() + " 人");
            differentx = WeworkController.weworkService.testNameList.size();
        }
        return differentx;
    }

    /**
     * @author lkj
     * @date 2024/4/8 16:12
     * @desc 点击用户名
     */
    public void clickUserName(TaskBean taskBean, String name) {
        ArrayList<AccessibilityNodeInfo> allByClazzs = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo clientPeopleItem : allByClazzs) {

            if (!TextUtils.isEmpty(clientPeopleItem.getText())) {
                Rect rect = new Rect();
                clientPeopleItem.getBoundsInScreen(rect);
//                LogUtil.e(tag + "字符串判断：" + rect.left + "  " + clientPeopleItem.getText().toString() +
//                        (clientPeopleItem.getClassName().equals(Views.TextView)) + "  " + clientPeopleItem.getText().toString().equals(name) + "  " + (rect.left >= 232 && rect.left <= 236));
                if (clientPeopleItem.getClassName().equals(Views.TextView) && clientPeopleItem.getText().toString().equals(name) && (rect.left >= 232 && rect.left <= 236)) {
                    //第二次判断同级之下的控件是否包含 “@微信”
                    AccessibilityNodeInfo parent = clientPeopleItem.getParent();
                    if (parent.getChildCount() >= 2) {
                        AccessibilityNodeInfo child = parent.getChild(1);
                        if (child != null && !TextUtils.isEmpty(child.getText())) {
                            if (child.getText().toString().contains("@")) {
                                LogUtil.e(tag + "点击用户名 " + clientPeopleItem.getText());
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, clientPeopleItem);
                                break;
                            }
                        }
                    }
                    LogUtil.e(tag + "点击用户名 " + clientPeopleItem.getText());
                    AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, clientPeopleItem);
                    break;
                }
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 15:43
     * @desc 根据选择联系人的位置 找打放大镜的位置
     */
    private void clickBigGlass(TaskBean taskBean) {
        ArrayList<AccessibilityNodeInfo> allByClazzs = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo allByClazz : allByClazzs) {
            if (allByClazz != null && !TextUtils.isEmpty(allByClazz.getText())) {
                if (allByClazz.getText().toString().equals("选择联系人")) {
                    LogUtil.e(tag + "找到了 选择联系人 计算一下放大镜的位置");
                    groupBigGlass(taskBean, allByClazz);
                }
            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 15:58
     * @desc 放大镜的具体位置
     */
    private void groupBigGlass(TaskBean taskBean, AccessibilityNodeInfo allByClazz) {
        Rect rect = new Rect();
        allByClazz.getBoundsInScreen(rect);
        int x = rect.right + 400;
        int y = (rect.top + rect.bottom) / 2;
        AccessibilityUtil.INSTANCE.clickByNode(WeworkController.weworkService, x, y);
        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
        LogUtil.e(tag + "点击了 选择联系人  界面 右上角的放大镜");
    }

    /*****************************************************************************************************************/
    //寻找文字  并进行点击
    public boolean clickButtonText(TaskBean taskBean, String buttonText1, String buttonText2) {
        LogUtil.e(tag + "寻找：buttonText1:" + buttonText1 + " 并进行点击  buttonText2:" + buttonText2 + " 并进行点击");
        boolean isFinded = false;
        ArrayList<AccessibilityNodeInfo> allByClazzs = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo allByClazz : allByClazzs) {
            if (allByClazz != null && !TextUtils.isEmpty(allByClazz.getText())) {
                if (!TextUtils.isEmpty(buttonText1)) {
                    if (allByClazz.getText().toString().equals(buttonText1)) {
                        LogUtil.e(tag + "发现了 " + buttonText1 + " 并进行了点击");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, allByClazz);
                        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                        isFinded = true;
                        break;
                    } else {
//                        LogUtil.e(tag + "这是其他的文字：" + allByClazz.getText().toString());
                    }
                }
                if (!TextUtils.isEmpty(buttonText2)) {
                    if (allByClazz.getText().toString().contains(buttonText2)) {
                        LogUtil.e(tag + "发现了 " + buttonText2 + " 并进行了点击");
                        AccessibilityUtil.INSTANCE.performClick(allByClazz, true);
                        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                        isFinded = true;
                        break;
                    } else {
//                        LogUtil.e(tag + "这是其他的文字：" + allByClazz.getText().toString());
                    }
                }
            }
        }
        return isFinded;
    }

    /**
     * @author lkj
     * @date 2024/4/8 13:46
     * @desc 找到输入框 并向里面输入群名字
     */
    public void findInputSearchBox(TaskBean taskBean, String groupName) {
        LogUtil.e(tag + "寻找输入框");
        AccessibilityNodeInfo inputNode = AccessibilityUtil.INSTANCE.findOnceByClazz(getRootCopy(taskBean), new String[]{Views.EditText});
        if (inputNode != null) {
            LogUtil.e(tag + "发现输入框 在里面输入名字：" + groupName);
            Bundle arguments = new Bundle();
            arguments.putCharSequence(AccessibilityNodeInfo.ACTION_ARGUMENT_SET_TEXT_CHARSEQUENCE, groupName);
            inputNode.performAction(AccessibilityNodeInfo.ACTION_SET_TEXT, arguments);
            SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
        }
    }

    /**
     * @author lkj
     * @date 2024/4/9 11:12
     * @desc 界面判断
     */
    public boolean localWhere(TaskBean taskBean, String string) {
        LogUtil.e(tag + "获取界面信息,目标信息：" + string);
        StringBuilder builder = new StringBuilder();
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo byClazz : allByClazz) {
            if (byClazz != null && !TextUtils.isEmpty(byClazz.getText())) {
                builder.append(byClazz.getText().toString());
            }
        }
        LogUtil.e(tag + "界面信息：" + builder.toString());
        return builder.toString().contains(string);
    }

    public AccessibilityNodeInfo localWhereNode(TaskBean taskBean, String string) {
        LogUtil.e(tag + "获取界面信息,目标信息：" + string);
        StringBuilder builder = new StringBuilder();
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo byClazz : allByClazz) {
            if (byClazz != null && !TextUtils.isEmpty(byClazz.getText())) {
                builder.append(byClazz.getText().toString());
                if (byClazz.getText().toString().contains(string)) {
                    return byClazz;
                }
            }
        }
        return null;
    }

    public ArrayList<AccessibilityNodeInfo> getNodeList(TaskBean taskBean, String string) {
        LogUtil.e(tag + "获取界面信息,目标信息：" + string);
        StringBuilder builder = new StringBuilder();
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo byClazz : allByClazz) {
            if (byClazz != null && !TextUtils.isEmpty(byClazz.getText())) {
                builder.append(byClazz.getText().toString());
            }
        }
        LogUtil.e(tag + "界面信息：" + builder.toString());
        return allByClazz;
    }

    /**
     * @author lkj
     * @date 2024/4/26 10:05
     * @desc 判断是否成功跳转到指定界面
     */
    public boolean getNodeListLike(TaskBean taskBean, String str1, String str2) {
        LogUtil.e(tag + "获取界面信息,目标信息：" + str1 + ",  当前信息：" + str2);
        StringBuilder builder = new StringBuilder();
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo byClazz : allByClazz) {
            if (byClazz != null && !TextUtils.isEmpty(byClazz.getText())) {
                builder.append(byClazz.getText().toString());
            }
        }
        LogUtil.e(tag + "界面信息：" + builder.toString());
        for (AccessibilityNodeInfo byClazz : allByClazz) {
            if (byClazz != null && !TextUtils.isEmpty(byClazz.getText())) {
                if (byClazz.getText().toString().contains(str1)) {
                    LogUtil.e(tag + "已经到了 --" + str1 + "-- 界面");
                    return true;
                }
                if (byClazz.getText().toString().contains(str2)) {
                    LogUtil.e(tag + "没有成功 跳转到 --" + str1 + "-- 界面");
                    return false;
                }
            }
        }
        return false;
    }

    /**
     * @author lkj
     * @date 2024/4/9 17:17
     * @desc 通过界面判断返回到了那个界面
     */
    public void backWhere(TaskBean taskBean, String string) {
        backScroll();
        SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
        LogUtil.e(tag + "获取界面信息,目标信息：" + string);
        StringBuilder builder = new StringBuilder();
        ArrayList<AccessibilityNodeInfo> allByClazz = AccessibilityUtil.INSTANCE.findAllByClazz(getRootCopy(taskBean), new String[]{Views.TextView});
        for (AccessibilityNodeInfo byClazz : allByClazz) {
            if (byClazz != null && !TextUtils.isEmpty(byClazz.getText())) {
                builder.append(byClazz.getText().toString());
            }
        }
        LogUtil.e(tag + "界面信息：" + builder.toString());
        if (builder.toString().contains(string)) {
            LogUtil.e(tag + "到达了指定页面√ √ √");
        } else {
            backWhere(taskBean, string);
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 17:20
     * @desc 返回 手势滑动
     */
    public void backScroll() {
        AccessibilityUtil.INSTANCE.scrollByXY(weworkService, 0, 1000, 400, 0);
    }

    /**
     * @author lkj
     * @date 2024/4/8 17:21
     * @desc 手势上滑
     */
    public void upScroll() {
        AccessibilityUtil.INSTANCE.scrollByXY_sec(weworkService, 10, 1569, 0, -1360);
    }

    /**
     * @author lkj
     * @date 2024/1/9 11:36
     * @desc 数组去重
     */
    private ArrayList<AccessibilityNodeInfo> removeDouble(List<AccessibilityNodeInfo> nameList) {
        Set<AccessibilityNodeInfo> playerSet = null;
        if (android.os.Build.VERSION.SDK_INT >= android.os.Build.VERSION_CODES.N) {
            playerSet = new TreeSet<>(Comparator.comparing(o -> (o.getText().toString())));
        }
        playerSet.addAll(nameList);
        ArrayList<AccessibilityNodeInfo> AccessibilityNodeInfos = new ArrayList<>(playerSet);
        for (AccessibilityNodeInfo AccessibilityNodeInfo : nameList) {
            if (!AccessibilityNodeInfos.contains(AccessibilityNodeInfo)) {
                LogUtil.e("被移除的元素：" + AccessibilityNodeInfo.getText().toString());
            }
        }
        return AccessibilityNodeInfos;
    }
}
