package com.kuxuan.autoclick.service;

import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.net.AddGroupNet;
import com.kuxuan.autoclick.net.AddShareClientNet;
import com.kuxuan.autoclick.net.FriendCircleNet;
import com.kuxuan.autoclick.net.GroupSendNet;
import com.kuxuan.autoclick.net.RealTimeAddGroupNet;
import com.kuxuan.autoclick.net.Share2ColleagueNet;
import com.kuxuan.autoclick.utils.SPUtils;

/**
 * @Auth lkj
 * @Date 2023/10/18 10:19
 * @Describe
 */
public class SelectMethod {
    private static SelectMethod selectMethod;

    public static SelectMethod getInstance() {
        if (selectMethod == null) {
            synchronized (SelectMethod.class) {
                if (selectMethod == null) {
                    selectMethod = new SelectMethod();
                }
            }
        }
        return selectMethod;
    }

    /**
     * @auth lkj
     * @Date 2023/10/18 10:16
     * @Describe 根据页面配置选择要执行的任务
     */
    public void selectMethod1(TaskBean taskBean) {
        boolean group_send = SPUtils.getInstance().getBoolean("group_send", true);
        boolean invite = SPUtils.getInstance().getBoolean("invite", true);
        boolean friend_send = SPUtils.getInstance().getBoolean("friend_send", true);
        boolean share_client = SPUtils.getInstance().getBoolean("share_client", false);
        boolean add_share_client = SPUtils.getInstance().getBoolean("add_share_client", false);
        boolean read_time_add_group = SPUtils.getInstance().getBoolean("read_time_add_group", false);
        if (group_send) {
            GroupSendNet.getInstance().groupSendMethod(taskBean);
        } else {
            if (invite) {
                AddGroupNet.getInstance().addGroupMethod(taskBean, 0, "", 0);
            } else {
                if (friend_send) {
                    FriendCircleNet.getInstance().friendSendMethod(taskBean);
                } else {
                    if (share_client) {
                        Share2ColleagueNet.getInstance().shareToColleague(taskBean);
                    } else {
                        if (add_share_client) {
                            AddShareClientNet.getInstance().addShareClient(taskBean);
                        } else {
                            if (read_time_add_group) {
                                RealTimeAddGroupNet.getInstance().realTimeAddMethod(taskBean);
                            }
                        }
                    }
                }
            }
        }
    }

    public void selectMethod2(TaskBean taskBean) {
        boolean invite = SPUtils.getInstance().getBoolean("invite", true);
        boolean friend_send = SPUtils.getInstance().getBoolean("friend_send", true);
        boolean share_client = SPUtils.getInstance().getBoolean("share_client", false);
        boolean add_share_client = SPUtils.getInstance().getBoolean("add_share_client", false);
        boolean read_time_add_group = SPUtils.getInstance().getBoolean("read_time_add_group", false);
        if (invite) {
            AddGroupNet.getInstance().addGroupMethod(taskBean, 0, "", 0);
        } else {
            if (friend_send) {
                FriendCircleNet.getInstance().friendSendMethod(taskBean);
            } else {
                if (share_client) {
                    Share2ColleagueNet.getInstance().shareToColleague(taskBean);
                } else {
                    if (add_share_client) {
                        AddShareClientNet.getInstance().addShareClient(taskBean);
                    } else {
                        if (read_time_add_group) {
                            RealTimeAddGroupNet.getInstance().realTimeAddMethod(taskBean);
                        }
                    }
                }
            }
        }
    }

    public void selectMethod3(TaskBean taskBean) {
        boolean friend_send = SPUtils.getInstance().getBoolean("friend_send", true);
        boolean share_client = SPUtils.getInstance().getBoolean("share_client", false);
        boolean add_share_client = SPUtils.getInstance().getBoolean("add_share_client", false);
        boolean read_time_add_group = SPUtils.getInstance().getBoolean("read_time_add_group", false);
        if (friend_send) {
            FriendCircleNet.getInstance().friendSendMethod(taskBean);
        } else {
            if (share_client) {
                Share2ColleagueNet.getInstance().shareToColleague(taskBean);
            } else {
                if (add_share_client) {
                    AddShareClientNet.getInstance().addShareClient(taskBean);
                } else {
                    if (read_time_add_group) {
                        RealTimeAddGroupNet.getInstance().realTimeAddMethod(taskBean);
                    }
                }
            }
        }
    }

    public void selectMethod4(TaskBean taskBean) {
        boolean share_client = SPUtils.getInstance().getBoolean("share_client", false);
        boolean add_share_client = SPUtils.getInstance().getBoolean("add_share_client", false);
        boolean read_time_add_group = SPUtils.getInstance().getBoolean("read_time_add_group", false);
        if (share_client) {
            Share2ColleagueNet.getInstance().shareToColleague(taskBean);
        } else {
            if (add_share_client) {
                AddShareClientNet.getInstance().addShareClient(taskBean);
            } else {
                if (read_time_add_group) {
                    RealTimeAddGroupNet.getInstance().realTimeAddMethod(taskBean);
                }
            }
        }
    }

    public void selectMethod5(TaskBean taskBean) {
        boolean add_share_client = SPUtils.getInstance().getBoolean("add_share_client", false);
        boolean read_time_add_group = SPUtils.getInstance().getBoolean("read_time_add_group", false);
        if (add_share_client) {
            AddShareClientNet.getInstance().addShareClient(taskBean);
        } else {
            if (read_time_add_group) {
                RealTimeAddGroupNet.getInstance().realTimeAddMethod(taskBean);
            }
        }
    }

    public void selectMethod6(TaskBean taskBean) {
        boolean read_time_add_group = SPUtils.getInstance().getBoolean("read_time_add_group", false);
        if (read_time_add_group) {
            RealTimeAddGroupNet.getInstance().realTimeAddMethod(taskBean);
        }
    }
}
