package com.kuxuan.autoclick.service;

import android.os.Bundle;
import android.os.SystemClock;
import android.view.accessibility.AccessibilityNodeInfo;

import com.kuxuan.autoclick.model.Constant;
import com.kuxuan.autoclick.model.TaskBean;
import com.kuxuan.autoclick.model.groupsend.CompanyBean;
import com.kuxuan.autoclick.model.share_model.SharedBean;
import com.kuxuan.autoclick.utils.AccessibilityUtil;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.NumberUtils;
import com.kuxuan.autoclick.utils.Views;

import java.util.List;

import static com.kuxuan.autoclick.service.WeworkController.weworkService;

/**
 * @Auth lkj
 * @Date 2023/10/16 14:13
 * @Describe 共享客户或学员
 */
public class ShareStudent {
    public static ShareStudent shareStudent;
    private String companyName;

    public static ShareStudent getInstance() {
        if (shareStudent == null) {
            synchronized (ShareStudent.class) {
                if (shareStudent == null) {
                    shareStudent = new ShareStudent();
                }
            }
        }
        return shareStudent;
    }

    /**
     * @auth lkj
     * @Date 2023/10/16 14:17
     * @Describe 跳到工作台寻找寻找 学员联系 或者 客户联系
     */
    public void findKfOrXy(TaskBean taskBean, int count, String companyname) {
        companyName = companyname;
        List<AccessibilityNodeInfo> xylxTexts = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("我的学员");
        if (xylxTexts != null) {
            if (!xylxTexts.isEmpty() && xylxTexts.size() > 0) {
                for (AccessibilityNodeInfo xylxText : xylxTexts) {
//                    if (xylxText.getText().equals("学员联系")) {
                    if (xylxText.getText().equals("我的学员")) {
                        LogUtil.e("这里找到学员联系 并进行点击！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, xylxText);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
//                findKHZS(taskBean, 0);
                findBigGlass(taskBean);
            } else {
                List<AccessibilityNodeInfo> khlxTexts = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("我的客户");
                if (khlxTexts != null) {
                    if (!khlxTexts.isEmpty() && khlxTexts.size() > 0) {
                        for (AccessibilityNodeInfo khlxText : khlxTexts) {
//                            if (khlxText.getText().equals("客户联系")) {
                            if (khlxText.getText().equals("我的客户")) {
                                LogUtil.e("这里找到客户联系 并进行点击！！");
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, khlxText);
                                SystemClock.sleep(NumberUtils.getRandom1000());
                            }
                        }
//                        findKHZS(taskBean, 0);
                        findBigGlass(taskBean);
                    } else {
                        LogUtil.e("我的学员 和 我的客户都没找到");
                        LogUtil.e("返回首页");
                        GroupSendImplKt.returnHome(taskBean, 0);
                        GroupSendImplKt.isHaveCompany(4, taskBean);
                    }
                } else {
                    if (count > 4) {
                        LogUtil.e("寻找客户联系 4次 没找到");
                    } else {
                        SystemClock.sleep(1000);
                        findKfOrXy(taskBean, count + 1, companyname);
                    }
                }
            }
        } else {
            if (count > 4) {
                LogUtil.e("寻找学员联系 4次 没找到");
            } else {
                SystemClock.sleep(1000);
                findKfOrXy(taskBean, count + 1, companyname);
            }
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/16 14:48
     * @Describe 寻找 客户总数
     */
    public void findKHZS(TaskBean taskBean, int count) {
        List<AccessibilityNodeInfo> khzsTexts = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("客户总数");
        if (khzsTexts != null) {
            if (!khzsTexts.isEmpty() && khzsTexts.size() > 0) {
                LogUtil.e("这里找到学员联系 并进行点击！！");
                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, khzsTexts.get(0));
                SystemClock.sleep(NumberUtils.getRandom1000());
                findBigGlass(taskBean);
            }
        } else {
            if (count > 4) {
                LogUtil.e("寻找客户总数 4次 没找到");
            } else {
                SystemClock.sleep(1000);
                findKHZS(taskBean, count + 1);
            }
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/17 16:37
     * @Describe 点击顶部放大镜
     */
    private void findBigGlass(TaskBean taskBean) {
        for (CompanyBean companyBean : weworkService.companyBeans) {
            if (companyBean.getCompanyName().equals(companyName)) {
                SharedBean sharedBean = new SharedBean();
                sharedBean.setColleagueNames(companyBean.getSharedBean().getColleagueNames());
                sharedBean.setClientNames(companyBean.getSharedBean().getClientNames());
                //用坐标点击顶部放大镜
                LogUtil.e("用坐标点击顶部放大镜 ");
                int x = (404 + 500) / 2;
                int y = (49 + 145) / 2;
                AccessibilityUtil.INSTANCE.clickByNode(weworkService, x, y);
                SystemClock.sleep(NumberUtils.getRandom1000());
                findSearch(taskBean, 0, sharedBean);
            }
        }
        LogUtil.e("返回首页");
        GroupSendImplKt.returnHome(taskBean, 0);
        GroupSendImplKt.isHaveCompany(4, taskBean);
    }

    /**
     * @auth lkj
     * @Date 2023/10/16 15:21
     * @Describe 寻找输入框 并输入客户名
     */
    public void findSearch(TaskBean taskBean, int count, SharedBean sharedBean) {
        String[] strings = new String[1];
        strings[0] = Views.EditText;
        LogUtil.e("   " + sharedBean.toString());
        AccessibilityNodeInfo inputNode = AccessibilityUtil.INSTANCE.findOnceByClazz(GlobalMethodKt.getRootCopy(taskBean), strings);
        if (inputNode != null) {
            for (String clientName : sharedBean.getClientNames()) {
                LogUtil.e("发现输入框 在里面输入名字");
                Bundle arguments = new Bundle();
                arguments.putCharSequence(AccessibilityNodeInfo.ACTION_ARGUMENT_SET_TEXT_CHARSEQUENCE, clientName);
                inputNode.performAction(AccessibilityNodeInfo.ACTION_SET_TEXT, arguments);
                SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
                findKHName(taskBean, clientName, 0, sharedBean);
            }
        } else {
            if (count > 4) {
                LogUtil.e("寻找输入框 4次 没找到");
            } else {
                SystemClock.sleep(1000);
                findSearch(taskBean, count + 1, sharedBean);
            }
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/16 15:28
     * @Describe 找到输入的名字并点击
     */
    public void findKHName(TaskBean taskBean, String clientName, int count, SharedBean sharedBean) {
        List<AccessibilityNodeInfo> kuNames = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText(clientName);
        if (kuNames != null) {
            if (!kuNames.isEmpty() && kuNames.size() > 0) {
                LogUtil.e("数量：" + kuNames.size());
                for (AccessibilityNodeInfo kuName : kuNames) {
                    LogUtil.e("节点内容：" + kuName.getText() + "  节点名：" + kuName.getClassName());
                    if (kuName.getClassName().equals(Views.TextView)) {
                        LogUtil.e("点击一下：" + kuName);
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, kuName);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                //在客户信息页面点击右上角的三个点
                LogUtil.e("在客户信息页面点击右上角的三个点");
                int x = (624 + 720) / 2;
                int y = (49 + 145) / 2;
                AccessibilityUtil.INSTANCE.clickByNode(weworkService, x, y);
                SystemClock.sleep(NumberUtils.getRandom1000());
                findShareToColleague(taskBean, 0, sharedBean);
            } else {
                LogUtil.e("没找到 " + clientName + " 这个人");
            }
        } else {
            LogUtil.e("kuNames 为空了！");
        }
    }

    private void findShareToColleague(TaskBean taskBean, int count, SharedBean sharedBean) {
        List<AccessibilityNodeInfo> gxgtsTexts = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("共享给同事");
        if (gxgtsTexts != null) {
            if (!gxgtsTexts.isEmpty() && gxgtsTexts.size() > 0) {
                for (String colleagueName : sharedBean.getColleagueNames()) {
                    AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, gxgtsTexts.get(0));
                    SystemClock.sleep(NumberUtils.getRandom1000());
                    //点击选择成员有边的放大镜
                    LogUtil.e("点击选择成员有边的放大镜");
                    int x = (624 + 720) / 2;
                    int y = (49 + 145) / 2;
                    AccessibilityUtil.INSTANCE.clickByNode(weworkService, x, y);
                    SystemClock.sleep(NumberUtils.getRandom1000());
                    findSearch2(taskBean, 0, colleagueName);
                }
                //返回到 循环位置 继续
                returnPage(taskBean);
            } else {
                if (count > 4) {
                    LogUtil.e("共享给同事 4次 没找到");
                } else {
                    SystemClock.sleep(1000);
                    findShareToColleague(taskBean, count + 1, sharedBean);
                }
            }
        } else {
            LogUtil.e("gxgtsTexts 为空了！");
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/16 15:55
     * @Describe 找到输入框 输入要分享的同事 名
     */
    public void findSearch2(TaskBean taskBean, int count, String colleagueName) {
        String[] strings = new String[1];
        strings[0] = Views.EditText;
        AccessibilityNodeInfo inputNode = AccessibilityUtil.INSTANCE.findOnceByClazz(GlobalMethodKt.getRootCopy(taskBean), strings);
        if (inputNode != null) {
            LogUtil.e("发现输入框 在里面输入名字");
            Bundle arguments = new Bundle();
            arguments.putCharSequence(AccessibilityNodeInfo.ACTION_ARGUMENT_SET_TEXT_CHARSEQUENCE, colleagueName);
            inputNode.performAction(AccessibilityNodeInfo.ACTION_SET_TEXT, arguments);
            SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
            findColleagueName(taskBean, 0, colleagueName);
        } else {
            if (count > 4) {
                LogUtil.e("寻找输入框 4次 没找到");
            } else {
                SystemClock.sleep(1000);
                findSearch2(taskBean, count + 1, colleagueName);
            }
        }
    }

    /**
     * @auth lkj
     * @Date 2023/10/16 15:58
     * @Describe 找到同事名  然后点名字 就实现分享了
     */
    private void findColleagueName(TaskBean taskBean, int count, String colleagueName) {
        List<AccessibilityNodeInfo> collageNames = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText(colleagueName);
        if (collageNames != null) {
            if (!collageNames.isEmpty() && collageNames.size() > 0) {
                for (AccessibilityNodeInfo kuName : collageNames) {
                    if (kuName.getClassName().equals(Views.TextView)) {
                        LogUtil.e("找到了 " + colleagueName + " 点一下进行共享！！");
                        AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, kuName);
                        SystemClock.sleep(NumberUtils.getRandom1000());
                    }
                }
                //点击弹框中的确定按钮
                confirmName(taskBean, 0, colleagueName);
            } else {
                LogUtil.e("没找到 " + colleagueName + " 这个人");
            }
        } else {
            LogUtil.e("kuNames 为空了！");
        }
    }

    private void confirmName(TaskBean taskBean, int count, String colleagueName) {
        List<AccessibilityNodeInfo> confirmBody = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("确定将");
        if (confirmBody != null) {
            if (!confirmBody.isEmpty() && confirmBody.size() > 0) {
                List<AccessibilityNodeInfo> confirmBtns = GlobalMethodKt.getRootCopy(taskBean).findAccessibilityNodeInfosByText("确定");
                if (confirmBtns != null) {
                    if (confirmBtns.size() > 0) {
                        for (AccessibilityNodeInfo confirmBtn : confirmBtns) {
                            if (confirmBtn.getText().equals("确定")) {
                                LogUtil.e("点一下 确定 按钮");
                                AccessibilityUtil.INSTANCE.clickByNodeInScreen(weworkService, confirmBtn);
                                SystemClock.sleep(NumberUtils.getRandom1000());
                            }
                        }
                    } else {
                        LogUtil.e("confirmBtns.size() 为  0  了！");
                    }
                } else {
                    LogUtil.e("confirmBtns 为空了！");
                }
            } else {
                LogUtil.e("没找到 确定将");
            }
        } else {
            LogUtil.e("confirmBody 为空了！");
        }
    }

    /**
     * @param taskBean
     * @auth lkj
     * @Date 2023/10/17 13:52
     * @Describe 返回到联系人列表界面 继续下一次的循环
     */
    private void returnPage(TaskBean taskBean) {
        if (weworkService.currentPackage.equals(Constant.PACKAGE_NAMES)) {
//            List<AccessibilityNodeInfo> addWxChats = GlobalMethodKt.getRootCopy(false, taskBean).findAccessibilityNodeInfosByText("支持加微信");
//            if (addWxChats != null && !addWxChats.isEmpty() && addWxChats.size() > 0) {
//                LogUtil.e("到联系人列表界面了！！");
//            } else {
            LogUtil.e("自己返回 界面 1次！");
            AccessibilityUtil.INSTANCE.scrollByXY(weworkService, 0, 1000, 400, 0);
            SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
            LogUtil.e("自己返回 界面 2次！");
            AccessibilityUtil.INSTANCE.scrollByXY(weworkService, 0, 1000, 400, 0);
            SystemClock.sleep(NumberUtils.getRandom1000() - 2000);
        }
    }
}
