package com.kuxuan.autoclick.service;

import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.media.MediaPlayer;
import android.os.Build;
import android.os.IBinder;
import android.os.SystemClock;

import androidx.core.app.NotificationCompat;

import com.kuxuan.autoclick.R;
import com.kuxuan.autoclick.app.Mapp;
import com.kuxuan.autoclick.app_status.AppStatusConstant;
import com.kuxuan.autoclick.app_status.AppStatusManager;
import com.kuxuan.autoclick.ui.MainActivity;
import com.kuxuan.autoclick.utils.LogUtil;

/**
 * Content：后台播放音乐达到保活目的 * Actor：韩小呆 ヾ(ﾟ▽ﾟ)ノ * Time:  2018/10/12 10:47 * Update: * Time:
 */
public class SingASongService extends Service {
    private MediaPlayer mMediaPlayer;
//    private Thread thread;
//    private Intent intent;

    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    @Override
    public void onCreate() {
        super.onCreate();
        startForeground(1, getNotification(this, "群发助手", "已启用前台服务！"));
        MyThread myThread = new MyThread();
        new Thread(myThread).start();
        mMediaPlayer = MediaPlayer.create(Mapp.context, R.raw.no_kill);
        mMediaPlayer.setLooping(true);
        LogUtil.e("onCreate（） 创建播放对象：" + mMediaPlayer.hashCode());
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
//        int appStatus = AppStatusManager.getInstance().getAppStatus();
//        if (appStatus == AppStatusConstant.STATUS_FORCE_KILLED) {
//            //异常退出
//            LogUtil.e("app异常退出");
//        } else if (appStatus == AppStatusConstant.STATUS_NORMAL) {
//            //不需要处理或者初始方法调用
//            if (this.intent == null) {
//                if (!thread.isAlive()) {
//                    thread.start();
//                }
//                this.intent = intent;
//            }
//            LogUtil.e("播放时 线程名称：" + thread.getName());
//        }
        return START_STICKY;
    }    //开始、暂停播放

    private void startPlaySong() {
        if (mMediaPlayer == null) {
            mMediaPlayer = MediaPlayer.create(Mapp.context, R.raw.no_kill);
            LogUtil.e("音乐启动播放,播放对象为： " + mMediaPlayer.hashCode());
            mMediaPlayer.start();
        } else {
            mMediaPlayer.start();
            LogUtil.e("音乐启动播放,播放对象为： " + mMediaPlayer.hashCode());
        }
        SystemClock.sleep(3000);
        if (mMediaPlayer != null) {
            mMediaPlayer.pause();
            LogUtil.e("音乐启动播放,播放对象为： " + mMediaPlayer.hashCode());
            int progress = mMediaPlayer.getCurrentPosition();

            LogUtil.e("音乐暂停，播放进度：" + progress);
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        mMediaPlayer.pause();
//        LogUtil.e("恢复播放 时当前播放器对象：" + mMediaPlayer.hashCode());
        stopPlaySong();
//        LogUtil.e("应用播放服务被杀死，正在重启");
//        LogUtil.e("目标播放工作线程是否存活：" + thread.isAlive());
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
//            startForegroundService(new Intent(getApplicationContext(), SingASongService.class));
//        } else {
//            startService(new Intent(getApplicationContext(), SingASongService.class));
//        }
    }    //停止播放销毁对象

    private void stopPlaySong() {
        if (mMediaPlayer != null) {
            mMediaPlayer.stop();
            LogUtil.e("音乐停止播放,播放对象为：" + mMediaPlayer.hashCode());
            LogUtil.e("音乐播放器是否在循环：" + mMediaPlayer.isLooping());
            LogUtil.e("音乐播放器是否还在播放：" + mMediaPlayer.isPlaying());
            mMediaPlayer.release();
            LogUtil.e("播放对象销毁,播放对象为：" + mMediaPlayer.hashCode());
            mMediaPlayer = null;
        }
    }

    class MyThread implements Runnable {
        @Override
        public void run() {
            startPlaySong();
        }
    }

    private Notification getNotification(Context context, String title, String text) {
        boolean isSilent = true;//是否静音
        boolean isOngoing = true;//是否持续(为不消失的常驻通知)
        String channelName = "服务常驻通知";
        String channelId = "Service_Id";
        String category = Notification.CATEGORY_SERVICE;
        NotificationManager notificationManager = (NotificationManager) context.getSystemService(Context.NOTIFICATION_SERVICE);
        Intent nfIntent = new Intent(context, MainActivity.class);
        PendingIntent pendingIntent = PendingIntent.getActivity(context, 0, nfIntent, PendingIntent.FLAG_IMMUTABLE);
        NotificationCompat.Builder builder = new NotificationCompat.Builder(context, channelId)
                .setContentIntent(pendingIntent) //设置PendingIntent
                .setSmallIcon(R.mipmap.ic_launcher) //设置状态栏内的小图标
                .setContentTitle(title) //设置标题
                .setContentText(text) //设置内容
                .setVisibility(NotificationCompat.VISIBILITY_PUBLIC)//设置通知公开可见
                .setOngoing(isOngoing)//设置持续(不消失的常驻通知)
                .setCategory(category)//设置类别
                .setPriority(NotificationCompat.PRIORITY_MAX);//优先级为：重要通知
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {//安卓8.0以上系统要求通知设置Channel,否则会报错
            NotificationChannel notificationChannel = new NotificationChannel(channelId, channelName, NotificationManager.IMPORTANCE_HIGH);
            notificationChannel.setLockscreenVisibility(NotificationCompat.VISIBILITY_PUBLIC);//锁屏显示通知
            notificationManager.createNotificationChannel(notificationChannel);
            builder.setChannelId(channelId);
        }
        return builder.build();
    }
}