package com.kuxuan.autoclick.ui;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.kuxuan.autoclick.R;
import com.kuxuan.autoclick.model.HisToryBean;
import com.kuxuan.autoclick.net.updateapp.manager.AutoUpdater;
import com.kuxuan.autoclick.utils.LogUtil;

import java.util.ArrayList;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class HisApkListActivity extends AppCompatActivity {

    @BindView(R.id.back_btn)
    ImageView backBtn;
    @BindView(R.id.top_title)
    TextView topTitle;
    @BindView(R.id.top_title_layout)
    RelativeLayout topTitleLayout;
    @BindView(R.id.his_recycle)
    RecyclerView hisRecycle;
    @BindView(R.id.file_local_path)
    TextView fileLocalPath;
    private ApksAdapter adapter;

    @SuppressLint("HandlerLeak")
    private Handler handler = new Handler() {
        @Override
        public void handleMessage(@NonNull Message msg) {
            if (msg.what == 111) {
                HisToryBean apkhisbean = (HisToryBean) msg.obj;
                apks = apkhisbean.getApks();
                LogUtil.e("更新adapter " + apks.size());
                adapter.upDateList(apks);
            }
        }
    };
    private List<HisToryBean.ApkBean> apks;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_his_apk_list);
        ButterKnife.bind(this);
        fileLocalPath.setText("下载文件查看目录：Android/data/com.kuxuan.autoclick/files");
        initAdapter();
        AutoUpdater.getInstance(HisApkListActivity.this).CheckHisApks(handler);
    }

    private void initAdapter() {
        apks = new ArrayList<>();
        LinearLayoutManager manager = new LinearLayoutManager(this);
        manager.setOrientation(RecyclerView.VERTICAL);
        hisRecycle.setLayoutManager(manager);
        adapter = new ApksAdapter(this, apks);
        adapter.setHasStableIds(true);
        hisRecycle.setAdapter(adapter);
    }

    @OnClick(R.id.back_btn)
    public void onViewClicked() {
        finish();
    }

    class ApksAdapter extends RecyclerView.Adapter<ApksAdapter.ItemViewHolder> {

        private Context context;
        private List<HisToryBean.ApkBean> strings;

        public ApksAdapter(Context context, List<HisToryBean.ApkBean> strings) {
            this.context = context;
            this.strings = strings;
            LogUtil.e("数量：" + strings.size());
        }

        public void upDateList(List<HisToryBean.ApkBean> apks) {
            this.strings = apks;
            notifyDataSetChanged();
        }

        @NonNull
        @Override
        public ItemViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
            View view = LayoutInflater.from(context).inflate(R.layout.adapter_his_apks, parent, false);
            ItemViewHolder holder = new ItemViewHolder(view);
            return holder;
        }

        @SuppressLint("SetTextI18n")
        @Override
        public void onBindViewHolder(@NonNull ItemViewHolder holder, int position) {
            holder.apkName.setText((position + 1) + ". " + strings.get(position).getApkName());
            if (!TextUtils.isEmpty(strings.get(position).getDesc())) {
                holder.apkDesc.setVisibility(View.VISIBLE);
                holder.apkDesc.setText("   " + strings.get(position).getDesc());
            }
            holder.itemView.setOnClickListener(view -> {
                AutoUpdater.getInstance(HisApkListActivity.this).ShowUpdateDialog("是否下载：" + strings.get(position).getApkName(), strings.get(position).getApkName(), 2);
            });
        }

        //防止数据错乱
        @Override
        public int getItemViewType(int position) {
            return position;
        }

        @Override
        public int getItemCount() {
            return strings.size();
        }

        @Override
        public long getItemId(int position) {
            return position;
        }

        class ItemViewHolder extends RecyclerView.ViewHolder {
            @BindView(R.id.apk_name)
            TextView apkName;
            @BindView(R.id.apk_desc)
            TextView apkDesc;

            public ItemViewHolder(@NonNull View itemView) {
                super(itemView);
                ButterKnife.bind(this, itemView);
            }
        }
    }
}
