package com.kuxuan.autoclick.ui;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.ClipData;
import android.content.ClipboardManager;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.net.ConnectivityManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.Process;
import android.os.SystemClock;
import android.provider.Settings;
import android.text.TextUtils;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.SeekBar;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.kuxuan.autoclick.R;
import com.kuxuan.autoclick.app_status.AppStatusConstant;
import com.kuxuan.autoclick.app_status.AppStatusManager;
import com.kuxuan.autoclick.model.EventNotifyBean;
import com.kuxuan.autoclick.model.MainBean;
import com.kuxuan.autoclick.model.MainNetStateBean;
import com.kuxuan.autoclick.net.updateapp.manager.AutoUpdater;
import com.kuxuan.autoclick.receiver.FileCleanupReceiver;
import com.kuxuan.autoclick.receiver.NetworkReceiver;
import com.kuxuan.autoclick.service.FloatingWindowService;
import com.kuxuan.autoclick.service.MyAccessibilityService;
import com.kuxuan.autoclick.service.SingASongService;
import com.kuxuan.autoclick.service.WeworkController;
import com.kuxuan.autoclick.utils.AsUtils;
import com.kuxuan.autoclick.utils.LogUtil;
import com.kuxuan.autoclick.utils.MemoruyUtils;
import com.kuxuan.autoclick.utils.NetWorkListenerUtils;
import com.kuxuan.autoclick.utils.PermissionUtils;
import com.kuxuan.autoclick.utils.SPUtils;
import com.kuxuan.autoclick.utils.StringUtils;
import com.kuxuan.autoclick.utils.SystemUtils;
import com.kuxuan.autoclick.view.CommitDialog;
import com.kuxuan.autoclick.view.TipsDialog;

import org.greenrobot.eventbus.EventBus;
import org.greenrobot.eventbus.Subscribe;
import org.greenrobot.eventbus.ThreadMode;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * @Auth lkj
 * @Date 2023/10/17 18:10
 * @Describe 模拟点击首页面
 */
public class MainActivity extends AppCompatActivity {

    public static final int INSTALL_APK_REQUEST_CODE = 200;
    @BindView(R.id.group_send_check)
    CheckBox groupSendCheck;
    @BindView(R.id.friend_send_check)
    CheckBox friendSendCheck;
    @BindView(R.id.invite_check)
    CheckBox inviteCheck;
    @BindView(R.id.share_client_check)
    CheckBox shareClientCheck;
    @BindView(R.id.device_id_tv)
    TextView deviceIdTv;
    @BindView(R.id.copy_device_id)
    Button copyDeviceId;
    @BindView(R.id.reset)
    Button reset;
    @BindView(R.id.btn_start_service)
    Button btnStart;
    @BindView(R.id.tv_status)
    TextView tvStatus;
    @BindView(R.id.tv_version)
    TextView tvVersion;
    @BindView(R.id.return_home)
    Button returnHome;
    @BindView(R.id.add_share_client_check)
    CheckBox addShareClientCheck;
    @BindView(R.id.one_way_firend_check)
    CheckBox oneWayFirendCheck;
    @BindView(R.id.wait_time)
    TextView waitTime;
    @BindView(R.id.seek_bar)
    SeekBar seekBar;
    @BindView(R.id.user_detail)
    Button userDetail;
    @BindView(R.id.text_1)
    TextView text1;
    @BindView(R.id.dashed_line1)
    View dashedLine1;
    @BindView(R.id.dashed_line2)
    View dashedLine2;
    @BindView(R.id.dashed_line3)
    View dashedLine3;
    @BindView(R.id.text_4)
    TextView text4;
    @BindView(R.id.dashed_line4)
    View dashedLine4;
    @BindView(R.id.text_5)
    TextView text5;
    @BindView(R.id.dashed_line5)
    View dashedLine5;
    @BindView(R.id.text_6)
    TextView text6;
    @BindView(R.id.dashed_line6)
    View dashedLine6;
    @BindView(R.id.net_work_status)
    TextView netWorkStatus;
    @BindView(R.id.system_version)
    TextView systemVersion;
    @BindView(R.id.log_cat)
    Button logCat;
    @BindView(R.id.sys_setting)
    Button sysSetting;
    @BindView(R.id.check_update)
    Button checkUpdate;
    @BindView(R.id.memory_state)
    TextView memoryState;
    @BindView(R.id.clear_memory)
    Button clearMemory;
    @BindView(R.id.disk_space)
    TextView diskSpace;
    @BindView(R.id.his_apk)
    Button hisApk;
    @BindView(R.id.client_number)
    Spinner clientNumber;
    @BindView(R.id.client_number_layout)
    LinearLayout clientNumberLayout;
    @BindView(R.id.user_input)
    EditText userInput;
    @BindView(R.id.red_dot)
    View redDot;
    @BindView(R.id.check_update_layout)
    RelativeLayout checkUpdateLayout;
    @BindView(R.id.identity_group)
    RadioGroup identityGroup;
    @BindView(R.id.identity_layout)
    LinearLayout identityLayout;
    @BindView(R.id.radio_1)
    RadioButton radio1;
    @BindView(R.id.radio_2)
    RadioButton radio2;
    @BindView(R.id.auto_out_group_switch)
    Switch autoOutGroupSwitch;
    @BindView(R.id.auto_out_group_layout)
    RelativeLayout autoOutGroupLayout;
    @BindView(R.id.auto_out_group_tips)
    TextView autoOutGroupTips;
    @BindView(R.id.manager_leader_name)
    EditText managerLeaderName;
    @BindView(R.id.auto_clean_file)
    Spinner autoCleanFile;
    @BindView(R.id.tile4_layout)
    LinearLayout tile4Layout;
    @BindView(R.id.out_group_1)
    RadioButton outGroup1;
    @BindView(R.id.out_group_2)
    RadioButton outGroup2;
    @BindView(R.id.out_group_model)
    RadioGroup outGroupModel;
    @BindView(R.id.read_time_add_group)
    CheckBox readTimeAddGroup;
    private boolean serviceON;
    public static Activity activity;
    private Intent intent;
    private FloatingWindowService myService;
    public FloatingWindowService.Work work;
    private NetworkReceiver netWorkReceiver;
    public static final int REQUEST_CODE = 100;
    private CommitDialog commitDialog;
    private String[] spinners = new String[]{"所属群主共有客服数量(默认1人)", "1人", "2人", "3人", "4人", "5人", "6人", "7人", "8人", "9人", "10人", "11人", "12人", "13人", "14人", "15人", "16人", "17人", "18人", "19人", "20人"};
    private String[] fileSaves = new String[]{"1天", "3天", "7天", "15天", "1个月"};

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);
        String deviceid = SystemUtils.getDeviceId(this);
        EventBus.getDefault().register(this);
        WeworkController.mainActivity = this;
        activity = this;
        deviceIdTv.setText(deviceid);
        String[] split = Build.FINGERPRINT.split("/");
//        DeviceInfoUtils.getTencentVersion(this);
        systemVersion.setText("系统版本: " + split[4].replace(".TCVCNXM:user", ""));
//        tencentVersion.setText("企业微信版本: "+);
        tvVersion.setText("群发工具版本: " + getAppVersionName(this));
        initSpinner();
        //设置手机息屏休眠时间为指定时间
        String user_use = SPUtils.getInstance().getString("user_use");
        String manager_leader_name = SPUtils.getInstance().getString("manager_leader_name");
        boolean group_send = SPUtils.getInstance().getBoolean("group_send", true);
        boolean friend_send = SPUtils.getInstance().getBoolean("friend_send", true);
        boolean invite = SPUtils.getInstance().getBoolean("invite", true);
        boolean share_client = SPUtils.getInstance().getBoolean("share_client", false);
        boolean add_share_client = SPUtils.getInstance().getBoolean("add_share_client", false);
        boolean one_way_firend = SPUtils.getInstance().getBoolean("one_way_firend", false);
        boolean read_time_add_group = SPUtils.getInstance().getBoolean("read_time_add_group", false);
        int seek_bar = SPUtils.getInstance().getInt("seek_bar", 10);
        int client_stemp = SPUtils.getInstance().getInt("client_stemp", 1);
        int identityId = SPUtils.getInstance().getInt("identityId", R.id.radio_2);
        int out_group_model = SPUtils.getInstance().getInt("out_group_model", 2);
        int auto_clean_log_file = SPUtils.getInstance().getInt("auto_clean_log_file", 1);
        boolean auto_out_group = SPUtils.getInstance().getBoolean("auto_out_group", false);
        if (identityId == R.id.radio_1) {//我是群主
            radio1.setChecked(true);
            clientNumberLayout.setVisibility(View.GONE);
            autoOutGroupLayout.setVisibility(View.GONE);
            managerLeaderName.setVisibility(View.GONE);
            autoOutGroupTips.setVisibility(View.GONE);
            outGroupModel.setVisibility(View.GONE);
        }
        if (identityId == R.id.radio_2) {//我是客服
            radio2.setChecked(true);
            clientNumberLayout.setVisibility(View.VISIBLE);
            autoOutGroupLayout.setVisibility(View.VISIBLE);
            managerLeaderName.setVisibility(View.VISIBLE);
            outGroupModel.setVisibility(View.VISIBLE);
            if (auto_out_group) {
                autoOutGroupTips.setVisibility(View.VISIBLE);
            } else {
                autoOutGroupTips.setVisibility(View.GONE);
            }
        }
        LogUtil.e("补拉类型：" + out_group_model);
        if (out_group_model == 1) {
            outGroup1.setChecked(true);
        }
        if (out_group_model == 2) {
            outGroup2.setChecked(true);
        }
        autoCleanFile.setSelection(auto_clean_log_file);
        managerLeaderName.setText(manager_leader_name);
        userInput.setText(user_use);
        clientNumber.setSelection(client_stemp);
        groupSendCheck.setChecked(group_send);
        friendSendCheck.setChecked(friend_send);
        inviteCheck.setChecked(invite);
        shareClientCheck.setChecked(share_client);
        addShareClientCheck.setChecked(add_share_client);
        oneWayFirendCheck.setChecked(one_way_firend);
        readTimeAddGroup.setChecked(read_time_add_group);
        seekBar.setProgress(seek_bar);
        autoOutGroupSwitch.setChecked(auto_out_group);
        waitTime.setText("3.群发切换主体时等待的时长: " + seek_bar + "s");
        if (invite) {
            identityLayout.setVisibility(View.VISIBLE);
        } else {
            identityLayout.setVisibility(View.GONE);
        }
        readTimeAddGroup.setOnClickListener((View v) -> {
            if (readTimeAddGroup.isChecked()) {
                readTimeAddGroup.setChecked(false);
                showRealTimeDialog();
            }
        });
        inviteCheck.setOnCheckedChangeListener(((buttonView, isChecked) -> {
            if (isChecked) {
                identityLayout.setVisibility(View.VISIBLE);
                if (auto_out_group) {
                    autoOutGroupTips.setVisibility(View.VISIBLE);
                } else {
                    autoOutGroupTips.setVisibility(View.GONE);
                }
            } else {
                identityLayout.setVisibility(View.GONE);
            }
        }));
        identityGroup.setOnCheckedChangeListener((group, checkedId) -> {
            SPUtils.getInstance().put("identityId", checkedId);
            if (checkedId == R.id.radio_1) {//我是群主
                clientNumberLayout.setVisibility(View.GONE);
                autoOutGroupLayout.setVisibility(View.GONE);
                autoOutGroupTips.setVisibility(View.GONE);
                managerLeaderName.setVisibility(View.GONE);
                outGroupModel.setVisibility(View.GONE);
            }
            if (checkedId == R.id.radio_2) {//我是客服
                clientNumberLayout.setVisibility(View.VISIBLE);
                autoOutGroupLayout.setVisibility(View.VISIBLE);
                managerLeaderName.setVisibility(View.VISIBLE);
                outGroupModel.setVisibility(View.VISIBLE);
                if (autoOutGroupSwitch.isChecked()) {
                    autoOutGroupTips.setVisibility(View.VISIBLE);
                } else {
                    autoOutGroupTips.setVisibility(View.GONE);
                }
            }
        });
        outGroupModel.setOnCheckedChangeListener((RadioGroup group, int checkedId) -> {
            int model = 0;
            if (checkedId == R.id.out_group_1) {//我是群主
                model = 1;
            }
            if (checkedId == R.id.out_group_2) {//我是客服
                model = 2;
            }
            LogUtil.e("补拉类型：" + model);
            SPUtils.getInstance().put("out_group_model", model);
        });
        autoOutGroupSwitch.setOnCheckedChangeListener((buttonView, isChecked) -> {
            SPUtils.getInstance().put("auto_out_group", isChecked);
            if (isChecked) {
                autoOutGroupTips.setVisibility(View.VISIBLE);
            } else {
                autoOutGroupTips.setVisibility(View.GONE);
            }
        });
        AutoUpdater.getInstance(this).setRedDot(redDot);
        registerNetWorkReceiver();
        //app状态改为正常
        AppStatusManager.getInstance().setAppStatus(AppStatusConstant.STATUS_NORMAL);
        if (intent == null) {
            intent = new Intent(this, SingASongService.class);
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {//8.0后才支持
                startForegroundService(intent);
                LogUtil.e("开启前台服务！！");
            } else {
                startService(intent);
                LogUtil.e("开启普通服务！！");
            }
        }
        seekBar.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                waitTime.setText("3.群发切换主体时等待的时长: " + progress + "s");
                SPUtils.getInstance().put("seek_bar", progress);
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {

            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });
        new NetWorkListenerUtils(this, mHnadler).startShowNetSpeed();
        startbtn();
        setAlarmManager();
    }

    @SuppressLint("HandlerLeak")
    private Handler mHnadler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 100:
//                    tv_speed.setText("当前网速： " + msg.obj.toString());
                    netWorkStatus.setText("网速：" + msg.obj.toString());
                    StringUtils.setMessageData(msg.obj.toString(), 50, 0);
                    break;
            }
            super.handleMessage(msg);
        }
    };

    @Subscribe(threadMode = ThreadMode.MAIN)
    public void mainEvent(MainBean mainBean) {
//        LogUtil.e("event bus: " + mainBean.startAnim);
        if (mainBean.startAnim) {
            if (work != null) {
                work.startWork();
            }
        } else {
            if (work != null) {
                work.stopWork();
            }
        }
    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    public void mainEvent(MainNetStateBean netStateBean) {
        LogUtil.e("网络连接状态: " + netStateBean.isConnected());
    }

    @Override
    protected void onResume() {
        super.onResume();
        String all = MemoruyUtils.getInternalStorageSize(this);
        String free = MemoruyUtils.getFreeSpace(this);
        diskSpace.setText("磁盘：可用" + free + "/共" + all);
        memoryState.setText("内存:" + MemoruyUtils.memoryUsageRate(this) + "%");
        serviceON = AsUtils.isServiceON(this, MyAccessibilityService.class.getName());
        tvStatus.setText("服务是否开启：" + serviceON);
        AutoUpdater.getInstance(this).CheckUpdate(true);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
        if (intent != null) {
            stopService(intent);
        }
        if (bindService && serviceConnection != null) {
            unbindService(serviceConnection);
        }
        if (netWorkReceiver != null) {
            unregisterReceiver(netWorkReceiver);
        }
        stopService(new Intent(MainActivity.this, FloatingWindowService.class));
    }

    private void registerNetWorkReceiver() {
        //注册网络状态监听广播
        netWorkReceiver = new NetworkReceiver();
        IntentFilter filter = new IntentFilter();
        filter.addAction(ConnectivityManager.CONNECTIVITY_ACTION);
        registerReceiver(netWorkReceiver, filter);
    }

    private void initSpinner() {
        ArrayAdapter<String> arrayAdapter = new ArrayAdapter<String>(this, R.layout.spinner_item, spinners);
        clientNumber.setAdapter(arrayAdapter);
        ArrayAdapter<String> logFileAdapter = new ArrayAdapter<String>(this, R.layout.spinner_item, fileSaves);
        autoCleanFile.setAdapter(logFileAdapter);
        autoCleanFile.setSelection(1);
        autoCleanFile.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                SPUtils.getInstance().put("auto_clean_log_file", position);
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {

            }
        });
    }

    @SuppressLint({"NewApi", "WrongConstant"})
    @OnClick({R.id.reset, R.id.btn_start_service, R.id.copy_device_id, R.id.return_home, R.id.user_detail, R.id.log_cat, R.id.sys_setting, R.id.clear_memory, R.id.check_update, R.id.his_apk})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.reset:
                closebtn();
                LogUtil.e("点击了 退出程序");
                Process.killProcess(Process.myPid());
                break;
            case R.id.return_home:
                LogUtil.e("点击了 返回桌面并执行任务");
                SPUtils.getInstance().put("group_send", groupSendCheck.isChecked());
                SPUtils.getInstance().put("friend_send", friendSendCheck.isChecked());
                SPUtils.getInstance().put("invite", inviteCheck.isChecked());
                SPUtils.getInstance().put("share_client", shareClientCheck.isChecked());
                SPUtils.getInstance().put("add_share_client", addShareClientCheck.isChecked());
                SPUtils.getInstance().put("client_stemp", clientNumber.getSelectedItemPosition());
                SPUtils.getInstance().put("user_use", userInput.getText().toString());
                SPUtils.getInstance().put("manager_leader_name", managerLeaderName.getText().toString());
                SPUtils.getInstance().put("read_time_add_group", readTimeAddGroup.isChecked());

                LogUtil.e("群发: " + groupSendCheck.isChecked());
                LogUtil.e("朋友圈: " + friendSendCheck.isChecked());
                LogUtil.e("邀请入群: " + inviteCheck.isChecked());
                LogUtil.e("共享联系人: " + shareClientCheck.isChecked());
                LogUtil.e("添加共享联系人: " + addShareClientCheck.isChecked());
                LogUtil.e("单向好友上传: " + oneWayFirendCheck.isChecked());
                LogUtil.e("所属群主的客服数量: " + clientNumber.getSelectedItemPosition());
                LogUtil.e("实时邀请入群: " + readTimeAddGroup.isChecked());
                if (TextUtils.isEmpty(userInput.getText().toString())) {
                    Toast.makeText(this, "请输入本机使用的客服名称", Toast.LENGTH_SHORT).show();
                    break;
                }
                int identityId = SPUtils.getInstance().getInt("identityId", R.id.radio_2);
                if (identityId == R.id.radio_2) {
                    if (TextUtils.isEmpty(managerLeaderName.getText().toString())) {
                        Toast.makeText(this, "请输入客服找哪个群主建群", Toast.LENGTH_SHORT).show();
                        break;
                    }
                }
                if (groupSendCheck.isChecked() || friendSendCheck.isChecked() || inviteCheck.isChecked()
                        || shareClientCheck.isChecked() || addShareClientCheck.isChecked() || readTimeAddGroup.isChecked()
                ) {
                    LogUtil.e("当前选择的任务为：" + groupSendCheck.isChecked() + "   " + friendSendCheck.isChecked() + "   " + inviteCheck.isChecked() + "   " + shareClientCheck.isChecked() + "   " + addShareClientCheck.isChecked() + "  " + readTimeAddGroup.isChecked());
                    // 获取ActivityManager对象
                    ActivityManager activityManager = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
                    // 获取正在运行的进程列表
                    List<ActivityManager.RunningAppProcessInfo> runningAppProcesses = activityManager.getRunningAppProcesses();
                    // 创建一个适配器
                    ArrayAdapter<String> adapter = new ArrayAdapter<>(this, android.R.layout.simple_list_item_1);
                    // 将进程名称添加到适配器中
                    for (ActivityManager.RunningAppProcessInfo processInfo : runningAppProcesses) {
                        LogUtil.e("进程名称：" + processInfo.processName);
                    }
                    startService();
                } else {
                    Toast.makeText(this, "请选择一项任务", Toast.LENGTH_SHORT).show();
                }
                break;
            case R.id.btn_start_service:
                //开启辅助权限
                LogUtil.e("点击了 开启服务");
                Intent intent = new Intent(Settings.ACTION_ACCESSIBILITY_SETTINGS);
                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(intent);
                break;
            case R.id.copy_device_id:
                LogUtil.e("点击了 复制设备ID");
                //复制信息到粘贴板
                ClipboardManager cm = (ClipboardManager) getSystemService(Context.CLIPBOARD_SERVICE);
                // 创建普通字符型ClipData
                ClipData mClipData = ClipData.newPlainText("Label", deviceIdTv.getText().toString());
                // 将ClipData内容放到系统剪贴板里。
                cm.setPrimaryClip(mClipData);
                Toast.makeText(this, "复制设备ID成功", Toast.LENGTH_SHORT).show();
                clearMemory();
                break;
            case R.id.user_detail:
                Intent intentDetail = new Intent(this, UserDetailActivity.class);
                startActivity(intentDetail);
                break;
            case R.id.log_cat:
                showUploadDialog();
                break;
            case R.id.sys_setting:
                // 创建Intent对象，指定Action为ACTION_GET_CONTENT
                Intent settingIntent = new Intent(Settings.ACTION_SETTINGS);
                startActivity(settingIntent);
                break;
            case R.id.clear_memory:
                MemoruyUtils.clearMemory(this);
                SystemClock.sleep(1000);
                memoryState.setText("内存:" + MemoruyUtils.memoryUsageRate(this) + "%");
                break;
            case R.id.check_update:
                AutoUpdater.getInstance(this).CheckUpdate(false);
                break;
            case R.id.his_apk:
                Intent intent1 = new Intent(this, HisApkListActivity.class);
                startActivity(intent1);
                break;
        }
    }


    private void startService() {
        if (serviceON) {
            /**
             * @auth lkj
             * @Date 2023/5/29 15:13
             * @Describe 当服务开启 并且回到App界面时通知服务器开启定时器
             */
            EventBus.getDefault().post(new EventNotifyBean());
            LogUtil.e("onResume");
            /**
             * @auth lkj
             * @Date 2023/5/26 14:42
             * @Describe 实现home键的功能 而不是直接退出App
             */
            moveTaskToBack(true);
        } else {
            Toast.makeText(this, "请开启无障碍功能！", Toast.LENGTH_SHORT).show();
        }
    }

    /**
     * @auth lkj
     * @Date 2023/6/9 16:52
     * @Describe 获取App版本号
     */
    private String getAppVersionName(Context context) {
        String versionName = "";
        try {
            PackageManager pm = context.getPackageManager();
            PackageInfo pi = pm.getPackageInfo(context.getPackageName(), 0);
            versionName = pi.versionName;
            if (versionName == null || versionName.length() <= 0) {
                return "";
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return versionName;
    }

    private boolean bindService;

    @SuppressLint("NewApi")
    public void startbtn() {
        if (FloatingWindowService.isStarted) {
            LogUtil.e("到此为止！！");
            return;
        }
        if (!Settings.canDrawOverlays(this)) {
            LogUtil.e("请求权限！！");
            Toast.makeText(this, "当前无权限，请授权", Toast.LENGTH_SHORT).show();
            Intent intent = new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION, Uri.parse("package:" + getApplicationContext().getPackageName()));
            intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            startActivityForResult(intent, 2);
            return;
        } else {
            LogUtil.e("开启服务！！");
            Intent intent1 = new Intent(MainActivity.this, FloatingWindowService.class);
            bindService = bindService(intent1, serviceConnection, Context.BIND_AUTO_CREATE);
        }
    }

    private void showRealTimeDialog() {
        //加一个实名认证的提示弹框
        TipsDialog dialog = new TipsDialog(this);
        dialog.setTipsMsg("实时邀请入群任务执行频率较高，建议该设备仅执行这一个任务，是否取消其他任务的执行？");
        dialog.setConfirmButton("不取消", "取消其他任务", R.color.red);
        dialog.setButtonClick(new TipsDialog.ButtonClick() {
            @Override
            public void buttonClick(boolean confirm) {
                readTimeAddGroup.setChecked(true);
                if (confirm) {
                    groupSendCheck.setChecked(false);
                    inviteCheck.setChecked(false);
                    friendSendCheck.setChecked(false);
                    shareClientCheck.setChecked(false);
                    addShareClientCheck.setChecked(false);
                    oneWayFirendCheck.setChecked(false);
                }
            }
        });
        dialog.show();
    }

    public void closebtn() {
        if (intent != null) {
            stopService(intent);
        }
        if (bindService && serviceConnection != null) {
            unbindService(serviceConnection);
        }
        stopService(new Intent(MainActivity.this, FloatingWindowService.class));
    }

    @SuppressLint("NewApi")
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        LogUtil.e("requestCode: " + requestCode + "  resultCode: " + resultCode + "  data: ");
        if (requestCode == 0) {
            if (!Settings.canDrawOverlays(this)) {
                Toast.makeText(this, "授权失败", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(this, "授权成功", Toast.LENGTH_SHORT).show();
                startService(new Intent(MainActivity.this, FloatingWindowService.class));
                bindService = bindService(intent, serviceConnection, Context.BIND_AUTO_CREATE);
            }
        } else if (requestCode == 1) {
            if (!Settings.canDrawOverlays(this)) {
                Toast.makeText(this, "授权失败", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(this, "授权成功", Toast.LENGTH_SHORT).show();
                startService(new Intent(MainActivity.this, FloatingWindowService.class));
                bindService = bindService(intent, serviceConnection, Context.BIND_AUTO_CREATE);
            }
        } else if (requestCode == 2) {
            if (!Settings.canDrawOverlays(this)) {
                Toast.makeText(this, "授权失败", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(this, "授权成功", Toast.LENGTH_SHORT).show();
                startService(new Intent(MainActivity.this, FloatingWindowService.class));
                bindService = bindService(intent, serviceConnection, Context.BIND_AUTO_CREATE);
            }
        } else if (requestCode == REQUEST_CODE) {
            if (data != null) {
                // 获取选择的文件夹的Uri
                Uri uri = data.getData();
                // 进行文件夹的相关处理
                LogUtil.e("选择的文件夹Uri：" + uri.getPath());
                if (commitDialog != null) {
                    commitDialog.setContent(uri);
                }
            }
        } else if (requestCode == INSTALL_APK_REQUEST_CODE) {
            if (data != null) {
                PackageManager pm = getPackageManager();
                //pm.canRequestPackageInstalls() 返回用户是否授予了安装apk的权限
                if (pm.canRequestPackageInstalls()) {
                    LogUtil.e("授予安装apk的权限了，可以检查安装");
                    AutoUpdater.getInstance(this).CheckUpdate(false);
                } else {
                    LogUtil.e("未授予安装apk的权限");
                }
            }
        }
    }

    private void showUploadDialog() {
        commitDialog = new CommitDialog(this, new CommitDialog.OnClickListener() {
            @Override
            public void onConfirm() {

            }
        });
//        commitDialog.setContent(uri.getPath());
        commitDialog.show();
    }

    private ServiceConnection serviceConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName componentName, IBinder iBinder) {
            //获取绑定binder 强制转化为MyService.Work
            work = (FloatingWindowService.Work) iBinder;
            myService = work.getMyService();
        }

        @Override
        public void onServiceDisconnected(ComponentName componentName) {
        }
    };

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (requestCode == PermissionUtils.PERMISSION_REQUEST_CODE) {
            //用户点击了“确定” == grantResults[0] == PackageManager.PERMISSION_GRANTED)
            if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                LogUtil.e("点击了 授予 系统设置权限");
                Settings.System.putInt(getContentResolver(), Settings.System.SCREEN_OFF_TIMEOUT, 15 * 1000);
            } else {
                LogUtil.e("未授予 系统设置权限！！");
                // TODO 用户拒绝权限申请，则弹出警示框
                PermissionUtils.showWaringDialog(MainActivity.this);
            }
        }
    }

    private void clearMemory() {
        ActivityManager am = (ActivityManager) getSystemService(Context.ACTIVITY_SERVICE);
        List<ActivityManager.RunningAppProcessInfo> infoList = am.getRunningAppProcesses();
        List<ActivityManager.RunningServiceInfo> serviceInfos = am.getRunningServices(100);

//        long beforeMem = getAvailMemory(this);
//        LogUtil.e( "-----------before memory info : " + beforeMem);
        int count = 0;
        if (infoList != null) {
            for (int i = 0; i < infoList.size(); ++i) {
                ActivityManager.RunningAppProcessInfo appProcessInfo = infoList.get(i);
                LogUtil.e("process name : " + appProcessInfo.processName);
                //importance 该进程的重要程度  分为几个级别，数值越低就越重要。  
                LogUtil.e("importance : " + appProcessInfo.importance);

                // 一般数值大于RunningAppProcessInfo.IMPORTANCE_SERVICE的进程都长时间没用或者空进程了  
                // 一般数值大于RunningAppProcessInfo.IMPORTANCE_VISIBLE的进程都是非可见进程，也就是在后台运行着  
                if (appProcessInfo.importance > ActivityManager.RunningAppProcessInfo.IMPORTANCE_VISIBLE) {
                    String[] pkgList = appProcessInfo.pkgList;
                    for (int j = 0; j < pkgList.length; ++j) {//pkgList 得到该进程下运行的包名  
                        LogUtil.e("It will be killed, package name : " + pkgList[j]);
                        am.killBackgroundProcesses(pkgList[j]);
                        count++;
                    }
                }

            }
        }
    }

    /**
     * @author lkj
     * @date 2024/4/19 14:05
     * @desc 自动清理过期文件
     */
    private void setAlarmManager() {
        // 在Activity或其他组件中设置闹钟
        Intent intent = new Intent(this, FileCleanupReceiver.class);
        PendingIntent alarmIntent = PendingIntent.getBroadcast(this, 0, intent, 0);
        long firstMillis = SystemClock.elapsedRealtime();
        long intervalMillis = AlarmManager.INTERVAL_DAY * 1; // 1天
//        long intervalMillis = 1000 * 10;
        AlarmManager alarmManager = (AlarmManager) getSystemService(Context.ALARM_SERVICE);
        alarmManager.setInexactRepeating(AlarmManager.ELAPSED_REALTIME_WAKEUP, firstMillis, intervalMillis, alarmIntent);
        LogUtil.e("已开启自动清理功能！！");
    }


}
/**
 * 猎豆安卓app
 * 1.增加上月分佣排行榜
 * 猎悟、消耗表、模拟点击工具
 * 1.模拟点击工具：1）增加手机版本号和企微版本号控制；2）手机内存、磁盘和网络监测，出现异常报警
 * 2.日常维护
 *
 * @author lkj
 * @date 2024/2/20 14:10
 * @desc 模拟点击：处理春节假期群发率低的问题 2-20
 * 模拟点击:  增加手机版本号和企微版本号控制 2-21
 * 模拟点击:  增加一键进入日志文件夹中、手机系统设置实现一键跳转 2-22
 * 模拟点击： 手机内存、磁盘和网络监测，出现异常报警 2-23
 * 猎豆优选： 上月分佣排行榜开发 2-26 ~ 2-29
 * 模拟点击： 日志文件一建上传功能 包含打开文件管理器 批量选择文件(无法批量选择)
 * 模拟点击： APP检查更新 一键下载安装 旧版下载不安装
 */
