package com.kuxuan.autoclick.utils;

import android.text.TextUtils;

import com.kuxuan.autoclick.model.Constant;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Name: 吴庆森
 * Date: 2019/10/23
 * <p>
 * Describe:存储日志
 */

public class LogFileUtils {

    private static Object obj = new Object();

    //文件名称
    private static String fileName = "Log日志" + ".log";

    //文件路径
    private static String filePath = "/storage/emulated/0/Android/media/com.kuxuan.autoclick/Log日志/";
    //    https://blog.51cto.com/u_15639793/5297215
    private static SimpleDateFormat dateFormat = new SimpleDateFormat("MM-dd");
    private static SimpleDateFormat s = new SimpleDateFormat("MM-dd HH:mm:ss");

    /**
     * 写入文件
     *
     * @param msg
     */
//    /storage/emulated/0/Log日志/operationLog-Log日志.log
    public static void writeLogFile(String msg) {
        synchronized (obj) {
            try {
                String date = dateFormat.format(new Date());
                createFile();
                FileWriter fw = null;
                File file = null;
                file = new File(filePath + date + "-" + fileName);
                String user_use = SPUtils.getInstance().getString("user_use");
                if (TextUtils.isEmpty(user_use)) {
                    if (file.exists()) {
                        fw = new FileWriter(file, true);
                    } else {
                        fw = new FileWriter(file, false);
                    }
                } else {
                    String newPath = filePath + date + "-" + user_use + "-" + fileName;
                    File newFile = new File(newPath);
                    if (newFile.exists()) {
                        fw = new FileWriter(newFile, true);
                    } else {
                        boolean isReNameed = file.renameTo(newFile);
                        if (isReNameed) {
                            file.delete();
                        }
                        System.out.print("修改文件名：" + isReNameed);
                        fw = new FileWriter(newFile, true);
                    }
                }
                Date d = new Date();
                String dateStr = s.format(d);
                fw.write(String.format("[%s] %s", dateStr, msg));
                fw.write(13);
                fw.write(10);
                fw.flush();
                fw.close();
            } catch (Throwable ex) {
                ex.printStackTrace();
            }
        }
    }

    /**
     * 取出文件
     *
     * @return
     */
    public static String readLogText() {
        FileReader fr = null;
        try {
            File file = new File(filePath + fileName);
            if (!file.exists()) {
                return "";
            }
            long n = LogVariateUtils.getInstance().getFileSize();
            long len = file.length();
            long skip = len - n;
            fr = new FileReader(file);
            fr.skip(Math.max(0, skip));
            char[] cs = new char[(int) Math.min(len, n)];
            fr.read(cs);
            return new String(cs).trim();
        } catch (Throwable ex) {
            ex.printStackTrace();
        } finally {
            try {
                if (fr != null) {
                    fr.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return "";
    }

    //创建文件夹
    public static void createFile() {
        File file = new File(filePath);
        if (!file.exists()) {
            file.mkdir();
        }
    }
}