package com.kuxuan.autoclick.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author lkj
 * @date 2024/4/8 14:07
 * @desc 模糊匹配工具类
 */
public class MatchUtils {

    /**
     * @author lkj
     * @date 2024/4/8 14:07
     * @desc 模糊匹配 只知道开头和结尾 不知道中间的文字
     */
    public static boolean isMatch(String input, String startPattern, String endPattern) {
        // 构建正则表达式
        String regex = "^" + Pattern.quote(startPattern) + ".*?" + Pattern.quote(endPattern) + "$";
        // 编译正则表达式
        Pattern pattern = Pattern.compile(regex);
        // 匹配输入字符串
        Matcher matcher = pattern.matcher(input);
        // 返回是否匹配的结果
        return matcher.matches();
    }
}
