package com.kuxuan.autoclick.utils;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.pm.PackageManager;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;

/**
 * @author lkj
 * @date 2024/2/20 11:03
 * @desc
 */
public class PermissionUtils {
    public static final int PERMISSION_REQUEST_CODE = 999;

    public static boolean requestPermission(Activity activity) {
        // checkSelfPermission() 检测权限
        if (ContextCompat.checkSelfPermission(activity, Manifest.permission.WRITE_SETTINGS) != PackageManager.PERMISSION_GRANTED) {
            //TODO 申请系统设置权限
            ActivityCompat.requestPermissions(activity, new String[]{Manifest.permission.WRITE_SETTINGS}, PERMISSION_REQUEST_CODE);
            return false;
        }
        return true;
    }//TODO 处理权限结果回调

    /*** 用户拒绝权限的警示*/
    public static void showWaringDialog(Activity activity) {
        new AlertDialog.Builder(activity).setTitle("警告！").setMessage("用户未授予系统设置权限").setPositiveButton("确定", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                //TODO 一般情况下如果用户不授权的话，功能时无法运行的，则直接退出
                activity.finish();
            }
        }).show();
    }
}
