package com.kuxuan.autoclick.utils;

import com.kuxuan.autoclick.model.Constant;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @auth lkj
 * @Date 2023/5/26 17:02
 * @Describe 给字符串排序
 */
public class StringSort {

    public static String sortKey(Map<String, Object> map) {
        List<String> keyList = new ArrayList<>();
        for (String key : map.keySet()) {
            keyList.add(key);
        }
        List<String> list = listSort(keyList);
        StringBuilder builder = new StringBuilder();
        for (String key : list) {
            Object value = map.get(key);
            builder.append(key + "=" + value);
        }
        String encrypt = MD5Util.encrypt(builder.toString());
        String encrypt1 = MD5Util.encrypt(encrypt + Constant.SOLT);
        LogUtil.e("\n"
                + "组合前：" + builder.toString() + "\n"
                + "组合中：" + encrypt + " " + Constant.SOLT + "\n"
                + "组合后：" + encrypt1);
        return encrypt1;
    }

    /**
     * @auth lkj
     * @Date 2023/5/26 17:19
     * @Describe 字符串内进行排序
     */
    public static String sortString(String s) {
        byte[] bys = s.getBytes();//将字符串转化为字节数组
        //排序
        Arrays.sort(bys);
        //char[] toCharArray()： 将字符串转化为字符数组。
        return new String(bys);
    }

    /**
     * 调用此方法
     *
     * @param list
     * @return
     */
    public static List<String> listSort(List<String> list) {
        String[] array = (String[]) list.toArray(new String[list.size()]);
        for (int i = 0; i < array.length - 1; i++) {
            for (int j = i + 1; j < array.length; j++) {
                if (singleSort(array[i], array[j]) == 1) {
                    String temp = array[i];
                    array[i] = array[j];
                    array[j] = temp;
                }
            }
        }
        return Arrays.asList(array);
    }

    /**
     * 比较两个字符
     *
     * @param one
     * @param two
     * @return
     */
    public static int singleSort(String one, String two) {
        int[] left = stringToAscii(one);
        int[] right = stringToAscii(two);
        int size = left.length < right.length ? left.length : right.length;
        for (int i = 0; i < size; i++) {
            // 大于10000说明是汉字 并且在判断一下是否相等 不相等在判断 减少判断次数
            if (left[i] > 10000 && right[i] > 10000 && left[i] != right[i]) {
                if (chineseCompare(one, two, i) != 0) {
                    return chineseCompare(one, two, i);
                }
            } else {
                if (intCompare(left[i], right[i]) != 0) {
                    return intCompare(left[i], right[i]);
                }
            }
        }
        return intCompare(left.length, right.length);
    }

    /**
     * 汉字比较
     *
     * @param one
     * @param two
     * @param i
     * @return
     */
    private static int chineseCompare(String one, String two, int i) {
        String substringleft;
        String substringright;
        if (i > 0) {
            substringleft = one.substring(i - 1, i);
            substringright = two.substring(i - 1, i);
        } else {
            substringleft = one.substring(0, i);
            substringright = two.substring(0, i);
        }
        // 获得汉字拼音首字母的ASCII码
        // 把他里面的CharacterParser.convert方法 改成 public static 不然会报错
        int subLeft = stringToAscii(CharacterParser.convert(substringleft)
                .substring(0, 1))[0];
        int subRight = stringToAscii(CharacterParser.convert(substringright)
                .substring(0, 1))[0];
        System.out.println(CharacterParser.convert(substringleft).substring(0,
                1));
        return intCompare(subLeft, subRight);
    }

    /**
     * 数字比较
     *
     * @param subLeft
     * @param subRight
     * @return
     */
    private static int intCompare(int subLeft, int subRight) {
        if (subLeft > subRight) {
            return 1;
        } else if (subLeft < subRight) {
            return -1;
        } else {
            return 0;
        }
    }

    /**
     * 获得ASCII码
     *
     * @param value
     * @return
     */
    public static int[] stringToAscii(String value) {
        char[] chars = value.toCharArray();
        int j = chars.length;
        int[] array = new int[j];
        for (int i = 0; i < chars.length; i++) {
            array[i] = (int) chars[i];
        }
        return array;
    }
}