package com.kuxuan.autoclick.utils;

import android.content.Context;

import com.kuxuan.autoclick.service.WeworkController;

import java.io.IOException;
import java.io.InputStream;

/**
 * @Auth lkj
 * @Date 2023/6/2 10:11
 * @Describe 字符串操作工具类
 */
public class StringUtils {
    /**
     * @auth lkj
     * @Date 2023/6/2 10:12
     * @Describe 字符串分割 取出字符串括号中的数字
     */
    public static int getNumber(String string) {
        if (string == null || "".equals(string)) {
            throw new RuntimeException("字符串不能为空");
        }
        if (string.contains("(") && string.contains(")")) {
            String targetStr = string.substring(string.indexOf("(") + 1, string.indexOf(")"));
            Integer value = Integer.valueOf(targetStr);
            return value;
        } else {
            return 0;
        }
    }

    /**
     * @auth lkj
     * @Date 2023/6/19 10:59
     * @Describe 字符串分割 取出“.”后面的数字
     */
    public static int getPointLaterNumber(String string) {
        if (string == null || "".equals(string)) {
            throw new RuntimeException("字符串不能为空");
        }
        String[] split = string.split("·");
        LogUtil.e("split: " + split[0]);
        if (split.length >= 2) {
            Integer value = Integer.valueOf(split[split.length - 1]);
            return value;
        } else {
            return 0;
        }
    }

    public static void setMessageData(String msg, int what, int arg1) {
//        LogUtil.e("传达消息：" + msg + " " + what + " " + arg1);
        if (WeworkController.mainActivity != null && WeworkController.mainActivity.work != null) {
            WeworkController.mainActivity.work.setData(msg, what, arg1);
        }
    }

    /**
     * @author lkj
     * @date 2024/4/8 15:11
     * @desc 字符串分割 把数字取出来
     */
    public static int getNumber1(String string) {
        if (string == null || "".equals(string)) {
            throw new RuntimeException("字符串不能为空");
        }
        String[] splits = string.split("人");
        LogUtil.e("分割出来的文字：" + splits[0]);
        return Integer.valueOf(splits[0]);
    }

    public static String readAssetsString(Context context) {
        try {
            // 获取assets目录下的文本文件的InputStream对象
            InputStream inputStream = context.getAssets().open("json.txt");
            // 创建一个字节数组用于存储文本文件的内容
            byte[] buffer = new byte[inputStream.available()];
            // 将文本文件的内容读取到字节数组中
            inputStream.read(buffer);

            // 关闭InputStream对象
            inputStream.close();

            // 将字节数组转换为字符串
            String text = new String(buffer, "UTF-8");
            return text;
            // 处理文本内容
            // ...
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }
}
