package com.kuxuan.autoclick.view;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.kuxuan.autoclick.R;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * @Auth lkj
 * @Date 2023/7/4 10:32
 * @Describe 自定义 提示对话框 只包含提示信息和 确定 取消 按钮
 */
public class TipsDialog extends Dialog {

    @BindView(R.id.tips_message)
    TextView tipsMessage;
    @BindView(R.id.cancel_button)
    Button cancelButton;
    @BindView(R.id.confirm_button)
    Button confirmButton;

    private String tipsMsg;
    private ButtonClick buttonClick;
    private Context context;
    private String cancleText;
    private String canFirmText;
    private int color;

    public TipsDialog setTipsMsg(String tipsMsg) {
        this.tipsMsg = tipsMsg;
        return this;
    }

    public TipsDialog setButtonClick(ButtonClick buttonClick) {
        this.buttonClick = buttonClick;
        return this;
    }

    public TipsDialog(Context context) {
        super(context);
        this.context = context;
    }

    public TipsDialog(Context context, boolean cancelable, OnCancelListener cancelListener) {
        super(context, cancelable, cancelListener);
    }

    public TipsDialog(Context context, int themeResId) {
        super(context, themeResId);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.dialog_tips);
        ButterKnife.bind(this);

//        WindowManager windowManager = getWindow().getWindowManager();
//        Display display = windowManager.getDefaultDisplay();
//        WindowManager.LayoutParams params = getWindow().getAttributes();
//        Point size = new Point();
//        display.getSize(size);
//        params.width = (int) (size.x * 0.9);
//        getWindow().setAttributes(params);
        getWindow().setBackgroundDrawableResource(android.R.color.transparent);
        setCancelable(false);
        if (!TextUtils.isEmpty(tipsMsg)) {
            tipsMessage.setText(tipsMsg);
        }
        if (!TextUtils.isEmpty(canFirmText)) {
            confirmButton.setText(canFirmText);
            confirmButton.setTextColor(context.getResources().getColor(color));
        }
        if (!TextUtils.isEmpty(cancleText)) {
            cancelButton.setText(cancleText);
        }
    }

    /**
     * @author lkj
     * @date 2024/4/28 11:28
     * @desc 设置button按钮
     */
    public TipsDialog setConfirmButton(String cancleText, String canFirmText, int color) {
        this.cancleText = cancleText;
        this.canFirmText = canFirmText;
        this.color = color;
        return this;
    }

    @OnClick({R.id.cancel_button, R.id.confirm_button})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.cancel_button:
                if (buttonClick != null) {
                    buttonClick.buttonClick(false);
                    dismiss();
                }
                break;
            case R.id.confirm_button:
                if (buttonClick != null) {
                    buttonClick.buttonClick(true);
                    dismiss();
                }
                break;
        }
    }

    public interface ButtonClick {
        void buttonClick(boolean confirm);
    }
}
